import 'dart:async';

import 'package:flutter_test/flutter_test.dart';
import 'package:kameleoon_client_flutter/kameleoon_client_flutter.dart';
import 'constants.dart';

String makeReason(String text) => "\n\n\n" + ERROR_REASON + "\n" + text + "\n \n \n";

Future<void> testAPI(KameleoonClient client, [Function? actionWhenReady]) async {
  final completer = new Completer();

  client.runWhenReady(() async {
    await actionWhenReady?.call();
    completer.complete(COMPLETE_VALID);
  }, () {
    completer.completeError(TIMEOUT_FAIL_ERROR);
  }, Duration(milliseconds: TIMEOUT_MILLISECONDS));

  expect(await completer.future, equals(COMPLETE_VALID), reason: makeReason("runWhenReady Timeout"));
}
