"use strict";
var kameleoon = (() => {
  var __getOwnPropNames = Object.getOwnPropertyNames;
  var __require = /* @__PURE__ */ ((x) => typeof require !== "undefined" ? require : typeof Proxy !== "undefined" ? new Proxy(x, {
    get: (a, b) => (typeof require !== "undefined" ? require : a)[b]
  }) : x)(function(x) {
    if (typeof require !== "undefined")
      return require.apply(this, arguments);
    throw new Error('Dynamic require of "' + x + '" is not supported');
  });
  var __commonJS = (cb, mod) => function __require2() {
    return mod || (0, cb[__getOwnPropNames(cb)[0]])((mod = { exports: {} }).exports, mod), mod.exports;
  };

  // node_modules/ts-res/build/main.js
  var require_main = __commonJS({
    "node_modules/ts-res/build/main.js"(exports) {
      "use strict";
      Object.defineProperty(exports, "__esModule", { value: true });
      exports.Err = exports.Ok = void 0;
      function throwErr(message) {
        if (!this.ok) {
          if (typeof this.error === "string" || typeof this.error === "undefined") {
            const defaultMessage = "There was an error! No specific error message was provided.";
            throw new Error(message || this.error || defaultMessage);
          }
          if (message) {
            this.error.message = message;
          }
          throw this.error;
        }
        return this.data;
      }
      function elseDo(callback) {
        if (this.ok) {
          return this.data;
        }
        return callback(this.error);
      }
      function or(orValue) {
        if (this.ok) {
          return this.data;
        }
        return orValue;
      }
      function and(callback) {
        if (this.ok) {
          callback(this.data);
        }
      }
      function Ok(data) {
        return { ok: true, data, throw: throwErr, else: elseDo, or, and };
      }
      exports.Ok = Ok;
      function Err(error) {
        return { ok: false, error, throw: throwErr, else: elseDo, or, and };
      }
      exports.Err = Err;
    }
  });

  // node_modules/ts-res/build/index.js
  var require_build = __commonJS({
    "node_modules/ts-res/build/index.js"(exports) {
      "use strict";
      Object.defineProperty(exports, "__esModule", { value: true });
      exports.Err = exports.Ok = void 0;
      var main_1 = require_main();
      Object.defineProperty(exports, "Ok", { enumerable: true, get: function() {
        return main_1.Ok;
      } });
      Object.defineProperty(exports, "Err", { enumerable: true, get: function() {
        return main_1.Err;
      } });
    }
  });

  // node_modules/@kameleoon/javascript-sdk-core/dist/types.js
  var require_types = __commonJS({
    "node_modules/@kameleoon/javascript-sdk-core/dist/types.js"(exports) {
      "use strict";
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.VariableType = exports.Milliseconds = exports.Environment = void 0;
      var Environment = /* @__PURE__ */ function(Environment2) {
        Environment2["Production"] = "production";
        Environment2["Staging"] = "staging";
        Environment2["Development"] = "development";
        return Environment2;
      }({});
      exports.Environment = Environment;
      var VariableType = /* @__PURE__ */ function(VariableType2) {
        VariableType2["BOOLEAN"] = "BOOLEAN";
        VariableType2["NUMBER"] = "NUMBER";
        VariableType2["STRING"] = "STRING";
        VariableType2["JSON"] = "JSON";
        return VariableType2;
      }({});
      exports.VariableType = VariableType;
      var Milliseconds = function(Milliseconds2) {
        Milliseconds2[Milliseconds2["Second"] = 1e3] = "Second";
        Milliseconds2[Milliseconds2["Minute"] = 60 * Milliseconds2.Second] = "Minute";
        Milliseconds2[Milliseconds2["Hour"] = 60 * Milliseconds2.Minute] = "Hour";
        return Milliseconds2;
      }({});
      exports.Milliseconds = Milliseconds;
    }
  });

  // node_modules/@kameleoon/javascript-sdk-core/dist/cacheManager/cacheManager.js
  var require_cacheManager = __commonJS({
    "node_modules/@kameleoon/javascript-sdk-core/dist/cacheManager/cacheManager.js"(exports) {
      "use strict";
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.CacheManager = void 0;
      var _types = require_types();
      function _defineProperty(obj, key, value) {
        key = _toPropertyKey(key);
        if (key in obj) {
          Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
        } else {
          obj[key] = value;
        }
        return obj;
      }
      function _toPropertyKey(arg) {
        var key = _toPrimitive(arg, "string");
        return typeof key === "symbol" ? key : String(key);
      }
      function _toPrimitive(input, hint) {
        if (typeof input !== "object" || input === null)
          return input;
        var prim = input[Symbol.toPrimitive];
        if (prim !== void 0) {
          var res = prim.call(input, hint || "default");
          if (typeof res !== "object")
            return res;
          throw new TypeError("@@toPrimitive must return a primitive value.");
        }
        return (hint === "string" ? String : Number)(input);
      }
      var CacheManager = class {
        /**
         * @param {number} cleanupTimeout - timeout for cleaning cache in seconds
         * generic type `T` is a type of data that will be stored in cache
         * @example
         * ```typescript
         * const cacheManager = new CacheManager<number>(60);
         * ```
         */
        constructor(cleanupTimeout) {
          _defineProperty(this, "cacheMap", /* @__PURE__ */ new Map());
          _defineProperty(this, "intervalId", null);
          _defineProperty(this, "cleanupTimeout", void 0);
          this.cleanupTimeout = cleanupTimeout * _types.Milliseconds.Second;
        }
        add({
          key,
          data,
          lifetime
        }) {
          if (this.intervalId === null) {
            this.activate();
          }
          const expirationTime = lifetime * _types.Milliseconds.Second;
          const cacheItem = {
            data,
            expirationTime: Date.now() + expirationTime
          };
          this.cacheMap.set(key, cacheItem);
        }
        getAliveItem(key) {
          const cacheItem = this.cacheMap.get(key);
          if (cacheItem && cacheItem.expirationTime >= Date.now()) {
            return cacheItem.data;
          }
          cacheItem && this.cacheMap.delete(key);
          return null;
        }
        activate() {
          this.intervalId = setInterval(() => {
            const now = Date.now();
            for (const [key, item] of this.cacheMap) {
              if (item.expirationTime < now) {
                this.cacheMap.delete(key);
              }
            }
            if (!this.cacheMap.size) {
              this.cleanupInterval();
            }
          }, this.cleanupTimeout);
        }
        cleanupInterval() {
          if (this.intervalId) {
            clearInterval(this.intervalId);
            this.intervalId = null;
          }
        }
      };
      exports.CacheManager = CacheManager;
    }
  });

  // node_modules/@kameleoon/javascript-sdk-core/dist/cacheManager/types.js
  var require_types2 = __commonJS({
    "node_modules/@kameleoon/javascript-sdk-core/dist/cacheManager/types.js"(exports) {
      "use strict";
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
    }
  });

  // node_modules/@kameleoon/javascript-sdk-core/dist/cacheManager/index.js
  var require_cacheManager2 = __commonJS({
    "node_modules/@kameleoon/javascript-sdk-core/dist/cacheManager/index.js"(exports) {
      "use strict";
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      Object.defineProperty(exports, "AddParametersType", {
        enumerable: true,
        get: function() {
          return _types.AddParametersType;
        }
      });
      Object.defineProperty(exports, "CacheManager", {
        enumerable: true,
        get: function() {
          return _cacheManager.CacheManager;
        }
      });
      var _cacheManager = require_cacheManager();
      var _types = require_types2();
    }
  });

  // node_modules/@kameleoon/javascript-sdk-core/dist/campaignConfiguration/types.js
  var require_types3 = __commonJS({
    "node_modules/@kameleoon/javascript-sdk-core/dist/campaignConfiguration/types.js"(exports) {
      "use strict";
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.RuleType = exports.FeatureStatus = exports.FeatureFlagSdkLanguageType = exports.ExperimentType = exports.ExperimentStatus = void 0;
      var ExperimentType = /* @__PURE__ */ function(ExperimentType2) {
        ExperimentType2["CLASSIC"] = "CLASSIC";
        ExperimentType2["SERVER_SIDE"] = "SERVER_SIDE";
        ExperimentType2["DEVELOPER"] = "DEVELOPER";
        ExperimentType2["MVT"] = "MVT";
        ExperimentType2["HYBRID"] = "HYBRID";
        return ExperimentType2;
      }({});
      exports.ExperimentType = ExperimentType;
      var RuleType = /* @__PURE__ */ function(RuleType2) {
        RuleType2["PROGRESSIVE_DELIVERY"] = "PROGRESSIVE_DELIVERY";
        RuleType2["TARGETED_DELIVERY"] = "TARGETED_DELIVERY";
        RuleType2["EXPERIMENTATION"] = "EXPERIMENTATION";
        return RuleType2;
      }({});
      exports.RuleType = RuleType;
      var FeatureFlagSdkLanguageType = /* @__PURE__ */ function(FeatureFlagSdkLanguageType2) {
        FeatureFlagSdkLanguageType2["ANDROID"] = "ANDROID";
        FeatureFlagSdkLanguageType2["SWIFT"] = "SWIFT";
        FeatureFlagSdkLanguageType2["JAVA"] = "JAVA";
        FeatureFlagSdkLanguageType2["CSHARP"] = "CSHARP";
        FeatureFlagSdkLanguageType2["NODEJS"] = "NODEJS";
        FeatureFlagSdkLanguageType2["PHP"] = "PHP";
        FeatureFlagSdkLanguageType2["RUBY"] = "RUBY";
        FeatureFlagSdkLanguageType2["GO"] = "GO";
        FeatureFlagSdkLanguageType2["FLUTTER"] = "FLUTTER";
        FeatureFlagSdkLanguageType2["REACTJS"] = "REACTJS";
        return FeatureFlagSdkLanguageType2;
      }({});
      exports.FeatureFlagSdkLanguageType = FeatureFlagSdkLanguageType;
      var FeatureStatus = /* @__PURE__ */ function(FeatureStatus2) {
        FeatureStatus2["ACTIVATED"] = "ACTIVATED";
        FeatureStatus2["DEACTIVATED"] = "DEACTIVATED";
        FeatureStatus2["SCHEDULED"] = "SCHEDULED";
        return FeatureStatus2;
      }({});
      exports.FeatureStatus = FeatureStatus;
      var ExperimentStatus = /* @__PURE__ */ function(ExperimentStatus2) {
        ExperimentStatus2["DRAFT"] = "DRAFT";
        ExperimentStatus2["ACTIVE"] = "ACTIVE";
        ExperimentStatus2["PAUSED"] = "PAUSED";
        ExperimentStatus2["SCHEDULED"] = "SCHEDULED";
        ExperimentStatus2["STOPPED"] = "STOPPED";
        ExperimentStatus2["USED_AS_PERSONALIZATION"] = "USED_AS_PERSONALIZATION";
        ExperimentStatus2["DEVIATED"] = "DEVIATED";
        return ExperimentStatus2;
      }({});
      exports.ExperimentStatus = ExperimentStatus;
    }
  });

  // node_modules/@kameleoon/javascript-sdk-core/dist/campaignConfiguration/constants.js
  var require_constants = __commonJS({
    "node_modules/@kameleoon/javascript-sdk-core/dist/campaignConfiguration/constants.js"(exports) {
      "use strict";
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.DEFAULT_CAMPAIGN_CONFIGURATION = exports.CLEANUP_TARGETING_DATA_INTERVAL = void 0;
      var CLEANUP_TARGETING_DATA_INTERVAL = 30;
      exports.CLEANUP_TARGETING_DATA_INTERVAL = CLEANUP_TARGETING_DATA_INTERVAL;
      var DEFAULT_CAMPAIGN_CONFIGURATION = {
        targetingData: {},
        configurationData: {
          experiments: [],
          featureFlags: [],
          configuration: {
            realTimeUpdate: false
          }
        }
      };
      exports.DEFAULT_CAMPAIGN_CONFIGURATION = DEFAULT_CAMPAIGN_CONFIGURATION;
    }
  });

  // node_modules/@kameleoon/javascript-sdk-core/dist/eventSource/types.js
  var require_types4 = __commonJS({
    "node_modules/@kameleoon/javascript-sdk-core/dist/eventSource/types.js"(exports) {
      "use strict";
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
    }
  });

  // node_modules/@kameleoon/javascript-sdk-core/dist/kameleoonError/types.js
  var require_types5 = __commonJS({
    "node_modules/@kameleoon/javascript-sdk-core/dist/kameleoonError/types.js"(exports) {
      "use strict";
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.KameleoonException = void 0;
      var KameleoonException = /* @__PURE__ */ function(KameleoonException2) {
        KameleoonException2["ExperimentConfigurationNotFound"] = "ExperimentConfigurationNotFound";
        KameleoonException2["EventSourceInitialization"] = "EventSourceInitialization";
        KameleoonException2["VariationNotFound"] = "VariationNotFound";
        KameleoonException2["FeatureFlagConfigurationNotFound"] = "FeatureFlagConfigurationNotFound";
        KameleoonException2["FeatureFlagVariableNotFound"] = "FeatureFlagVariableNotFound";
        KameleoonException2["NotTargeted"] = "NotTargeted";
        KameleoonException2["NotAllocated"] = "NotAllocated";
        KameleoonException2["VisitorCodeMaxLength"] = "VisitorCodeMaxLength";
        KameleoonException2["VisitorCodeEmpty"] = "VisitorCodeEmpty";
        KameleoonException2["StorageInitialization"] = "StorageInitialization";
        KameleoonException2["StorageWrite"] = "StorageWrite";
        KameleoonException2["StorageRead"] = "StorageRead";
        KameleoonException2["StorageParse"] = "StorageParse";
        KameleoonException2["ClientConfiguration"] = "ClientConfiguration";
        KameleoonException2["TargetingCondition"] = "TargetingCondition";
        KameleoonException2["AmongValuesCheck"] = "AmongValuesCheck";
        KameleoonException2["Initialization"] = "Initialization";
        KameleoonException2["JSONParse"] = "JSONParse";
        KameleoonException2["NumberParse"] = "NumberParse";
        KameleoonException2["RemoteData"] = "RemoteData";
        KameleoonException2["MaximumRetriesReached"] = "MaximumRetriesReached";
        return KameleoonException2;
      }({});
      exports.KameleoonException = KameleoonException;
    }
  });

  // node_modules/@kameleoon/javascript-sdk-core/dist/kameleoonError/constants.js
  var require_constants2 = __commonJS({
    "node_modules/@kameleoon/javascript-sdk-core/dist/kameleoonError/constants.js"(exports) {
      "use strict";
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.ERROR_MESSAGES = void 0;
      var _types = require_types5();
      var ERROR_MESSAGES = {
        [_types.KameleoonException.JSONParse]: (err) => `Couldn't parse JSON variable: ${err}`,
        [_types.KameleoonException.NumberParse]: (value) => `It's not possible to parse value ${value} to Number`,
        [_types.KameleoonException.Initialization]: () => "It seems that the client wasn't properly initialized, make sure to run `initialize` method before invoking other methods",
        [_types.KameleoonException.StorageInitialization]: () => "There was an error while initializing React Native SDK storage, it seems that the storage library dependency wasn't installed",
        [_types.KameleoonException.EventSourceInitialization]: () => "There was an error while initializing Real Time Update service, it seems that the event source library dependency wasn't installed",
        [_types.KameleoonException.VariationNotFound]: () => "Couldn't find experiment variation",
        [_types.KameleoonException.FeatureFlagConfigurationNotFound]: (featureKey, visitorCode) => `No feature flag with key ${featureKey} was found for ${visitorCode} visitorCode.`,
        [_types.KameleoonException.FeatureFlagVariableNotFound]: (variableKey, visitorCode) => `No feature flag variable with key ${variableKey} was found for ${visitorCode} visitorCode.`,
        [_types.KameleoonException.ExperimentConfigurationNotFound]: (experimentId, visitorCode) => `No experiment with id ${experimentId} was found for ${visitorCode} visitorCode.`,
        [_types.KameleoonException.NotTargeted]: (visitorCode) => `Visitor code ${visitorCode} is not targeted`,
        [_types.KameleoonException.NotAllocated]: (visitorCode) => `Visitor with visitor code ${visitorCode} is in unallocated traffic, there is no variation id to be assigned to the visitor.`,
        [_types.KameleoonException.VisitorCodeMaxLength]: () => "Visitor code can not be more than 255 characters long",
        [_types.KameleoonException.VisitorCodeEmpty]: () => "Visitor code can not be empty",
        [_types.KameleoonException.StorageWrite]: (err) => `Couldn't update storage for kameleoonClient: ${err}`,
        [_types.KameleoonException.StorageRead]: (key) => `No data found in storage under ${key} key`,
        [_types.KameleoonException.StorageParse]: (err, key) => `Couldn't parse ${key} storage data, the data may be corrupted. Error: ${err}`,
        [_types.KameleoonException.ClientConfiguration]: () => "Couldn't retrieve client configuration from Kameleoon Api",
        [_types.KameleoonException.TargetingCondition]: (targetingType) => `${targetingType} targeting condition is not yet supported.`,
        [_types.KameleoonException.AmongValuesCheck]: (err, value) => `Couldn't parse value "${value}": ${err}`,
        [_types.KameleoonException.RemoteData]: () => `Couldn't retrieve data from Kameleoon server`,
        [_types.KameleoonException.MaximumRetriesReached]: () => `Maximum retries reached, request failed`
      };
      exports.ERROR_MESSAGES = ERROR_MESSAGES;
    }
  });

  // node_modules/@kameleoon/javascript-sdk-core/dist/kameleoonError/helpers.js
  var require_helpers = __commonJS({
    "node_modules/@kameleoon/javascript-sdk-core/dist/kameleoonError/helpers.js"(exports) {
      "use strict";
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.exhaustCheck = exhaustCheck;
      function exhaustCheck(option) {
        throw new Error(`Reaching an impossible state because of ${option}`);
      }
    }
  });

  // node_modules/@kameleoon/javascript-sdk-core/dist/kameleoonError/kameleoonError.js
  var require_kameleoonError = __commonJS({
    "node_modules/@kameleoon/javascript-sdk-core/dist/kameleoonError/kameleoonError.js"(exports) {
      "use strict";
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.KameleoonError = void 0;
      var _constants = require_constants2();
      var _helpers = require_helpers();
      var _types = require_types5();
      function _defineProperty(obj, key, value) {
        key = _toPropertyKey(key);
        if (key in obj) {
          Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
        } else {
          obj[key] = value;
        }
        return obj;
      }
      function _toPropertyKey(arg) {
        var key = _toPrimitive(arg, "string");
        return typeof key === "symbol" ? key : String(key);
      }
      function _toPrimitive(input, hint) {
        if (typeof input !== "object" || input === null)
          return input;
        var prim = input[Symbol.toPrimitive];
        if (prim !== void 0) {
          var res = prim.call(input, hint || "default");
          if (typeof res !== "object")
            return res;
          throw new TypeError("@@toPrimitive must return a primitive value.");
        }
        return (hint === "string" ? String : Number)(input);
      }
      var KameleoonError = class extends Error {
        /**
         * @param {KameleoonException} type - type of KameleoonError represented by `KameleoonException` enum
         * */
        constructor(type, secondParam, thirdParam) {
          super(`Error: ${type}`);
          _defineProperty(this, "errorType", void 0);
          this.name = "KameleoonError";
          this.errorType = type;
          switch (type) {
            case _types.KameleoonException.Initialization:
            case _types.KameleoonException.ClientConfiguration:
            case _types.KameleoonException.VisitorCodeMaxLength:
            case _types.KameleoonException.VisitorCodeEmpty:
            case _types.KameleoonException.StorageInitialization:
            case _types.KameleoonException.VariationNotFound:
            case _types.KameleoonException.EventSourceInitialization:
            case _types.KameleoonException.RemoteData:
            case _types.KameleoonException.MaximumRetriesReached:
              this.message = _constants.ERROR_MESSAGES[type]();
              break;
            case _types.KameleoonException.NotAllocated:
            case _types.KameleoonException.NotTargeted:
              this.message = _constants.ERROR_MESSAGES[type](secondParam);
              break;
            case _types.KameleoonException.ExperimentConfigurationNotFound:
              this.message = _constants.ERROR_MESSAGES[type](secondParam, thirdParam);
              break;
            case _types.KameleoonException.FeatureFlagVariableNotFound:
            case _types.KameleoonException.FeatureFlagConfigurationNotFound:
              this.message = _constants.ERROR_MESSAGES[type](secondParam, thirdParam);
              break;
            case _types.KameleoonException.StorageWrite:
            case _types.KameleoonException.JSONParse:
              this.message = _constants.ERROR_MESSAGES[type](secondParam);
              break;
            case _types.KameleoonException.StorageRead:
              this.message = _constants.ERROR_MESSAGES[type](secondParam);
              break;
            case _types.KameleoonException.StorageParse:
              this.message = _constants.ERROR_MESSAGES[type](secondParam, thirdParam);
              break;
            case _types.KameleoonException.TargetingCondition:
              this.message = _constants.ERROR_MESSAGES[type](secondParam);
              break;
            case _types.KameleoonException.NumberParse:
              this.message = _constants.ERROR_MESSAGES[type](secondParam);
              break;
            case _types.KameleoonException.AmongValuesCheck:
              this.message = _constants.ERROR_MESSAGES[type](secondParam, thirdParam);
              break;
            default:
              (0, _helpers.exhaustCheck)(type);
          }
        }
        get type() {
          return this.errorType;
        }
      };
      exports.KameleoonError = KameleoonError;
    }
  });

  // node_modules/@kameleoon/javascript-sdk-core/dist/kameleoonError/index.js
  var require_kameleoonError2 = __commonJS({
    "node_modules/@kameleoon/javascript-sdk-core/dist/kameleoonError/index.js"(exports) {
      "use strict";
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      Object.defineProperty(exports, "KameleoonError", {
        enumerable: true,
        get: function() {
          return _kameleoonError.KameleoonError;
        }
      });
      Object.defineProperty(exports, "KameleoonException", {
        enumerable: true,
        get: function() {
          return _types.KameleoonException;
        }
      });
      Object.defineProperty(exports, "exhaustCheck", {
        enumerable: true,
        get: function() {
          return _helpers.exhaustCheck;
        }
      });
      var _kameleoonError = require_kameleoonError();
      var _types = require_types5();
      var _helpers = require_helpers();
    }
  });

  // node_modules/@kameleoon/javascript-sdk-core/dist/requester/constants.js
  var require_constants3 = __commonJS({
    "node_modules/@kameleoon/javascript-sdk-core/dist/requester/constants.js"(exports) {
      "use strict";
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.UrlTracking = exports.UrlQuery = exports.UrlParameter = exports.UrlEventType = exports.URL = exports.Header = void 0;
      var Header = /* @__PURE__ */ function(Header2) {
        Header2["UserAgent"] = "User-Agent";
        return Header2;
      }({});
      exports.Header = Header;
      var topLevelDomain = false ? "com" : "com";
      var dataTopLevelDomain = false ? "net" : "io";
      var UrlEventType = {
        CustomData: "eventType=customData",
        StaticData: "eventType=staticData",
        Page: "eventType=page",
        Conversion: "eventType=conversion",
        Activity: "eventType=activity",
        Experiment: "eventType=experiment"
      };
      exports.UrlEventType = UrlEventType;
      var UrlParameter = {
        Title: "&title=",
        ReferrersIndices: "&referrersIndices=",
        Negative: "&negative=",
        Revenue: "&revenue=",
        Overwrite: "&overwrite=",
        Index: "&index=",
        BrowserIndex: "&browserIndex=",
        Href: "&href=",
        DeviceType: "&deviceType=",
        SiteCode: "&siteCode=",
        GoalId: "&goalId=",
        VisitorCode: "&visitorCode=",
        Environment: "&environment=",
        VariationId: "&variationId=",
        Ts: "&ts=",
        Key: "&key=",
        SdkName: "&sdkName=",
        SdkVersion: "&sdkVersion=",
        ValuesCountMap: "&valuesCountMap=",
        Nonce: "&nonce=",
        Id: "&id=",
        CustomData: "&customData=",
        CurrentVisit: "&currentVisit=",
        MaxNumberPreviousVisits: "&maxNumberPreviousVisits="
      };
      exports.UrlParameter = UrlParameter;
      var UrlQuery = {
        Sse: "sse?siteCode=",
        Mobile: "mobile?siteCode=",
        Map: "map?siteCode=",
        Events: "events?siteCode=",
        Visitor: "visitor?siteCode="
      };
      exports.UrlQuery = UrlQuery;
      var UrlTracking = {
        Visit: "visit/",
        Map: "map/"
      };
      exports.UrlTracking = UrlTracking;
      var URL_DATA_API = `https://data.kameleoon.${dataTopLevelDomain}`;
      var URL = {
        SERVER_SENT_EVENTS: `https://events.kameleoon.${topLevelDomain}:8110/`,
        CLIENT_CONFIGURATION: `https://client-config.kameleoon.${topLevelDomain}/`,
        VISIT_EVENT: `${URL_DATA_API}/${UrlTracking.Visit + UrlQuery.Events}`,
        VISIT_DATA: `${URL_DATA_API}/${UrlTracking.Visit + UrlQuery.Visitor}`,
        DATA_MAP: `${URL_DATA_API}/${UrlTracking.Map + UrlQuery.Map}`
      };
      exports.URL = URL;
    }
  });

  // node_modules/@kameleoon/javascript-sdk-core/dist/kameleoonData/constants.js
  var require_constants4 = __commonJS({
    "node_modules/@kameleoon/javascript-sdk-core/dist/kameleoonData/constants.js"(exports) {
      "use strict";
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.HEX_CHARACTERS = void 0;
      var HEX_CHARACTERS = "0123456789ABCDEF";
      exports.HEX_CHARACTERS = HEX_CHARACTERS;
    }
  });

  // node_modules/@kameleoon/javascript-sdk-core/dist/kameleoonData/nonce.js
  var require_nonce = __commonJS({
    "node_modules/@kameleoon/javascript-sdk-core/dist/kameleoonData/nonce.js"(exports) {
      "use strict";
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.Nonce = void 0;
      var _constants = require_constants4();
      function _defineProperty(obj, key, value) {
        key = _toPropertyKey(key);
        if (key in obj) {
          Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
        } else {
          obj[key] = value;
        }
        return obj;
      }
      function _toPropertyKey(arg) {
        var key = _toPrimitive(arg, "string");
        return typeof key === "symbol" ? key : String(key);
      }
      function _toPrimitive(input, hint) {
        if (typeof input !== "object" || input === null)
          return input;
        var prim = input[Symbol.toPrimitive];
        if (prim !== void 0) {
          var res = prim.call(input, hint || "default");
          if (typeof res !== "object")
            return res;
          throw new TypeError("@@toPrimitive must return a primitive value.");
        }
        return (hint === "string" ? String : Number)(input);
      }
      var Nonce = class {
        // --- Note ---
        // nonce — «number that can only be used once»
        // is a hex valid string for the one-time use, which helps
        // tracking mechanism to differ one tracking event from another
        constructor() {
          _defineProperty(this, "nonce", void 0);
          this.nonce = this.getNonce();
        }
        getNonce() {
          const hexLength = _constants.HEX_CHARACTERS.length;
          let nonce = "";
          for (let i = 0; i < hexLength; i++) {
            const randomNumber = Math.floor(Math.random() * hexLength);
            nonce += _constants.HEX_CHARACTERS.substring(randomNumber, randomNumber + 1);
          }
          return nonce;
        }
      };
      exports.Nonce = Nonce;
    }
  });

  // node_modules/@kameleoon/javascript-sdk-core/dist/requester/requester.js
  var require_requester = __commonJS({
    "node_modules/@kameleoon/javascript-sdk-core/dist/requester/requester.js"(exports) {
      "use strict";
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.Requester = void 0;
      var _tsRes = require_build();
      var _kameleoonError = require_kameleoonError2();
      var _constants = require_constants3();
      var _nonce = require_nonce();
      function _defineProperty(obj, key, value) {
        key = _toPropertyKey(key);
        if (key in obj) {
          Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
        } else {
          obj[key] = value;
        }
        return obj;
      }
      function _toPropertyKey(arg) {
        var key = _toPrimitive(arg, "string");
        return typeof key === "symbol" ? key : String(key);
      }
      function _toPrimitive(input, hint) {
        if (typeof input !== "object" || input === null)
          return input;
        var prim = input[Symbol.toPrimitive];
        if (prim !== void 0) {
          var res = prim.call(input, hint || "default");
          if (typeof res !== "object")
            return res;
          throw new TypeError("@@toPrimitive must return a primitive value.");
        }
        return (hint === "string" ? String : Number)(input);
      }
      var Requester = class extends _nonce.Nonce {
        constructor({
          siteCode,
          environment,
          packageInfo,
          requestDispatcher
        }) {
          super();
          _defineProperty(this, "siteCode", void 0);
          _defineProperty(this, "environment", void 0);
          _defineProperty(this, "requestDispatcher", void 0);
          _defineProperty(this, "packageInfo", void 0);
          this.requestDispatcher = requestDispatcher;
          this.siteCode = siteCode;
          this.environment = environment;
          this.packageInfo = packageInfo;
        }
        async getClientConfiguration(timeStamp) {
          const environmentParam = this.environment ? _constants.UrlParameter.Environment + this.environment : "";
          const timeStampParam = timeStamp ? _constants.UrlParameter.Ts + timeStamp : "";
          const requestUrl = _constants.URL.CLIENT_CONFIGURATION + _constants.UrlQuery.Mobile + this.siteCode + environmentParam + timeStampParam;
          try {
            const response = await this.requestDispatcher.getClientConfiguration(requestUrl);
            return (0, _tsRes.Ok)(response);
          } catch (error) {
            return (0, _tsRes.Err)(error);
          }
        }
        async getRemoteData(key) {
          const requestUrl = _constants.URL.DATA_MAP + this.siteCode + _constants.UrlParameter.Key + encodeURI(key);
          const response = await this.requestDispatcher.getRemoteData(requestUrl);
          if (!response) {
            return (0, _tsRes.Err)(new _kameleoonError.KameleoonError(_kameleoonError.KameleoonException.RemoteData));
          }
          return (0, _tsRes.Ok)(response);
        }
        async getVisitorData(visitorCode) {
          const requestUrl = _constants.URL.VISIT_DATA + this.siteCode + _constants.UrlParameter.VisitorCode + visitorCode + _constants.UrlParameter.MaxNumberPreviousVisits + 1 + _constants.UrlParameter.CustomData + true + _constants.UrlParameter.CurrentVisit + true;
          const response = await this.requestDispatcher.getRemoteData(requestUrl);
          if (!response) {
            return (0, _tsRes.Err)(new _kameleoonError.KameleoonError(_kameleoonError.KameleoonException.RemoteData));
          }
          return (0, _tsRes.Ok)(response);
        }
        async trackExperiment({
          variationId,
          visitorCode,
          experimentId,
          isUnallocated,
          body,
          userAgent,
          callback
        }) {
          const url = this.getTrackingUrl(visitorCode);
          const unallocatedAddition = !body ? _constants.UrlEventType.Activity + _constants.UrlParameter.Nonce + this.getNonce() : "";
          const bodyAddition = isUnallocated ? unallocatedAddition : _constants.UrlEventType.Experiment + _constants.UrlParameter.Id + experimentId + _constants.UrlParameter.VariationId + variationId + _constants.UrlParameter.Nonce + this.getNonce();
          const extendedBody = bodyAddition ? body + "\n" + bodyAddition : body;
          const headers = userAgent ? {
            [_constants.Header.UserAgent]: userAgent
          } : void 0;
          const response = await this.requestDispatcher.track({
            url,
            headers,
            body: extendedBody
          });
          if (response && callback) {
            callback();
          }
        }
        async trackData({
          visitorCode,
          body,
          userAgent
        }) {
          const url = this.getTrackingUrl(visitorCode);
          const headers = userAgent ? {
            [_constants.Header.UserAgent]: userAgent
          } : void 0;
          this.requestDispatcher.track({
            url,
            headers,
            body
          });
        }
        getTrackingUrl(visitorCode) {
          const {
            type,
            version
          } = this.packageInfo;
          return _constants.URL.VISIT_EVENT + this.siteCode + _constants.UrlParameter.VisitorCode + encodeURIComponent(visitorCode) + _constants.UrlParameter.SdkName + type + _constants.UrlParameter.SdkVersion + version;
        }
      };
      exports.Requester = Requester;
    }
  });

  // node_modules/@kameleoon/javascript-sdk-core/dist/requester/types.js
  var require_types6 = __commonJS({
    "node_modules/@kameleoon/javascript-sdk-core/dist/requester/types.js"(exports) {
      "use strict";
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.HttpMethod = void 0;
      var HttpMethod = /* @__PURE__ */ function(HttpMethod2) {
        HttpMethod2["Get"] = "GET";
        HttpMethod2["Post"] = "POST";
        return HttpMethod2;
      }({});
      exports.HttpMethod = HttpMethod;
    }
  });

  // node_modules/@kameleoon/javascript-sdk-core/dist/requester/index.js
  var require_requester2 = __commonJS({
    "node_modules/@kameleoon/javascript-sdk-core/dist/requester/index.js"(exports) {
      "use strict";
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      Object.defineProperty(exports, "GetClientConfigurationResultType", {
        enumerable: true,
        get: function() {
          return _types.GetClientConfigurationResultType;
        }
      });
      Object.defineProperty(exports, "GetVisitorDataResultType", {
        enumerable: true,
        get: function() {
          return _types.GetVisitorDataResultType;
        }
      });
      Object.defineProperty(exports, "Header", {
        enumerable: true,
        get: function() {
          return _constants.Header;
        }
      });
      Object.defineProperty(exports, "HttpMethod", {
        enumerable: true,
        get: function() {
          return _types.HttpMethod;
        }
      });
      Object.defineProperty(exports, "IExternalRequestDispatcher", {
        enumerable: true,
        get: function() {
          return _types.IExternalRequestDispatcher;
        }
      });
      Object.defineProperty(exports, "Requester", {
        enumerable: true,
        get: function() {
          return _requester.Requester;
        }
      });
      Object.defineProperty(exports, "TrackExperimentParamsType", {
        enumerable: true,
        get: function() {
          return _types.TrackExperimentParamsType;
        }
      });
      Object.defineProperty(exports, "TrackParametersType", {
        enumerable: true,
        get: function() {
          return _types.TrackParametersType;
        }
      });
      Object.defineProperty(exports, "URL", {
        enumerable: true,
        get: function() {
          return _constants.URL;
        }
      });
      Object.defineProperty(exports, "UrlEventType", {
        enumerable: true,
        get: function() {
          return _constants.UrlEventType;
        }
      });
      Object.defineProperty(exports, "UrlParameter", {
        enumerable: true,
        get: function() {
          return _constants.UrlParameter;
        }
      });
      Object.defineProperty(exports, "VisitType", {
        enumerable: true,
        get: function() {
          return _types.VisitType;
        }
      });
      var _requester = require_requester();
      var _constants = require_constants3();
      var _types = require_types6();
    }
  });

  // node_modules/@kameleoon/javascript-sdk-core/dist/eventSource/constants.js
  var require_constants5 = __commonJS({
    "node_modules/@kameleoon/javascript-sdk-core/dist/eventSource/constants.js"(exports) {
      "use strict";
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.REAL_TIME_EVENT = void 0;
      var REAL_TIME_EVENT = "configuration-update-event";
      exports.REAL_TIME_EVENT = REAL_TIME_EVENT;
    }
  });

  // node_modules/@kameleoon/javascript-sdk-core/dist/eventSource/externalEventSource.js
  var require_externalEventSource = __commonJS({
    "node_modules/@kameleoon/javascript-sdk-core/dist/eventSource/externalEventSource.js"(exports) {
      "use strict";
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.ExternalEventSource = void 0;
      var _requester = require_requester2();
      var _constants = require_constants3();
      var _constants2 = require_constants5();
      function _defineProperty(obj, key, value) {
        key = _toPropertyKey(key);
        if (key in obj) {
          Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
        } else {
          obj[key] = value;
        }
        return obj;
      }
      function _toPropertyKey(arg) {
        var key = _toPrimitive(arg, "string");
        return typeof key === "symbol" ? key : String(key);
      }
      function _toPrimitive(input, hint) {
        if (typeof input !== "object" || input === null)
          return input;
        var prim = input[Symbol.toPrimitive];
        if (prim !== void 0) {
          var res = prim.call(input, hint || "default");
          if (typeof res !== "object")
            return res;
          throw new TypeError("@@toPrimitive must return a primitive value.");
        }
        return (hint === "string" ? String : Number)(input);
      }
      var ExternalEventSource = class {
        constructor(siteCode, externalEventSource) {
          _defineProperty(this, "eventSource", void 0);
          _defineProperty(this, "siteCode", void 0);
          const url = _requester.URL.SERVER_SENT_EVENTS + _constants.UrlQuery.Sse + siteCode;
          const eventSource = externalEventSource.initialize(url);
          this.eventSource = eventSource;
          this.siteCode = siteCode;
        }
        open(onEvent) {
          this.eventSource.open({
            onEvent,
            siteCode: this.siteCode,
            eventType: _constants2.REAL_TIME_EVENT
          });
        }
        close() {
          this.eventSource.close();
        }
      };
      exports.ExternalEventSource = ExternalEventSource;
    }
  });

  // node_modules/@kameleoon/javascript-sdk-core/dist/eventSource/index.js
  var require_eventSource = __commonJS({
    "node_modules/@kameleoon/javascript-sdk-core/dist/eventSource/index.js"(exports) {
      "use strict";
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      Object.defineProperty(exports, "EventSourceOpenParametersType", {
        enumerable: true,
        get: function() {
          return _types.EventSourceOpenParametersType;
        }
      });
      Object.defineProperty(exports, "ExternalEventSource", {
        enumerable: true,
        get: function() {
          return _externalEventSource.ExternalEventSource;
        }
      });
      Object.defineProperty(exports, "IEventSource", {
        enumerable: true,
        get: function() {
          return _externalEventSource.IEventSource;
        }
      });
      Object.defineProperty(exports, "IExternalEventSource", {
        enumerable: true,
        get: function() {
          return _types.IExternalEventSource;
        }
      });
      Object.defineProperty(exports, "IExternalEventSourceConstructor", {
        enumerable: true,
        get: function() {
          return _types.IExternalEventSourceConstructor;
        }
      });
      Object.defineProperty(exports, "REAL_TIME_EVENT", {
        enumerable: true,
        get: function() {
          return _constants.REAL_TIME_EVENT;
        }
      });
      Object.defineProperty(exports, "RealTimeEventType", {
        enumerable: true,
        get: function() {
          return _types.RealTimeEventType;
        }
      });
      var _types = require_types4();
      var _externalEventSource = require_externalEventSource();
      var _constants = require_constants5();
    }
  });

  // node_modules/@kameleoon/javascript-sdk-core/dist/campaignConfiguration/campaignConfiguration.js
  var require_campaignConfiguration = __commonJS({
    "node_modules/@kameleoon/javascript-sdk-core/dist/campaignConfiguration/campaignConfiguration.js"(exports) {
      "use strict";
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.CampaignConfiguration = void 0;
      var _tsRes = require_build();
      var _constants = require_constants();
      var _eventSource = require_eventSource();
      var _types = require_types();
      function ownKeys(object, enumerableOnly) {
        var keys = Object.keys(object);
        if (Object.getOwnPropertySymbols) {
          var symbols = Object.getOwnPropertySymbols(object);
          enumerableOnly && (symbols = symbols.filter(function(sym) {
            return Object.getOwnPropertyDescriptor(object, sym).enumerable;
          })), keys.push.apply(keys, symbols);
        }
        return keys;
      }
      function _objectSpread(target) {
        for (var i = 1; i < arguments.length; i++) {
          var source = null != arguments[i] ? arguments[i] : {};
          i % 2 ? ownKeys(Object(source), true).forEach(function(key) {
            _defineProperty(target, key, source[key]);
          }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function(key) {
            Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
          });
        }
        return target;
      }
      function _defineProperty(obj, key, value) {
        key = _toPropertyKey(key);
        if (key in obj) {
          Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
        } else {
          obj[key] = value;
        }
        return obj;
      }
      function _toPropertyKey(arg) {
        var key = _toPrimitive(arg, "string");
        return typeof key === "symbol" ? key : String(key);
      }
      function _toPrimitive(input, hint) {
        if (typeof input !== "object" || input === null)
          return input;
        var prim = input[Symbol.toPrimitive];
        if (prim !== void 0) {
          var res = prim.call(input, hint || "default");
          if (typeof res !== "object")
            return res;
          throw new TypeError("@@toPrimitive must return a primitive value.");
        }
        return (hint === "string" ? String : Number)(input);
      }
      var CampaignConfiguration = class {
        constructor({
          settings,
          storage,
          requester,
          externalClientConfiguration,
          targetingCleanupInterval
        }) {
          _defineProperty(this, "configurationUpdateCallback", void 0);
          _defineProperty(this, "updateConfigurationIntervalId", null);
          _defineProperty(this, "targetingDataIntervalId", null);
          _defineProperty(this, "unsentTargetingData", {});
          _defineProperty(this, "targetingData", _constants.DEFAULT_CAMPAIGN_CONFIGURATION.targetingData);
          _defineProperty(this, "configurationData", _constants.DEFAULT_CAMPAIGN_CONFIGURATION.configurationData);
          _defineProperty(this, "settings", void 0);
          _defineProperty(this, "lastUpdate", void 0);
          _defineProperty(this, "storage", void 0);
          _defineProperty(this, "requester", void 0);
          _defineProperty(this, "eventSource", void 0);
          _defineProperty(this, "externalClientConfiguration", void 0);
          _defineProperty(this, "targetingDataLifetime", _constants.CLEANUP_TARGETING_DATA_INTERVAL * _types.Milliseconds.Minute);
          this.requester = requester;
          this.settings = settings;
          this.lastUpdate = /* @__PURE__ */ new Date();
          this.storage = storage;
          this.readStorageData();
          this.externalClientConfiguration = externalClientConfiguration;
          if (targetingCleanupInterval) {
            this.targetingDataLifetime = targetingCleanupInterval * _types.Milliseconds.Minute;
            const cleanupIntervalMinutes = targetingCleanupInterval < 0 ? 1 : targetingCleanupInterval;
            try {
              this.targetingDataIntervalId = setInterval(() => this.cleanupOutdatedTargetingData.call(this, this.targetingData), cleanupIntervalMinutes * _types.Milliseconds.Minute);
            } catch (err) {
              if (this.targetingDataIntervalId) {
                clearInterval(this.targetingDataIntervalId);
              }
              throw err;
            }
          }
        }
        async initialize(externalEventSource, useCache) {
          const shouldUpdate = this.checkShouldUpdate();
          if (shouldUpdate) {
            const updateResult = await this.updateClientConfiguration({
              useCache
            });
            if (!updateResult.ok) {
              return updateResult;
            }
          }
          if (this.configurationData.configuration.realTimeUpdate && !this.externalClientConfiguration) {
            if (this.updateConfigurationIntervalId) {
              clearInterval(this.updateConfigurationIntervalId);
            }
            this.eventSource = new _eventSource.ExternalEventSource(this.settings.siteCode, externalEventSource);
            const updateEventCallback = (_timeStamp) => {
              this.updateClientConfiguration({
                useCache
              });
              if (this.configurationUpdateCallback) {
                this.configurationUpdateCallback();
              }
            };
            this.eventSource.open(updateEventCallback);
          } else {
            if (this.eventSource) {
              this.eventSource.close();
            }
            if (this.updateConfigurationIntervalId) {
              clearInterval(this.updateConfigurationIntervalId);
            }
            try {
              this.updateConfigurationIntervalId = setInterval(() => this.updateClientConfiguration.bind(this)({
                useCache
              }), this.settings.updateInterval);
            } catch (err) {
              if (this.updateConfigurationIntervalId) {
                clearInterval(this.updateConfigurationIntervalId);
              }
              throw err;
            }
          }
          return (0, _tsRes.Ok)();
        }
        addTargetingData(visitorCode, ...data) {
          if (!(visitorCode in this.targetingData)) {
            this.targetingData[visitorCode] = [];
          }
          data.forEach((dataItem) => {
            this.targetingData[visitorCode].push({
              data: dataItem.data,
              lastActivityTime: Date.now()
            });
          });
          const result = this.updateStorageData(this.lastUpdate);
          if (result.ok) {
            data.forEach((dataItem) => {
              if (!this.unsentTargetingData[visitorCode]) {
                this.unsentTargetingData[visitorCode] = [];
              }
              this.unsentTargetingData[visitorCode].push(dataItem);
            });
          }
          return result;
        }
        getUnsentData(visitorCode) {
          const unsentDataItem = this.unsentTargetingData[visitorCode];
          if (!unsentDataItem) {
            return [];
          }
          return unsentDataItem;
        }
        clearUnsentData(visitorCode) {
          this.unsentTargetingData[visitorCode] = [];
        }
        onConfigurationUpdate(callback) {
          this.configurationUpdateCallback = callback;
        }
        get storedTargetingData() {
          return this.targetingData;
        }
        get experiments() {
          return this.configurationData.experiments;
        }
        get featureFlags() {
          return this.configurationData.featureFlags;
        }
        get configuration() {
          return this.configurationData.configuration;
        }
        checkShouldUpdate() {
          const {
            featureFlags,
            experiments,
            configuration
          } = this.configurationData;
          const {
            updateInterval
          } = this.settings;
          if (!featureFlags.length && !experiments.length) {
            return true;
          }
          if (configuration.realTimeUpdate) {
            return true;
          }
          const lastUpdateTime = this.lastUpdate.getTime();
          const updateWindowEdge = Date.now() - updateInterval;
          return lastUpdateTime < updateWindowEdge;
        }
        cleanupOutdatedTargetingData(data) {
          const currentTime = Date.now();
          const resultTargetingData = _objectSpread({}, data);
          for (const [key, value] of Object.entries(resultTargetingData)) {
            if (value) {
              const resultValue = value.filter((item) => {
                const isDataExpired = item.lastActivityTime + this.targetingDataLifetime < currentTime;
                return !isDataExpired;
              });
              if (resultValue.length) {
                resultTargetingData[key] = resultValue;
                continue;
              }
            }
            delete resultTargetingData[key];
          }
          this.targetingData = resultTargetingData;
          this.updateStorageData(this.lastUpdate).throw();
        }
        readStorageData() {
          const result = this.storage.read();
          if (result.ok) {
            const {
              kameleoonTargetingData,
              kameleoonConfiguration,
              lastUpdate
            } = result.data;
            this.configurationData = kameleoonConfiguration;
            this.targetingData = kameleoonTargetingData;
            this.lastUpdate = new Date(Date.parse(lastUpdate));
          }
        }
        async updateClientConfiguration({
          useCache = false,
          timeStamp
        } = {}) {
          if (this.externalClientConfiguration) {
            const {
              configuration,
              experiments,
              featureFlagConfigurations
            } = this.externalClientConfiguration;
            this.configurationData = {
              configuration,
              experiments,
              featureFlags: featureFlagConfigurations
            };
          } else {
            const clientConfigurationResult = await this.requester.getClientConfiguration(timeStamp);
            if (!clientConfigurationResult.ok) {
              const {
                featureFlags,
                experiments: experiments2
              } = this.configurationData;
              if (useCache && featureFlags.length && experiments2.length) {
                return (0, _tsRes.Ok)(true);
              }
              return clientConfigurationResult;
            }
            const {
              configuration,
              experiments,
              featureFlagConfigurations
            } = clientConfigurationResult.data;
            this.configurationData = {
              configuration,
              experiments,
              featureFlags: featureFlagConfigurations
            };
          }
          const result = this.updateStorageData(/* @__PURE__ */ new Date());
          if (!result.ok) {
            return result;
          }
          return (0, _tsRes.Ok)(true);
        }
        updateStorageData(lastUpdate) {
          const data = {
            kameleoonTargetingData: this.targetingData,
            kameleoonConfiguration: this.configurationData,
            lastUpdate: lastUpdate.toString()
          };
          return this.storage.write(data);
        }
      };
      exports.CampaignConfiguration = CampaignConfiguration;
    }
  });

  // node_modules/@kameleoon/javascript-sdk-core/dist/campaignConfiguration/index.js
  var require_campaignConfiguration2 = __commonJS({
    "node_modules/@kameleoon/javascript-sdk-core/dist/campaignConfiguration/index.js"(exports) {
      "use strict";
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      Object.defineProperty(exports, "CLEANUP_TARGETING_DATA_INTERVAL", {
        enumerable: true,
        get: function() {
          return _constants.CLEANUP_TARGETING_DATA_INTERVAL;
        }
      });
      Object.defineProperty(exports, "CampaignConfiguration", {
        enumerable: true,
        get: function() {
          return _campaignConfiguration.CampaignConfiguration;
        }
      });
      Object.defineProperty(exports, "CampaignConfigurationType", {
        enumerable: true,
        get: function() {
          return _types.CampaignConfigurationType;
        }
      });
      Object.defineProperty(exports, "ConfigurationDataType", {
        enumerable: true,
        get: function() {
          return _types.ConfigurationDataType;
        }
      });
      Object.defineProperty(exports, "ExperimentItemType", {
        enumerable: true,
        get: function() {
          return _types.ExperimentItemType;
        }
      });
      Object.defineProperty(exports, "FeatureFlagType", {
        enumerable: true,
        get: function() {
          return _types.FeatureFlagType;
        }
      });
      Object.defineProperty(exports, "FeatureVariableType", {
        enumerable: true,
        get: function() {
          return _types.FeatureVariableType;
        }
      });
      Object.defineProperty(exports, "JSONType", {
        enumerable: true,
        get: function() {
          return _types.JSONType;
        }
      });
      Object.defineProperty(exports, "JSONValue", {
        enumerable: true,
        get: function() {
          return _types.JSONValue;
        }
      });
      Object.defineProperty(exports, "RespoolTimeType", {
        enumerable: true,
        get: function() {
          return _types.RespoolTimeType;
        }
      });
      Object.defineProperty(exports, "RuleItemType", {
        enumerable: true,
        get: function() {
          return _types.RuleItemType;
        }
      });
      Object.defineProperty(exports, "RuleType", {
        enumerable: true,
        get: function() {
          return _types.RuleType;
        }
      });
      Object.defineProperty(exports, "VariationByExpositionType", {
        enumerable: true,
        get: function() {
          return _types.VariationByExpositionType;
        }
      });
      var _types = require_types3();
      var _campaignConfiguration = require_campaignConfiguration();
      var _constants = require_constants();
    }
  });

  // node_modules/@kameleoon/javascript-sdk-core/dist/clientSettings/clientSettings.js
  var require_clientSettings = __commonJS({
    "node_modules/@kameleoon/javascript-sdk-core/dist/clientSettings/clientSettings.js"(exports) {
      "use strict";
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.ClientSettings = void 0;
      var _types = require_types();
      function _defineProperty(obj, key, value) {
        key = _toPropertyKey(key);
        if (key in obj) {
          Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
        } else {
          obj[key] = value;
        }
        return obj;
      }
      function _toPropertyKey(arg) {
        var key = _toPrimitive(arg, "string");
        return typeof key === "symbol" ? key : String(key);
      }
      function _toPrimitive(input, hint) {
        if (typeof input !== "object" || input === null)
          return input;
        var prim = input[Symbol.toPrimitive];
        if (prim !== void 0) {
          var res = prim.call(input, hint || "default");
          if (typeof res !== "object")
            return res;
          throw new TypeError("@@toPrimitive must return a primitive value.");
        }
        return (hint === "string" ? String : Number)(input);
      }
      var ClientSettings = class {
        constructor(siteCode, configuration) {
          _defineProperty(this, "updateInterval", 60 * _types.Milliseconds.Minute);
          _defineProperty(this, "environment", void 0);
          _defineProperty(this, "siteCode", void 0);
          this.siteCode = siteCode;
          if (configuration?.environment) {
            this.environment = configuration.environment;
          }
          if (configuration?.updateInterval) {
            if (configuration.updateInterval < 1) {
              this.updateInterval = 1 * _types.Milliseconds.Minute;
            }
            this.updateInterval = configuration.updateInterval * _types.Milliseconds.Minute;
          }
        }
        get settings() {
          return {
            updateInterval: this.updateInterval,
            environment: this.environment,
            siteCode: this.siteCode
          };
        }
      };
      exports.ClientSettings = ClientSettings;
    }
  });

  // node_modules/@kameleoon/javascript-sdk-core/dist/clientSettings/types.js
  var require_types7 = __commonJS({
    "node_modules/@kameleoon/javascript-sdk-core/dist/clientSettings/types.js"(exports) {
      "use strict";
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
    }
  });

  // node_modules/@kameleoon/javascript-sdk-core/dist/clientSettings/index.js
  var require_clientSettings2 = __commonJS({
    "node_modules/@kameleoon/javascript-sdk-core/dist/clientSettings/index.js"(exports) {
      "use strict";
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      Object.defineProperty(exports, "ClientSettings", {
        enumerable: true,
        get: function() {
          return _clientSettings.ClientSettings;
        }
      });
      Object.defineProperty(exports, "ClientSettingsType", {
        enumerable: true,
        get: function() {
          return _types.ClientSettingsType;
        }
      });
      var _clientSettings = require_clientSettings();
      var _types = require_types7();
    }
  });

  // node_modules/@kameleoon/javascript-sdk-core/dist/constants.js
  var require_constants6 = __commonJS({
    "node_modules/@kameleoon/javascript-sdk-core/dist/constants.js"(exports) {
      "use strict";
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.VISITOR_CODE_LENGTH = exports.UNALLOCATED_VARIATION_ID = exports.SDKType = exports.OFF_VARIATION_KEY = exports.KAMELEOON_COOKIE_KEY = exports.Cookie = exports.CACHE_ITEM_LIFETIME = exports.CACHE_CLEANUP_TIMEOUT = void 0;
      var UNALLOCATED_VARIATION_ID = 0;
      exports.UNALLOCATED_VARIATION_ID = UNALLOCATED_VARIATION_ID;
      var OFF_VARIATION_KEY = "off";
      exports.OFF_VARIATION_KEY = OFF_VARIATION_KEY;
      var KAMELEOON_COOKIE_KEY = "kameleoonVisitorCode";
      exports.KAMELEOON_COOKIE_KEY = KAMELEOON_COOKIE_KEY;
      var VISITOR_CODE_LENGTH = 16;
      exports.VISITOR_CODE_LENGTH = VISITOR_CODE_LENGTH;
      var CACHE_CLEANUP_TIMEOUT = 10;
      exports.CACHE_CLEANUP_TIMEOUT = CACHE_CLEANUP_TIMEOUT;
      var CACHE_ITEM_LIFETIME = 5;
      exports.CACHE_ITEM_LIFETIME = CACHE_ITEM_LIFETIME;
      var Cookie = /* @__PURE__ */ function(Cookie2) {
        Cookie2["PairsDelimiter"] = "; ";
        Cookie2["KeyValueDelimiter"] = "=";
        Cookie2["MaxAge"] = "Max-Age";
        Cookie2["Path"] = "Path";
        Cookie2["Domain"] = "Domain";
        return Cookie2;
      }({});
      exports.Cookie = Cookie;
      var SDKType = /* @__PURE__ */ function(SDKType2) {
        SDKType2["NodeJS"] = "nodejs";
        SDKType2["JavaScript"] = "javascript";
        SDKType2["React"] = "react";
        return SDKType2;
      }({});
      exports.SDKType = SDKType;
    }
  });

  // node_modules/@kameleoon/javascript-sdk-core/dist/kameleoonData/types.js
  var require_types8 = __commonJS({
    "node_modules/@kameleoon/javascript-sdk-core/dist/kameleoonData/types.js"(exports) {
      "use strict";
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.KameleoonData = exports.DeviceType = exports.BrowserType = void 0;
      var KameleoonData = /* @__PURE__ */ function(KameleoonData2) {
        KameleoonData2["CustomData"] = "customData";
        KameleoonData2["PageView"] = "pageView";
        KameleoonData2["Browser"] = "browser";
        KameleoonData2["Conversion"] = "conversion";
        KameleoonData2["Device"] = "device";
        KameleoonData2["UserAgent"] = "userAgent";
        return KameleoonData2;
      }({});
      exports.KameleoonData = KameleoonData;
      var DeviceType = /* @__PURE__ */ function(DeviceType2) {
        DeviceType2["Phone"] = "PHONE";
        DeviceType2["Tablet"] = "TABLET";
        DeviceType2["Desktop"] = "DESKTOP";
        return DeviceType2;
      }({});
      exports.DeviceType = DeviceType;
      var BrowserType = /* @__PURE__ */ function(BrowserType2) {
        BrowserType2[BrowserType2["Chrome"] = 0] = "Chrome";
        BrowserType2[BrowserType2["InternetExplorer"] = 1] = "InternetExplorer";
        BrowserType2[BrowserType2["Firefox"] = 2] = "Firefox";
        BrowserType2[BrowserType2["Safari"] = 3] = "Safari";
        BrowserType2[BrowserType2["Opera"] = 4] = "Opera";
        BrowserType2[BrowserType2["Other"] = 5] = "Other";
        return BrowserType2;
      }({});
      exports.BrowserType = BrowserType;
    }
  });

  // node_modules/@kameleoon/javascript-sdk-core/dist/kameleoonData/customData.js
  var require_customData = __commonJS({
    "node_modules/@kameleoon/javascript-sdk-core/dist/kameleoonData/customData.js"(exports) {
      "use strict";
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.CustomData = void 0;
      var _requester = require_requester2();
      var _nonce = require_nonce();
      var _types = require_types8();
      function _defineProperty(obj, key, value) {
        key = _toPropertyKey(key);
        if (key in obj) {
          Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
        } else {
          obj[key] = value;
        }
        return obj;
      }
      function _toPropertyKey(arg) {
        var key = _toPrimitive(arg, "string");
        return typeof key === "symbol" ? key : String(key);
      }
      function _toPrimitive(input, hint) {
        if (typeof input !== "object" || input === null)
          return input;
        var prim = input[Symbol.toPrimitive];
        if (prim !== void 0) {
          var res = prim.call(input, hint || "default");
          if (typeof res !== "object")
            return res;
          throw new TypeError("@@toPrimitive must return a primitive value.");
        }
        return (hint === "string" ? String : Number)(input);
      }
      var CustomData = class extends _nonce.Nonce {
        /**
         * @param {number} index - an index of custom data to be stored under in a state, an index of custom data can be specified in `Advanced Tools` section of Kameleoon Application
         * @param {string[]} value - custom value to store under the specified id, value can be anything but has to be stringified to match the `string` type. *Note* value is variadic parameter and can be used as follows
         * @example
         * ```ts
         * // - Single value
         * const customData = new CustomData(0, 'value_1');
         * // - Variadic number of values
         * const customData = new CustomData(0, 'value_1', 'value_2', 'value_3');
         * // - Array of values
         * const values = ['value_1', 'value_2', 'value_3'];
         * const customData = new CustomData(0, ...values);
         * ```
         * */
        constructor(index, ...value) {
          super();
          _defineProperty(this, "index", void 0);
          _defineProperty(this, "value", void 0);
          this.index = index;
          this.value = value;
        }
        /**
         * @property url - url for the current data type used for events tracking
         * */
        get url() {
          const uniqueValues = [...new Set(this.value)];
          let resultValue = {};
          uniqueValues.forEach((value) => {
            resultValue[value] = 1;
          });
          if (!Object.keys(resultValue).length) {
            return "";
          }
          return _requester.UrlEventType.CustomData + _requester.UrlParameter.Index + this.index + _requester.UrlParameter.ValuesCountMap + encodeURIComponent(JSON.stringify(resultValue)) + _requester.UrlParameter.Overwrite + String(true) + _requester.UrlParameter.Nonce + this.nonce;
        }
        /**
         * @property data - data of the current class instance
         * */
        get data() {
          return {
            index: this.index,
            value: this.value,
            type: _types.KameleoonData.CustomData,
            nonce: this.nonce
          };
        }
      };
      exports.CustomData = CustomData;
    }
  });

  // node_modules/@kameleoon/javascript-sdk-core/dist/kameleoonData/conversion.js
  var require_conversion = __commonJS({
    "node_modules/@kameleoon/javascript-sdk-core/dist/kameleoonData/conversion.js"(exports) {
      "use strict";
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.Conversion = void 0;
      var _requester = require_requester2();
      var _nonce = require_nonce();
      var _types = require_types8();
      function _defineProperty(obj, key, value) {
        key = _toPropertyKey(key);
        if (key in obj) {
          Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
        } else {
          obj[key] = value;
        }
        return obj;
      }
      function _toPropertyKey(arg) {
        var key = _toPrimitive(arg, "string");
        return typeof key === "symbol" ? key : String(key);
      }
      function _toPrimitive(input, hint) {
        if (typeof input !== "object" || input === null)
          return input;
        var prim = input[Symbol.toPrimitive];
        if (prim !== void 0) {
          var res = prim.call(input, hint || "default");
          if (typeof res !== "object")
            return res;
          throw new TypeError("@@toPrimitive must return a primitive value.");
        }
        return (hint === "string" ? String : Number)(input);
      }
      var Conversion = class extends _nonce.Nonce {
        /**
         * @param {ConversionParametersType} conversionParameters - an object with conversion parameters
         * */
        constructor({
          goalId,
          revenue = 0,
          negative = false
        }) {
          super();
          _defineProperty(this, "goalId", void 0);
          _defineProperty(this, "revenue", void 0);
          _defineProperty(this, "negative", void 0);
          this.goalId = goalId;
          this.revenue = revenue;
          this.negative = negative;
        }
        /**
         * @property url - url for the current data type used for events tracking
         * */
        get url() {
          return _requester.UrlEventType.Conversion + _requester.UrlParameter.GoalId + String(this.goalId) + _requester.UrlParameter.Revenue + String(this.revenue) + _requester.UrlParameter.Negative + String(this.negative) + _requester.UrlParameter.Nonce + this.nonce;
        }
        /**
         * @property data - data of the current class instance
         * */
        get data() {
          return {
            goalId: this.goalId,
            revenue: this.revenue,
            negative: this.negative,
            type: _types.KameleoonData.Conversion,
            nonce: this.nonce
          };
        }
      };
      exports.Conversion = Conversion;
    }
  });

  // node_modules/@kameleoon/javascript-sdk-core/dist/kameleoonData/device.js
  var require_device = __commonJS({
    "node_modules/@kameleoon/javascript-sdk-core/dist/kameleoonData/device.js"(exports) {
      "use strict";
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.Device = void 0;
      var _requester = require_requester2();
      var _nonce = require_nonce();
      var _types = require_types8();
      function _defineProperty(obj, key, value) {
        key = _toPropertyKey(key);
        if (key in obj) {
          Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
        } else {
          obj[key] = value;
        }
        return obj;
      }
      function _toPropertyKey(arg) {
        var key = _toPrimitive(arg, "string");
        return typeof key === "symbol" ? key : String(key);
      }
      function _toPrimitive(input, hint) {
        if (typeof input !== "object" || input === null)
          return input;
        var prim = input[Symbol.toPrimitive];
        if (prim !== void 0) {
          var res = prim.call(input, hint || "default");
          if (typeof res !== "object")
            return res;
          throw new TypeError("@@toPrimitive must return a primitive value.");
        }
        return (hint === "string" ? String : Number)(input);
      }
      var Device = class extends _nonce.Nonce {
        /**
         * @param {DeviceType} device - one of the available device types from `DeviceType` enum
         * */
        constructor(device) {
          super();
          _defineProperty(this, "device", void 0);
          this.device = device;
        }
        /**
         * @property url - url for the current data type used for events tracking
         * */
        get url() {
          return _requester.UrlEventType.StaticData + _requester.UrlParameter.DeviceType + this.device + _requester.UrlParameter.Nonce + this.nonce;
        }
        /**
         * @property data - data of the current class instance
         * */
        get data() {
          return {
            device: this.device,
            type: _types.KameleoonData.Device,
            nonce: this.nonce
          };
        }
      };
      exports.Device = Device;
    }
  });

  // node_modules/@kameleoon/javascript-sdk-core/dist/kameleoonData/browser.js
  var require_browser = __commonJS({
    "node_modules/@kameleoon/javascript-sdk-core/dist/kameleoonData/browser.js"(exports) {
      "use strict";
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.Browser = void 0;
      var _nonce = require_nonce();
      var _requester = require_requester2();
      var _types = require_types8();
      function _defineProperty(obj, key, value) {
        key = _toPropertyKey(key);
        if (key in obj) {
          Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
        } else {
          obj[key] = value;
        }
        return obj;
      }
      function _toPropertyKey(arg) {
        var key = _toPrimitive(arg, "string");
        return typeof key === "symbol" ? key : String(key);
      }
      function _toPrimitive(input, hint) {
        if (typeof input !== "object" || input === null)
          return input;
        var prim = input[Symbol.toPrimitive];
        if (prim !== void 0) {
          var res = prim.call(input, hint || "default");
          if (typeof res !== "object")
            return res;
          throw new TypeError("@@toPrimitive must return a primitive value.");
        }
        return (hint === "string" ? String : Number)(input);
      }
      var Browser = class extends _nonce.Nonce {
        /**
         * @param {BrowserType} browser - one of the browser types available for data, if browser can not be found in a list, it can be marked as `BrowserType.Other`
         * */
        constructor(browser) {
          super();
          _defineProperty(this, "browser", void 0);
          this.browser = browser;
        }
        /**
         * @property url - url for the current data type used for events tracking
         * */
        get url() {
          return _requester.UrlEventType.StaticData + _requester.UrlParameter.BrowserIndex + this.browser + _requester.UrlParameter.Nonce + this.nonce;
        }
        /**
         * @property data - data of the current class instance
         * */
        get data() {
          return {
            browser: this.browser,
            type: _types.KameleoonData.Browser,
            nonce: this.nonce
          };
        }
      };
      exports.Browser = Browser;
    }
  });

  // node_modules/@kameleoon/javascript-sdk-core/dist/kameleoonData/pageView.js
  var require_pageView = __commonJS({
    "node_modules/@kameleoon/javascript-sdk-core/dist/kameleoonData/pageView.js"(exports) {
      "use strict";
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.PageView = void 0;
      var _requester = require_requester2();
      var _nonce = require_nonce();
      var _types = require_types8();
      function _defineProperty(obj, key, value) {
        key = _toPropertyKey(key);
        if (key in obj) {
          Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
        } else {
          obj[key] = value;
        }
        return obj;
      }
      function _toPropertyKey(arg) {
        var key = _toPrimitive(arg, "string");
        return typeof key === "symbol" ? key : String(key);
      }
      function _toPrimitive(input, hint) {
        if (typeof input !== "object" || input === null)
          return input;
        var prim = input[Symbol.toPrimitive];
        if (prim !== void 0) {
          var res = prim.call(input, hint || "default");
          if (typeof res !== "object")
            return res;
          throw new TypeError("@@toPrimitive must return a primitive value.");
        }
        return (hint === "string" ? String : Number)(input);
      }
      var PageView = class extends _nonce.Nonce {
        /**
         * @param {PageViewParametersType} pageViewParameters - an object with page view parameters
         * */
        constructor({
          urlAddress,
          title,
          referrers
        }) {
          super();
          _defineProperty(this, "urlAddress", void 0);
          _defineProperty(this, "title", void 0);
          _defineProperty(this, "referrers", void 0);
          this.urlAddress = urlAddress;
          this.title = title;
          this.referrers = referrers;
        }
        /**
         * @property url - url for the current data type used for events tracking
         * */
        get url() {
          return _requester.UrlEventType.Page + _requester.UrlParameter.Href + encodeURIComponent(this.urlAddress) + _requester.UrlParameter.Title + encodeURIComponent(this.title) + this.getReferresParameter(this.referrers) + _requester.UrlParameter.Nonce + this.nonce;
        }
        /**
         * @property data - data of the current class instance
         * */
        get data() {
          return {
            urlAddress: this.urlAddress,
            title: this.title,
            referrers: this.referrers,
            type: _types.KameleoonData.PageView,
            nonce: this.nonce
          };
        }
        getReferresParameter(referrers) {
          if (referrers) {
            return _requester.UrlParameter.ReferrersIndices + JSON.stringify(referrers);
          }
          return "";
        }
      };
      exports.PageView = PageView;
    }
  });

  // node_modules/@kameleoon/javascript-sdk-core/dist/kameleoonData/userAgent.js
  var require_userAgent = __commonJS({
    "node_modules/@kameleoon/javascript-sdk-core/dist/kameleoonData/userAgent.js"(exports) {
      "use strict";
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.UserAgent = void 0;
      var _nonce = require_nonce();
      var _types = require_types8();
      function _defineProperty(obj, key, value) {
        key = _toPropertyKey(key);
        if (key in obj) {
          Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
        } else {
          obj[key] = value;
        }
        return obj;
      }
      function _toPropertyKey(arg) {
        var key = _toPrimitive(arg, "string");
        return typeof key === "symbol" ? key : String(key);
      }
      function _toPrimitive(input, hint) {
        if (typeof input !== "object" || input === null)
          return input;
        var prim = input[Symbol.toPrimitive];
        if (prim !== void 0) {
          var res = prim.call(input, hint || "default");
          if (typeof res !== "object")
            return res;
          throw new TypeError("@@toPrimitive must return a primitive value.");
        }
        return (hint === "string" ? String : Number)(input);
      }
      var UserAgent = class extends _nonce.Nonce {
        constructor(value) {
          super();
          _defineProperty(this, "value", void 0);
          this.value = value;
        }
        /**
         * @property url - url for the current data type used for events tracking
         * */
        get url() {
          return "";
        }
        /**
         * @property data - data of the current class instance
         * */
        get data() {
          return {
            value: this.value,
            type: _types.KameleoonData.UserAgent,
            nonce: this.nonce
          };
        }
      };
      exports.UserAgent = UserAgent;
    }
  });

  // node_modules/@kameleoon/javascript-sdk-core/dist/kameleoonData/index.js
  var require_kameleoonData = __commonJS({
    "node_modules/@kameleoon/javascript-sdk-core/dist/kameleoonData/index.js"(exports) {
      "use strict";
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      Object.defineProperty(exports, "Browser", {
        enumerable: true,
        get: function() {
          return _browser.Browser;
        }
      });
      Object.defineProperty(exports, "BrowserType", {
        enumerable: true,
        get: function() {
          return _types.BrowserType;
        }
      });
      Object.defineProperty(exports, "Conversion", {
        enumerable: true,
        get: function() {
          return _conversion.Conversion;
        }
      });
      Object.defineProperty(exports, "ConversionParametersType", {
        enumerable: true,
        get: function() {
          return _types.ConversionParametersType;
        }
      });
      Object.defineProperty(exports, "CustomData", {
        enumerable: true,
        get: function() {
          return _customData.CustomData;
        }
      });
      Object.defineProperty(exports, "CustomDataType", {
        enumerable: true,
        get: function() {
          return _types.CustomDataType;
        }
      });
      Object.defineProperty(exports, "Device", {
        enumerable: true,
        get: function() {
          return _device.Device;
        }
      });
      Object.defineProperty(exports, "DeviceType", {
        enumerable: true,
        get: function() {
          return _types.DeviceType;
        }
      });
      Object.defineProperty(exports, "KameleoonData", {
        enumerable: true,
        get: function() {
          return _types.KameleoonData;
        }
      });
      Object.defineProperty(exports, "KameleoonDataItemType", {
        enumerable: true,
        get: function() {
          return _types.KameleoonDataItemType;
        }
      });
      Object.defineProperty(exports, "KameleoonDataType", {
        enumerable: true,
        get: function() {
          return _types.KameleoonDataType;
        }
      });
      Object.defineProperty(exports, "PageView", {
        enumerable: true,
        get: function() {
          return _pageView.PageView;
        }
      });
      Object.defineProperty(exports, "PageViewParametersType", {
        enumerable: true,
        get: function() {
          return _types.PageViewParametersType;
        }
      });
      Object.defineProperty(exports, "UserAgent", {
        enumerable: true,
        get: function() {
          return _userAgent.UserAgent;
        }
      });
      Object.defineProperty(exports, "UserAgentDataType", {
        enumerable: true,
        get: function() {
          return _types.UserAgentDataType;
        }
      });
      var _customData = require_customData();
      var _conversion = require_conversion();
      var _device = require_device();
      var _browser = require_browser();
      var _pageView = require_pageView();
      var _userAgent = require_userAgent();
      var _types = require_types8();
    }
  });

  // node_modules/@kameleoon/javascript-sdk-core/dist/storage/constants.js
  var require_constants7 = __commonJS({
    "node_modules/@kameleoon/javascript-sdk-core/dist/storage/constants.js"(exports) {
      "use strict";
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.KameleoonStorageKey = void 0;
      var KameleoonStorageKey = /* @__PURE__ */ function(KameleoonStorageKey2) {
        KameleoonStorageKey2["ClientData"] = "kameleoonClientData";
        KameleoonStorageKey2["VariationData"] = "kameleoonVariationData";
        KameleoonStorageKey2["VisitorCode"] = "kameleoonVisitorCode";
        return KameleoonStorageKey2;
      }({});
      exports.KameleoonStorageKey = KameleoonStorageKey;
    }
  });

  // node_modules/@kameleoon/javascript-sdk-core/dist/storage/externalStorage.js
  var require_externalStorage = __commonJS({
    "node_modules/@kameleoon/javascript-sdk-core/dist/storage/externalStorage.js"(exports) {
      "use strict";
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.ExternalStorage = void 0;
      var _tsRes = require_build();
      var _kameleoonError = require_kameleoonError2();
      function _defineProperty(obj, key, value) {
        key = _toPropertyKey(key);
        if (key in obj) {
          Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
        } else {
          obj[key] = value;
        }
        return obj;
      }
      function _toPropertyKey(arg) {
        var key = _toPrimitive(arg, "string");
        return typeof key === "symbol" ? key : String(key);
      }
      function _toPrimitive(input, hint) {
        if (typeof input !== "object" || input === null)
          return input;
        var prim = input[Symbol.toPrimitive];
        if (prim !== void 0) {
          var res = prim.call(input, hint || "default");
          if (typeof res !== "object")
            return res;
          throw new TypeError("@@toPrimitive must return a primitive value.");
        }
        return (hint === "string" ? String : Number)(input);
      }
      var ExternalStorage = class {
        constructor(externalStorage) {
          _defineProperty(this, "key", void 0);
          _defineProperty(this, "storage", void 0);
          this.key = externalStorage.key;
          this.storage = externalStorage;
        }
        read() {
          const result = this.storage.read();
          if (!result.ok) {
            return result;
          }
          return this.parse(result.data);
        }
        write(data) {
          this.storage.write(JSON.stringify(data));
          return (0, _tsRes.Ok)();
        }
        parse(data) {
          let result;
          try {
            result = JSON.parse(data);
          } catch (err) {
            throw new _kameleoonError.KameleoonError(_kameleoonError.KameleoonException.StorageParse, err, this.key);
          }
          return (0, _tsRes.Ok)(result);
        }
      };
      exports.ExternalStorage = ExternalStorage;
    }
  });

  // node_modules/@kameleoon/javascript-sdk-core/dist/storage/types.js
  var require_types9 = __commonJS({
    "node_modules/@kameleoon/javascript-sdk-core/dist/storage/types.js"(exports) {
      "use strict";
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
    }
  });

  // node_modules/@kameleoon/javascript-sdk-core/dist/storage/index.js
  var require_storage = __commonJS({
    "node_modules/@kameleoon/javascript-sdk-core/dist/storage/index.js"(exports) {
      "use strict";
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      Object.defineProperty(exports, "ClientDataType", {
        enumerable: true,
        get: function() {
          return _types.ClientDataType;
        }
      });
      Object.defineProperty(exports, "ExperimentVariationsType", {
        enumerable: true,
        get: function() {
          return _types.ExperimentVariationsType;
        }
      });
      Object.defineProperty(exports, "ExternalStorage", {
        enumerable: true,
        get: function() {
          return _externalStorage.ExternalStorage;
        }
      });
      Object.defineProperty(exports, "IExternalStorage", {
        enumerable: true,
        get: function() {
          return _types.IExternalStorage;
        }
      });
      Object.defineProperty(exports, "IExternalStorageConstructor", {
        enumerable: true,
        get: function() {
          return _types.IExternalStorageConstructor;
        }
      });
      Object.defineProperty(exports, "IStorage", {
        enumerable: true,
        get: function() {
          return _types.IStorage;
        }
      });
      Object.defineProperty(exports, "KameleoonStorageKey", {
        enumerable: true,
        get: function() {
          return _constants.KameleoonStorageKey;
        }
      });
      Object.defineProperty(exports, "VariationDataType", {
        enumerable: true,
        get: function() {
          return _types.VariationDataType;
        }
      });
      var _constants = require_constants7();
      var _externalStorage = require_externalStorage();
      var _types = require_types9();
    }
  });

  // node_modules/@kameleoon/javascript-sdk-core/dist/targeting/types.js
  var require_types10 = __commonJS({
    "node_modules/@kameleoon/javascript-sdk-core/dist/targeting/types.js"(exports) {
      "use strict";
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.TargetingType = exports.Operator = exports.MatchTypeVariation = exports.MatchTypeTest = exports.MatchTypeCustomData = void 0;
      var Operator = /* @__PURE__ */ function(Operator2) {
        Operator2["And"] = "AND";
        Operator2["Or"] = "OR";
        return Operator2;
      }({});
      exports.Operator = Operator;
      var MatchTypeCustomData = /* @__PURE__ */ function(MatchTypeCustomData2) {
        MatchTypeCustomData2["TRUE"] = "TRUE";
        MatchTypeCustomData2["FALSE"] = "FALSE";
        MatchTypeCustomData2["EXACT"] = "EXACT";
        MatchTypeCustomData2["CONTAINS"] = "CONTAINS";
        MatchTypeCustomData2["REGULAR_EXPRESSION"] = "REGULAR_EXPRESSION";
        MatchTypeCustomData2["EQUAL"] = "EQUAL";
        MatchTypeCustomData2["LOWER"] = "LOWER";
        MatchTypeCustomData2["GREATER"] = "GREATER";
        MatchTypeCustomData2["UNDEFINED"] = "UNDEFINED";
        MatchTypeCustomData2["AMONG_VALUES"] = "AMONG_VALUES";
        return MatchTypeCustomData2;
      }({});
      exports.MatchTypeCustomData = MatchTypeCustomData;
      var MatchTypeVariation = /* @__PURE__ */ function(MatchTypeVariation2) {
        MatchTypeVariation2["ANY"] = "ANY";
        MatchTypeVariation2["EXACT"] = "EXACT";
        return MatchTypeVariation2;
      }({});
      exports.MatchTypeVariation = MatchTypeVariation;
      var MatchTypeTest = /* @__PURE__ */ function(MatchTypeTest2) {
        MatchTypeTest2["ALL"] = "ALL";
        MatchTypeTest2["TEST"] = "TEST";
        MatchTypeTest2["PERSO"] = "PERSO";
        return MatchTypeTest2;
      }({});
      exports.MatchTypeTest = MatchTypeTest;
      var TargetingType = /* @__PURE__ */ function(TargetingType2) {
        TargetingType2["PAGE_URL"] = "PAGE_URL";
        TargetingType2["PAGE_TITLE"] = "PAGE_TITLE";
        TargetingType2["LANDING_PAGE"] = "LANDING_PAGE";
        TargetingType2["ORIGIN"] = "ORIGIN";
        TargetingType2["ORIGIN_TYPE"] = "ORIGIN_TYPE";
        TargetingType2["REFERRERS"] = "REFERRERS";
        TargetingType2["NEW_VISITORS"] = "NEW_VISITORS";
        TargetingType2["INTERESTS"] = "INTERESTS";
        TargetingType2["BROWSER_LANGUAGE"] = "BROWSER_LANGUAGE";
        TargetingType2["GEOLOCATION"] = "GEOLOCATION";
        TargetingType2["DEVICE_TYPE"] = "DEVICE_TYPE";
        TargetingType2["SCREEN_DIMENSION"] = "SCREEN_DIMENSION";
        TargetingType2["VISITOR_IP"] = "VISITOR_IP";
        TargetingType2["AD_BLOCKER"] = "AD_BLOCKER";
        TargetingType2["PREVIOUS_PAGE"] = "PREVIOUS_PAGE";
        TargetingType2["KEY_PAGES"] = "KEY_PAGES";
        TargetingType2["PAGE_VIEWS"] = "PAGE_VIEWS";
        TargetingType2["FIRST_VISIT"] = "FIRST_VISIT";
        TargetingType2["LAST_VISIT"] = "LAST_VISIT";
        TargetingType2["ACTIVE_SESSION"] = "ACTIVE_SESSION";
        TargetingType2["TIME_SINCE_PAGE_LOAD"] = "TIME_SINCE_PAGE_LOAD";
        TargetingType2["SAME_DAY_VISITS"] = "SAME_DAY_VISITS";
        TargetingType2["VISITS"] = "VISITS";
        TargetingType2["VISITS_BY_PAGE"] = "VISITS_BY_PAGE";
        TargetingType2["INTERNAL_SEARCH_KEYWORDS"] = "INTERNAL_SEARCH_KEYWORDS";
        TargetingType2["TABS_ON_SITE"] = "TABS_ON_SITE";
        TargetingType2["CONVERSION_PROBABILITY"] = "CONVERSION_PROBABILITY";
        TargetingType2["HEAT_SLICE"] = "HEAT_SLICE";
        TargetingType2["SKY_STATUS"] = "SKY_STATUS";
        TargetingType2["TEMPERATURE"] = "TEMPERATURE";
        TargetingType2["DAY_NIGHT"] = "DAY_NIGHT";
        TargetingType2["FORECAST_SKY_STATUS"] = "FORECAST_SKY_STATUS";
        TargetingType2["FORECAST_TEMPERATURE"] = "FORECAST_TEMPERATURE";
        TargetingType2["DAY_OF_WEEK"] = "DAY_OF_WEEK";
        TargetingType2["TIME_RANGE"] = "TIME_RANGE";
        TargetingType2["HOUR_MINUTE_RANGE"] = "HOUR_MINUTE_RANGE";
        TargetingType2["JS_CODE"] = "JS_CODE";
        TargetingType2["COOKIE"] = "COOKIE";
        TargetingType2["EVENT"] = "EVENT";
        TargetingType2["BROWSER"] = "BROWSER";
        TargetingType2["OPERATING_SYSTEM"] = "OPERATING_SYSTEM";
        TargetingType2["DOM_ELEMENT"] = "DOM_ELEMENT";
        TargetingType2["MOUSE_OUT"] = "MOUSE_OUT";
        TargetingType2["TARGET_EXPERIMENT"] = "TARGET_EXPERIMENT";
        TargetingType2["TARGET_PERSONALIZATION"] = "TARGET_PERSONALIZATION";
        TargetingType2["EXCLUSIVE_EXPERIMENT"] = "EXCLUSIVE_EXPERIMENT";
        TargetingType2["CONVERSIONS"] = "CONVERSIONS";
        TargetingType2["CUSTOM_DATUM"] = "CUSTOM_DATUM";
        TargetingType2["YSANCE_SEGMENT"] = "YSANCE_SEGMENT";
        TargetingType2["YSANCE_ATTRIBUT"] = "YSANCE_ATTRIBUT";
        TargetingType2["TEALIUM_BADGE"] = "TEALIUM_BADGE";
        TargetingType2["TEALIUM_AUDIENCE"] = "TEALIUM_AUDIENCE";
        TargetingType2["PRICE_OF_DISPLAYED_PAGE"] = "PRICE_OF_DISPLAYED_PAGE";
        TargetingType2["NUMBER_OF_VISITED_PAGES"] = "NUMBER_OF_VISITED_PAGES";
        TargetingType2["VISITED_PAGES"] = "VISITED_PAGES";
        TargetingType2["CUSTOM"] = "CUSTOM";
        TargetingType2["EXPLICIT_TRIGGER"] = "EXPLICIT_TRIGGER";
        return TargetingType2;
      }({});
      exports.TargetingType = TargetingType;
    }
  });

  // node_modules/@kameleoon/javascript-sdk-core/dist/targeting/conditions/customDataCondition.js
  var require_customDataCondition = __commonJS({
    "node_modules/@kameleoon/javascript-sdk-core/dist/targeting/conditions/customDataCondition.js"(exports) {
      "use strict";
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.CustomDataCondition = void 0;
      var _tsRes = require_build();
      var _kameleoonData = require_kameleoonData();
      var _kameleoonError = require_kameleoonError2();
      var _types = require_types10();
      function _defineProperty(obj, key, value) {
        key = _toPropertyKey(key);
        if (key in obj) {
          Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
        } else {
          obj[key] = value;
        }
        return obj;
      }
      function _toPropertyKey(arg) {
        var key = _toPrimitive(arg, "string");
        return typeof key === "symbol" ? key : String(key);
      }
      function _toPrimitive(input, hint) {
        if (typeof input !== "object" || input === null)
          return input;
        var prim = input[Symbol.toPrimitive];
        if (prim !== void 0) {
          var res = prim.call(input, hint || "default");
          if (typeof res !== "object")
            return res;
          throw new TypeError("@@toPrimitive must return a primitive value.");
        }
        return (hint === "string" ? String : Number)(input);
      }
      var CustomDataCondition = class {
        constructor({
          customDataIndex,
          valueMatchType,
          isInclude,
          value
        }) {
          _defineProperty(this, "customDataIndex", void 0);
          _defineProperty(this, "matchType", void 0);
          _defineProperty(this, "inverseResult", void 0);
          _defineProperty(this, "conditionValue", void 0);
          _defineProperty(this, "error", void 0);
          this.customDataIndex = Number(customDataIndex);
          this.inverseResult = !(isInclude ?? true);
          this.matchType = valueMatchType;
          this.conditionValue = value;
        }
        evaluate({
          targetingData
        }) {
          const isCustomData = (data) => data.type === _kameleoonData.KameleoonData.CustomData;
          const filteredData = targetingData.map((item) => item.data).filter(isCustomData).filter((item) => item.index === this.customDataIndex);
          if (filteredData.length) {
            const lastDataItem = filteredData[filteredData.length - 1];
            const {
              value: customDataValue
            } = lastDataItem;
            const result = this.inverseResult ? !this.checkCondition(customDataValue) : this.checkCondition(customDataValue);
            if (this.error) {
              return (0, _tsRes.Err)(this.error);
            }
            return (0, _tsRes.Ok)(result);
          }
          return (0, _tsRes.Ok)(this.matchType === _types.MatchTypeCustomData.UNDEFINED);
        }
        checkCondition(customDataValue) {
          if (this.conditionValue === null && this.matchType !== _types.MatchTypeCustomData.TRUE && this.matchType !== _types.MatchTypeCustomData.FALSE) {
            return false;
          }
          const conditionValue = this.conditionValue;
          if (this.matchType === _types.MatchTypeCustomData.AMONG_VALUES) {
            const result = this.parseArray(conditionValue);
            if (!result.ok) {
              this.error = result.error;
              return false;
            }
            const resultData = new Set(result.data);
            return Array.isArray(customDataValue) ? customDataValue.some((value) => resultData.has(value)) : result.data.includes(customDataValue);
          }
          if (Array.isArray(customDataValue)) {
            return customDataValue.some((value) => this.checkCondition(value));
          }
          switch (this.matchType) {
            case _types.MatchTypeCustomData.CONTAINS:
              return customDataValue.includes(conditionValue);
            case _types.MatchTypeCustomData.EXACT:
              return customDataValue === this.conditionValue;
            case _types.MatchTypeCustomData.REGULAR_EXPRESSION:
              return this.parseRegExp(conditionValue).test(customDataValue);
            case _types.MatchTypeCustomData.LOWER:
              return Number(customDataValue) < Number(this.conditionValue);
            case _types.MatchTypeCustomData.EQUAL:
              return Number(customDataValue) === Number(this.conditionValue);
            case _types.MatchTypeCustomData.GREATER:
              return Number(customDataValue) > Number(this.conditionValue);
            case _types.MatchTypeCustomData.TRUE:
              return customDataValue.toLowerCase() === "true";
            case _types.MatchTypeCustomData.FALSE:
              return customDataValue.toLowerCase() === "false";
            default:
              return false;
          }
        }
        parseRegExp(value) {
          if (value[0] === "/") {
            const [_, expression, flags] = value.split("/");
            return new RegExp(expression, flags);
          }
          return new RegExp(value);
        }
        parseArray(value) {
          try {
            const result = JSON.parse(value);
            if (Array.isArray(result)) {
              return (0, _tsRes.Ok)(result);
            }
          } catch (err) {
            return (0, _tsRes.Err)(new _kameleoonError.KameleoonError(_kameleoonError.KameleoonException.AmongValuesCheck, err, value));
          }
          return (0, _tsRes.Ok)([]);
        }
      };
      exports.CustomDataCondition = CustomDataCondition;
    }
  });

  // node_modules/@kameleoon/javascript-sdk-core/dist/targeting/conditions/exclusiveExperimentCondition.js
  var require_exclusiveExperimentCondition = __commonJS({
    "node_modules/@kameleoon/javascript-sdk-core/dist/targeting/conditions/exclusiveExperimentCondition.js"(exports) {
      "use strict";
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.ExclusiveExperimentCondition = void 0;
      var _tsRes = require_build();
      function _defineProperty(obj, key, value) {
        key = _toPropertyKey(key);
        if (key in obj) {
          Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
        } else {
          obj[key] = value;
        }
        return obj;
      }
      function _toPropertyKey(arg) {
        var key = _toPrimitive(arg, "string");
        return typeof key === "symbol" ? key : String(key);
      }
      function _toPrimitive(input, hint) {
        if (typeof input !== "object" || input === null)
          return input;
        var prim = input[Symbol.toPrimitive];
        if (prim !== void 0) {
          var res = prim.call(input, hint || "default");
          if (typeof res !== "object")
            return res;
          throw new TypeError("@@toPrimitive must return a primitive value.");
        }
        return (hint === "string" ? String : Number)(input);
      }
      var ExclusiveExperimentCondition = class {
        constructor({
          isInclude
        }) {
          _defineProperty(this, "inverseResult", void 0);
          this.inverseResult = !(isInclude ?? true);
        }
        evaluate({
          experimentId,
          variationData
        }) {
          const keys = Object.keys(variationData);
          const isEmpty = !keys.length;
          const isExclusive = keys.length === 1 && keys[0] === String(experimentId);
          const isSatisfied = isEmpty || isExclusive;
          return (0, _tsRes.Ok)(this.inverseResult ? !isSatisfied : isSatisfied);
        }
      };
      exports.ExclusiveExperimentCondition = ExclusiveExperimentCondition;
    }
  });

  // node_modules/@kameleoon/javascript-sdk-core/dist/targeting/conditions/targetExperimentCondition.js
  var require_targetExperimentCondition = __commonJS({
    "node_modules/@kameleoon/javascript-sdk-core/dist/targeting/conditions/targetExperimentCondition.js"(exports) {
      "use strict";
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.TargetExperimentCondition = void 0;
      var _tsRes = require_build();
      var _types = require_types10();
      function _defineProperty(obj, key, value) {
        key = _toPropertyKey(key);
        if (key in obj) {
          Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
        } else {
          obj[key] = value;
        }
        return obj;
      }
      function _toPropertyKey(arg) {
        var key = _toPrimitive(arg, "string");
        return typeof key === "symbol" ? key : String(key);
      }
      function _toPrimitive(input, hint) {
        if (typeof input !== "object" || input === null)
          return input;
        var prim = input[Symbol.toPrimitive];
        if (prim !== void 0) {
          var res = prim.call(input, hint || "default");
          if (typeof res !== "object")
            return res;
          throw new TypeError("@@toPrimitive must return a primitive value.");
        }
        return (hint === "string" ? String : Number)(input);
      }
      var TargetExperimentCondition = class {
        constructor({
          variation,
          experiment,
          isInclude,
          variationMatchType
        }) {
          _defineProperty(this, "inverseResult", void 0);
          _defineProperty(this, "experimentId", void 0);
          _defineProperty(this, "variationId", void 0);
          _defineProperty(this, "matchType", void 0);
          this.inverseResult = !(isInclude ?? true);
          this.experimentId = experiment;
          this.variationId = variation;
          this.matchType = variationMatchType;
        }
        evaluate({
          variationData
        }) {
          if (!this.experimentId) {
            return (0, _tsRes.Ok)(false);
          }
          if (this.matchType === _types.MatchTypeVariation.EXACT && !this.variationId) {
            (0, _tsRes.Ok)(false);
          }
          const result = this.checkCondition({
            variationId: this.variationId,
            experimentId: this.experimentId,
            variationData
          });
          return (0, _tsRes.Ok)(this.inverseResult ? !result : result);
        }
        checkCondition({
          variationId,
          experimentId,
          variationData
        }) {
          const experimentIdString = String(experimentId);
          const variation = variationData[experimentIdString];
          switch (this.matchType) {
            case _types.MatchTypeVariation.EXACT: {
              return variation?.variationId === variationId;
            }
            case _types.MatchTypeVariation.ANY:
              return Boolean(variation);
            default:
              return false;
          }
        }
      };
      exports.TargetExperimentCondition = TargetExperimentCondition;
    }
  });

  // node_modules/@kameleoon/javascript-sdk-core/dist/targeting/conditions/conditionFactory.js
  var require_conditionFactory = __commonJS({
    "node_modules/@kameleoon/javascript-sdk-core/dist/targeting/conditions/conditionFactory.js"(exports) {
      "use strict";
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.ConditionFactory = void 0;
      var _tsRes = require_build();
      var _kameleoonError = require_kameleoonError2();
      var _types = require_types10();
      var _customDataCondition = require_customDataCondition();
      var _exclusiveExperimentCondition = require_exclusiveExperimentCondition();
      var _targetExperimentCondition = require_targetExperimentCondition();
      var ConditionFactory = class {
        static createCondition(data) {
          const {
            targetingType
          } = data;
          switch (targetingType) {
            case _types.TargetingType.CUSTOM_DATUM:
              return (0, _tsRes.Ok)(new _customDataCondition.CustomDataCondition(data));
            case _types.TargetingType.EXCLUSIVE_EXPERIMENT:
              return (0, _tsRes.Ok)(new _exclusiveExperimentCondition.ExclusiveExperimentCondition(data));
            case _types.TargetingType.TARGET_EXPERIMENT:
              return (0, _tsRes.Ok)(new _targetExperimentCondition.TargetExperimentCondition(data));
            default:
              return (0, _tsRes.Err)(new _kameleoonError.KameleoonError(_kameleoonError.KameleoonException.TargetingCondition, targetingType));
          }
        }
      };
      exports.ConditionFactory = ConditionFactory;
    }
  });

  // node_modules/@kameleoon/javascript-sdk-core/dist/targeting/conditions/types.js
  var require_types11 = __commonJS({
    "node_modules/@kameleoon/javascript-sdk-core/dist/targeting/conditions/types.js"(exports) {
      "use strict";
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
    }
  });

  // node_modules/@kameleoon/javascript-sdk-core/dist/targeting/conditions/index.js
  var require_conditions = __commonJS({
    "node_modules/@kameleoon/javascript-sdk-core/dist/targeting/conditions/index.js"(exports) {
      "use strict";
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      Object.defineProperty(exports, "ConditionDataType", {
        enumerable: true,
        get: function() {
          return _types.ConditionDataType;
        }
      });
      Object.defineProperty(exports, "ConditionFactory", {
        enumerable: true,
        get: function() {
          return _conditionFactory.ConditionFactory;
        }
      });
      Object.defineProperty(exports, "ConditionType", {
        enumerable: true,
        get: function() {
          return _types.ConditionType;
        }
      });
      Object.defineProperty(exports, "CustomDataCondition", {
        enumerable: true,
        get: function() {
          return _customDataCondition.CustomDataCondition;
        }
      });
      Object.defineProperty(exports, "ExclusiveExperimentCondition", {
        enumerable: true,
        get: function() {
          return _exclusiveExperimentCondition.ExclusiveExperimentCondition;
        }
      });
      Object.defineProperty(exports, "TargetExperimentCondition", {
        enumerable: true,
        get: function() {
          return _targetExperimentCondition.TargetExperimentCondition;
        }
      });
      var _conditionFactory = require_conditionFactory();
      var _types = require_types11();
      var _customDataCondition = require_customDataCondition();
      var _targetExperimentCondition = require_targetExperimentCondition();
      var _exclusiveExperimentCondition = require_exclusiveExperimentCondition();
    }
  });

  // node_modules/@kameleoon/javascript-sdk-core/dist/targeting/targetingNode.js
  var require_targetingNode = __commonJS({
    "node_modules/@kameleoon/javascript-sdk-core/dist/targeting/targetingNode.js"(exports) {
      "use strict";
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.TargetingNode = void 0;
      var _conditions = require_conditions();
      var _types = require_types10();
      function _defineProperty(obj, key, value) {
        key = _toPropertyKey(key);
        if (key in obj) {
          Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
        } else {
          obj[key] = value;
        }
        return obj;
      }
      function _toPropertyKey(arg) {
        var key = _toPrimitive(arg, "string");
        return typeof key === "symbol" ? key : String(key);
      }
      function _toPrimitive(input, hint) {
        if (typeof input !== "object" || input === null)
          return input;
        var prim = input[Symbol.toPrimitive];
        if (prim !== void 0) {
          var res = prim.call(input, hint || "default");
          if (typeof res !== "object")
            return res;
          throw new TypeError("@@toPrimitive must return a primitive value.");
        }
        return (hint === "string" ? String : Number)(input);
      }
      var TargetingNode = class {
        constructor(value, left, right) {
          _defineProperty(this, "nodeValue", void 0);
          _defineProperty(this, "nodeError", void 0);
          _defineProperty(this, "leftChild", void 0);
          _defineProperty(this, "rightChild", void 0);
          if (this.isOperator(value)) {
            this.nodeValue = value;
          } else {
            const result = _conditions.ConditionFactory.createCondition(value);
            if (result.ok) {
              this.nodeValue = result.data;
            } else {
              this.nodeError = result.error;
            }
          }
          this.leftChild = left;
          this.rightChild = right;
        }
        get value() {
          return this.nodeValue;
        }
        get error() {
          return this.nodeError;
        }
        get left() {
          return this.leftChild;
        }
        get right() {
          return this.rightChild;
        }
        isOperator(value) {
          return value === _types.Operator.And || value === _types.Operator.Or;
        }
      };
      exports.TargetingNode = TargetingNode;
    }
  });

  // node_modules/@kameleoon/javascript-sdk-core/dist/targeting/targetingTree.js
  var require_targetingTree = __commonJS({
    "node_modules/@kameleoon/javascript-sdk-core/dist/targeting/targetingTree.js"(exports) {
      "use strict";
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.TargetingTree = void 0;
      var _tsRes = require_build();
      var _targetingNode = require_targetingNode();
      var _types = require_types10();
      function _defineProperty(obj, key, value) {
        key = _toPropertyKey(key);
        if (key in obj) {
          Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
        } else {
          obj[key] = value;
        }
        return obj;
      }
      function _toPropertyKey(arg) {
        var key = _toPrimitive(arg, "string");
        return typeof key === "symbol" ? key : String(key);
      }
      function _toPrimitive(input, hint) {
        if (typeof input !== "object" || input === null)
          return input;
        var prim = input[Symbol.toPrimitive];
        if (prim !== void 0) {
          var res = prim.call(input, hint || "default");
          if (typeof res !== "object")
            return res;
          throw new TypeError("@@toPrimitive must return a primitive value.");
        }
        return (hint === "string" ? String : Number)(input);
      }
      var TargetingTree = class {
        constructor(segment) {
          _defineProperty(this, "tree", void 0);
          _defineProperty(this, "error", null);
          const {
            conditions,
            operators
          } = this.flattenSegment(segment);
          const nodes = conditions.map((condition) => new _targetingNode.TargetingNode(condition));
          for (const operator of operators) {
            const left = nodes.shift();
            const right = nodes.shift();
            nodes.unshift(new _targetingNode.TargetingNode(operator, left, right));
          }
          this.tree = nodes[0];
        }
        evaluate(data) {
          const result = this.evaluateNode(this.tree, data);
          if (this.error) {
            return (0, _tsRes.Err)(this.error);
          }
          return (0, _tsRes.Ok)(result);
        }
        evaluateNode(node, data) {
          if (this.isLeafNode(node)) {
            if (node.error) {
              return false;
            }
            const result = node.value.evaluate(data);
            if (!result.ok) {
              this.error = result.error;
              return false;
            }
            return result.data;
          }
          if (this.isNonLeafNode(node)) {
            switch (node.value) {
              case _types.Operator.And: {
                return this.evaluateNode(node.left, data) && this.evaluateNode(node.right, data);
              }
              case _types.Operator.Or: {
                return this.evaluateNode(node.left, data) || this.evaluateNode(node.right, data);
              }
              default:
                break;
            }
          }
          return false;
        }
        isLeafNode(node) {
          return !Boolean(node.left && node.right);
        }
        isNonLeafNode(node) {
          return Boolean(node.left && node.right && (node.value === _types.Operator.Or || node.value === _types.Operator.And));
        }
        flattenSegment(segment) {
          const {
            firstLevel: conditions,
            firstLevelOrOperators: operators
          } = segment.conditionsData;
          const resultOperators = [...operators];
          const resultConditions = [];
          conditions.forEach((condition) => {
            const {
              conditions: conditionList,
              orOperators
            } = condition;
            if (orOperators.length) {
              orOperators.forEach((item) => resultOperators.unshift(item));
              conditionList.forEach((item) => resultConditions.unshift(item));
            } else {
              conditionList.forEach((item) => resultConditions.push(item));
            }
          });
          const convertedOperators = resultOperators.map((operator) => operator ? _types.Operator.Or : _types.Operator.And);
          return {
            conditions: resultConditions,
            operators: convertedOperators
          };
        }
      };
      exports.TargetingTree = TargetingTree;
    }
  });

  // node_modules/@kameleoon/javascript-sdk-core/dist/targeting/index.js
  var require_targeting = __commonJS({
    "node_modules/@kameleoon/javascript-sdk-core/dist/targeting/index.js"(exports) {
      "use strict";
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      Object.defineProperty(exports, "CustomDataCondition", {
        enumerable: true,
        get: function() {
          return _conditions.CustomDataCondition;
        }
      });
      Object.defineProperty(exports, "EvaluationDataType", {
        enumerable: true,
        get: function() {
          return _types.EvaluationDataType;
        }
      });
      Object.defineProperty(exports, "ExclusiveExperimentCondition", {
        enumerable: true,
        get: function() {
          return _conditions.ExclusiveExperimentCondition;
        }
      });
      Object.defineProperty(exports, "MatchTypeCustomData", {
        enumerable: true,
        get: function() {
          return _types.MatchTypeCustomData;
        }
      });
      Object.defineProperty(exports, "MatchTypeVariation", {
        enumerable: true,
        get: function() {
          return _types.MatchTypeVariation;
        }
      });
      Object.defineProperty(exports, "Operator", {
        enumerable: true,
        get: function() {
          return _types.Operator;
        }
      });
      Object.defineProperty(exports, "SegmentType", {
        enumerable: true,
        get: function() {
          return _types.SegmentType;
        }
      });
      Object.defineProperty(exports, "TargetExperimentCondition", {
        enumerable: true,
        get: function() {
          return _conditions.TargetExperimentCondition;
        }
      });
      Object.defineProperty(exports, "TargetingDataItemType", {
        enumerable: true,
        get: function() {
          return _types.TargetingDataItemType;
        }
      });
      Object.defineProperty(exports, "TargetingDataType", {
        enumerable: true,
        get: function() {
          return _types.TargetingDataType;
        }
      });
      Object.defineProperty(exports, "TargetingTree", {
        enumerable: true,
        get: function() {
          return _targetingTree.TargetingTree;
        }
      });
      Object.defineProperty(exports, "TargetingType", {
        enumerable: true,
        get: function() {
          return _types.TargetingType;
        }
      });
      var _targetingTree = require_targetingTree();
      var _types = require_types10();
      var _conditions = require_conditions();
    }
  });

  // node_modules/@kameleoon/javascript-sdk-core/dist/utilities/constants.js
  var require_constants8 = __commonJS({
    "node_modules/@kameleoon/javascript-sdk-core/dist/utilities/constants.js"(exports) {
      "use strict";
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.VISITOR_CODE_MAX_LENGTH = void 0;
      var VISITOR_CODE_MAX_LENGTH = 255;
      exports.VISITOR_CODE_MAX_LENGTH = VISITOR_CODE_MAX_LENGTH;
    }
  });

  // node_modules/@kameleoon/javascript-sdk-core/dist/utilities/utilities.js
  var require_utilities = __commonJS({
    "node_modules/@kameleoon/javascript-sdk-core/dist/utilities/utilities.js"(exports) {
      "use strict";
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.Utilities = void 0;
      var _tsRes = require_build();
      var _kameleoonError = require_kameleoonError2();
      var _types = require_types();
      var _targeting = require_targeting();
      var _constants = require_constants8();
      var _kameleoonData = require_kameleoonData();
      var _constants2 = require_constants6();
      function ownKeys(object, enumerableOnly) {
        var keys = Object.keys(object);
        if (Object.getOwnPropertySymbols) {
          var symbols = Object.getOwnPropertySymbols(object);
          enumerableOnly && (symbols = symbols.filter(function(sym) {
            return Object.getOwnPropertyDescriptor(object, sym).enumerable;
          })), keys.push.apply(keys, symbols);
        }
        return keys;
      }
      function _objectSpread(target) {
        for (var i = 1; i < arguments.length; i++) {
          var source = null != arguments[i] ? arguments[i] : {};
          i % 2 ? ownKeys(Object(source), true).forEach(function(key) {
            _defineProperty(target, key, source[key]);
          }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function(key) {
            Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
          });
        }
        return target;
      }
      function _defineProperty(obj, key, value) {
        key = _toPropertyKey(key);
        if (key in obj) {
          Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
        } else {
          obj[key] = value;
        }
        return obj;
      }
      function _toPropertyKey(arg) {
        var key = _toPrimitive(arg, "string");
        return typeof key === "symbol" ? key : String(key);
      }
      function _toPrimitive(input, hint) {
        if (typeof input !== "object" || input === null)
          return input;
        var prim = input[Symbol.toPrimitive];
        if (prim !== void 0) {
          var res = prim.call(input, hint || "default");
          if (typeof res !== "object")
            return res;
          throw new TypeError("@@toPrimitive must return a primitive value.");
        }
        return (hint === "string" ? String : Number)(input);
      }
      var Utilities = class {
        static checkTargeting({
          segment,
          visitorCode,
          targetingData,
          experimentId,
          variationConfiguration
        }) {
          if (!segment || !segment.conditionsData.firstLevel.length) {
            return (0, _tsRes.Ok)(true);
          }
          if (!variationConfiguration) {
            return (0, _tsRes.Err)(new _kameleoonError.KameleoonError(_kameleoonError.KameleoonException.Initialization));
          }
          let variations = {};
          const assignedVariationsResult = variationConfiguration.getAssignedVariations(visitorCode);
          if (assignedVariationsResult.ok) {
            variations = assignedVariationsResult.data;
          }
          const targetingTree = new _targeting.TargetingTree(segment);
          const result = targetingTree.evaluate({
            targetingData: targetingData || [],
            variationData: variations,
            experimentId
          });
          return result;
        }
        static validateVisitorCode(visitorCode) {
          if (visitorCode.length === 0) {
            return (0, _tsRes.Err)(new _kameleoonError.KameleoonError(_kameleoonError.KameleoonException.VisitorCodeEmpty));
          }
          if (visitorCode.length > _constants.VISITOR_CODE_MAX_LENGTH) {
            return (0, _tsRes.Err)(new _kameleoonError.KameleoonError(_kameleoonError.KameleoonException.VisitorCodeMaxLength));
          }
          return (0, _tsRes.Ok)();
        }
        static getDataUrl(visitorCode, campaignConfiguration) {
          const unsentData = campaignConfiguration.getUnsentData(visitorCode);
          return unsentData.map((item) => item.url).join("\n");
        }
        static trackRule({
          featureFlagVariation,
          campaignConfiguration,
          visitorCode,
          requester,
          userAgent
        }) {
          const {
            variationId,
            rule
          } = featureFlagVariation;
          const dataUrl = this.getDataUrl(visitorCode, campaignConfiguration);
          const resultVariationId = variationId || 0;
          const isUnallocated = variationId === null;
          const experimentId = rule ? rule.experimentId : 0;
          const callback = () => campaignConfiguration.clearUnsentData;
          requester.trackExperiment({
            visitorCode,
            isUnallocated,
            body: dataUrl,
            callback,
            experimentId,
            variationId: resultVariationId,
            userAgent
          });
        }
        static parseFeatureVariable(variable) {
          const {
            type,
            value
          } = variable;
          switch (type) {
            case _types.VariableType.BOOLEAN:
              return (0, _tsRes.Ok)({
                type,
                value: Boolean(value)
              });
            case _types.VariableType.STRING:
              return (0, _tsRes.Ok)({
                type,
                value: String(value)
              });
            case _types.VariableType.NUMBER:
              const numberValue = Number(value);
              if (Number.isNaN(numberValue)) {
                return (0, _tsRes.Err)(new _kameleoonError.KameleoonError(_kameleoonError.KameleoonException.NumberParse, String(value)));
              }
              return (0, _tsRes.Ok)({
                type,
                value: numberValue
              });
            case _types.VariableType.JSON:
              try {
                const jsonValue = JSON.parse(String(variable.value));
                return (0, _tsRes.Ok)({
                  type,
                  value: jsonValue
                });
              } catch (err) {
                return (0, _tsRes.Err)(new _kameleoonError.KameleoonError(_kameleoonError.KameleoonException.JSONParse, err));
              }
            default:
              (0, _kameleoonError.exhaustCheck)(type);
          }
        }
        static parseVisitorData(data) {
          const {
            currentVisit,
            previousVisits
          } = data;
          let visits;
          if (currentVisit) {
            visits = [currentVisit];
          } else if (previousVisits) {
            visits = previousVisits;
          }
          if (!visits) {
            return [];
          }
          const indexMap = /* @__PURE__ */ new Map();
          const resultData = [];
          const customDataEvents = [...visits[0].customDataEvents];
          customDataEvents.sort((a, b) => b.time - a.time);
          for (const customDataEvent of customDataEvents) {
            const customDataIndex = customDataEvent.data.index;
            if (!indexMap.has(customDataIndex)) {
              indexMap.set(customDataIndex, true);
              const values = Object.keys(customDataEvent.data.valuesCountMap);
              resultData.push(new _kameleoonData.CustomData(customDataIndex, ...values));
            }
          }
          return resultData;
        }
        static getUserAgent(visitorCode, campaignConfiguration) {
          const isUserAgent = (data) => data.type === _kameleoonData.KameleoonData.UserAgent;
          const targetingData = campaignConfiguration.storedTargetingData[visitorCode];
          if (targetingData) {
            const filteredData = targetingData.map((item) => item.data).filter(isUserAgent);
            if (filteredData.length) {
              const [userAgentData] = filteredData;
              return userAgentData.value;
            }
          }
          return void 0;
        }
        static updateCache({
          cacheManager,
          visitorCode,
          experimentId,
          variationId
        }) {
          const cacheData = cacheManager.getAliveItem(visitorCode);
          const newCacheData = cacheData ? _objectSpread({}, cacheData) : {};
          newCacheData[experimentId] = {
            variationId,
            expirationTime: Date.now() + _constants2.CACHE_ITEM_LIFETIME * _types.Milliseconds.Second
          };
          cacheManager.add({
            key: visitorCode,
            data: newCacheData,
            lifetime: _constants2.CACHE_ITEM_LIFETIME
          });
        }
        static getTrackingCode(trackingCache, visitorCode) {
          let resultString = "window.kameleoonQueue=window.kameleoonQueue||[];";
          const cacheData = trackingCache.getAliveItem(visitorCode);
          if (!cacheData) {
            return resultString;
          }
          const updatedCacheData = {};
          Object.entries(cacheData).forEach(([experimentId, {
            variationId,
            expirationTime
          }]) => {
            if (expirationTime > Date.now()) {
              resultString += `window.kameleoonQueue.push(['Experiments.assignVariation',${experimentId},${variationId}]);`;
              resultString += `window.kameleoonQueue.push(['Experiments.trigger',${experimentId},true]);`;
              updatedCacheData[Number(experimentId)] = {
                variationId,
                expirationTime
              };
            }
          });
          trackingCache.add({
            key: visitorCode,
            data: updatedCacheData,
            lifetime: _constants2.CACHE_ITEM_LIFETIME
          });
          return resultString;
        }
      };
      exports.Utilities = Utilities;
    }
  });

  // node_modules/@kameleoon/javascript-sdk-core/dist/utilities/index.js
  var require_utilities2 = __commonJS({
    "node_modules/@kameleoon/javascript-sdk-core/dist/utilities/index.js"(exports) {
      "use strict";
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      Object.defineProperty(exports, "Utilities", {
        enumerable: true,
        get: function() {
          return _utilities.Utilities;
        }
      });
      var _utilities = require_utilities();
    }
  });

  // (disabled):crypto
  var require_crypto = __commonJS({
    "(disabled):crypto"() {
    }
  });

  // node_modules/crypto-js/core.js
  var require_core = __commonJS({
    "node_modules/crypto-js/core.js"(exports, module) {
      (function(root, factory) {
        if (typeof exports === "object") {
          module.exports = exports = factory();
        } else if (typeof define === "function" && define.amd) {
          define([], factory);
        } else {
          root.CryptoJS = factory();
        }
      })(exports, function() {
        var CryptoJS = CryptoJS || function(Math2, undefined2) {
          var crypto;
          if (typeof window !== "undefined" && window.crypto) {
            crypto = window.crypto;
          }
          if (typeof self !== "undefined" && self.crypto) {
            crypto = self.crypto;
          }
          if (typeof globalThis !== "undefined" && globalThis.crypto) {
            crypto = globalThis.crypto;
          }
          if (!crypto && typeof window !== "undefined" && window.msCrypto) {
            crypto = window.msCrypto;
          }
          if (!crypto && typeof global !== "undefined" && global.crypto) {
            crypto = global.crypto;
          }
          if (!crypto && typeof __require === "function") {
            try {
              crypto = require_crypto();
            } catch (err) {
            }
          }
          var cryptoSecureRandomInt = function() {
            if (crypto) {
              if (typeof crypto.getRandomValues === "function") {
                try {
                  return crypto.getRandomValues(new Uint32Array(1))[0];
                } catch (err) {
                }
              }
              if (typeof crypto.randomBytes === "function") {
                try {
                  return crypto.randomBytes(4).readInt32LE();
                } catch (err) {
                }
              }
            }
            throw new Error("Native crypto module could not be used to get secure random number.");
          };
          var create = Object.create || function() {
            function F() {
            }
            return function(obj) {
              var subtype;
              F.prototype = obj;
              subtype = new F();
              F.prototype = null;
              return subtype;
            };
          }();
          var C = {};
          var C_lib = C.lib = {};
          var Base = C_lib.Base = function() {
            return {
              /**
               * Creates a new object that inherits from this object.
               *
               * @param {Object} overrides Properties to copy into the new object.
               *
               * @return {Object} The new object.
               *
               * @static
               *
               * @example
               *
               *     var MyType = CryptoJS.lib.Base.extend({
               *         field: 'value',
               *
               *         method: function () {
               *         }
               *     });
               */
              extend: function(overrides) {
                var subtype = create(this);
                if (overrides) {
                  subtype.mixIn(overrides);
                }
                if (!subtype.hasOwnProperty("init") || this.init === subtype.init) {
                  subtype.init = function() {
                    subtype.$super.init.apply(this, arguments);
                  };
                }
                subtype.init.prototype = subtype;
                subtype.$super = this;
                return subtype;
              },
              /**
               * Extends this object and runs the init method.
               * Arguments to create() will be passed to init().
               *
               * @return {Object} The new object.
               *
               * @static
               *
               * @example
               *
               *     var instance = MyType.create();
               */
              create: function() {
                var instance = this.extend();
                instance.init.apply(instance, arguments);
                return instance;
              },
              /**
               * Initializes a newly created object.
               * Override this method to add some logic when your objects are created.
               *
               * @example
               *
               *     var MyType = CryptoJS.lib.Base.extend({
               *         init: function () {
               *             // ...
               *         }
               *     });
               */
              init: function() {
              },
              /**
               * Copies properties into this object.
               *
               * @param {Object} properties The properties to mix in.
               *
               * @example
               *
               *     MyType.mixIn({
               *         field: 'value'
               *     });
               */
              mixIn: function(properties) {
                for (var propertyName in properties) {
                  if (properties.hasOwnProperty(propertyName)) {
                    this[propertyName] = properties[propertyName];
                  }
                }
                if (properties.hasOwnProperty("toString")) {
                  this.toString = properties.toString;
                }
              },
              /**
               * Creates a copy of this object.
               *
               * @return {Object} The clone.
               *
               * @example
               *
               *     var clone = instance.clone();
               */
              clone: function() {
                return this.init.prototype.extend(this);
              }
            };
          }();
          var WordArray = C_lib.WordArray = Base.extend({
            /**
             * Initializes a newly created word array.
             *
             * @param {Array} words (Optional) An array of 32-bit words.
             * @param {number} sigBytes (Optional) The number of significant bytes in the words.
             *
             * @example
             *
             *     var wordArray = CryptoJS.lib.WordArray.create();
             *     var wordArray = CryptoJS.lib.WordArray.create([0x00010203, 0x04050607]);
             *     var wordArray = CryptoJS.lib.WordArray.create([0x00010203, 0x04050607], 6);
             */
            init: function(words, sigBytes) {
              words = this.words = words || [];
              if (sigBytes != undefined2) {
                this.sigBytes = sigBytes;
              } else {
                this.sigBytes = words.length * 4;
              }
            },
            /**
             * Converts this word array to a string.
             *
             * @param {Encoder} encoder (Optional) The encoding strategy to use. Default: CryptoJS.enc.Hex
             *
             * @return {string} The stringified word array.
             *
             * @example
             *
             *     var string = wordArray + '';
             *     var string = wordArray.toString();
             *     var string = wordArray.toString(CryptoJS.enc.Utf8);
             */
            toString: function(encoder) {
              return (encoder || Hex).stringify(this);
            },
            /**
             * Concatenates a word array to this word array.
             *
             * @param {WordArray} wordArray The word array to append.
             *
             * @return {WordArray} This word array.
             *
             * @example
             *
             *     wordArray1.concat(wordArray2);
             */
            concat: function(wordArray) {
              var thisWords = this.words;
              var thatWords = wordArray.words;
              var thisSigBytes = this.sigBytes;
              var thatSigBytes = wordArray.sigBytes;
              this.clamp();
              if (thisSigBytes % 4) {
                for (var i = 0; i < thatSigBytes; i++) {
                  var thatByte = thatWords[i >>> 2] >>> 24 - i % 4 * 8 & 255;
                  thisWords[thisSigBytes + i >>> 2] |= thatByte << 24 - (thisSigBytes + i) % 4 * 8;
                }
              } else {
                for (var j = 0; j < thatSigBytes; j += 4) {
                  thisWords[thisSigBytes + j >>> 2] = thatWords[j >>> 2];
                }
              }
              this.sigBytes += thatSigBytes;
              return this;
            },
            /**
             * Removes insignificant bits.
             *
             * @example
             *
             *     wordArray.clamp();
             */
            clamp: function() {
              var words = this.words;
              var sigBytes = this.sigBytes;
              words[sigBytes >>> 2] &= 4294967295 << 32 - sigBytes % 4 * 8;
              words.length = Math2.ceil(sigBytes / 4);
            },
            /**
             * Creates a copy of this word array.
             *
             * @return {WordArray} The clone.
             *
             * @example
             *
             *     var clone = wordArray.clone();
             */
            clone: function() {
              var clone = Base.clone.call(this);
              clone.words = this.words.slice(0);
              return clone;
            },
            /**
             * Creates a word array filled with random bytes.
             *
             * @param {number} nBytes The number of random bytes to generate.
             *
             * @return {WordArray} The random word array.
             *
             * @static
             *
             * @example
             *
             *     var wordArray = CryptoJS.lib.WordArray.random(16);
             */
            random: function(nBytes) {
              var words = [];
              for (var i = 0; i < nBytes; i += 4) {
                words.push(cryptoSecureRandomInt());
              }
              return new WordArray.init(words, nBytes);
            }
          });
          var C_enc = C.enc = {};
          var Hex = C_enc.Hex = {
            /**
             * Converts a word array to a hex string.
             *
             * @param {WordArray} wordArray The word array.
             *
             * @return {string} The hex string.
             *
             * @static
             *
             * @example
             *
             *     var hexString = CryptoJS.enc.Hex.stringify(wordArray);
             */
            stringify: function(wordArray) {
              var words = wordArray.words;
              var sigBytes = wordArray.sigBytes;
              var hexChars = [];
              for (var i = 0; i < sigBytes; i++) {
                var bite = words[i >>> 2] >>> 24 - i % 4 * 8 & 255;
                hexChars.push((bite >>> 4).toString(16));
                hexChars.push((bite & 15).toString(16));
              }
              return hexChars.join("");
            },
            /**
             * Converts a hex string to a word array.
             *
             * @param {string} hexStr The hex string.
             *
             * @return {WordArray} The word array.
             *
             * @static
             *
             * @example
             *
             *     var wordArray = CryptoJS.enc.Hex.parse(hexString);
             */
            parse: function(hexStr) {
              var hexStrLength = hexStr.length;
              var words = [];
              for (var i = 0; i < hexStrLength; i += 2) {
                words[i >>> 3] |= parseInt(hexStr.substr(i, 2), 16) << 24 - i % 8 * 4;
              }
              return new WordArray.init(words, hexStrLength / 2);
            }
          };
          var Latin1 = C_enc.Latin1 = {
            /**
             * Converts a word array to a Latin1 string.
             *
             * @param {WordArray} wordArray The word array.
             *
             * @return {string} The Latin1 string.
             *
             * @static
             *
             * @example
             *
             *     var latin1String = CryptoJS.enc.Latin1.stringify(wordArray);
             */
            stringify: function(wordArray) {
              var words = wordArray.words;
              var sigBytes = wordArray.sigBytes;
              var latin1Chars = [];
              for (var i = 0; i < sigBytes; i++) {
                var bite = words[i >>> 2] >>> 24 - i % 4 * 8 & 255;
                latin1Chars.push(String.fromCharCode(bite));
              }
              return latin1Chars.join("");
            },
            /**
             * Converts a Latin1 string to a word array.
             *
             * @param {string} latin1Str The Latin1 string.
             *
             * @return {WordArray} The word array.
             *
             * @static
             *
             * @example
             *
             *     var wordArray = CryptoJS.enc.Latin1.parse(latin1String);
             */
            parse: function(latin1Str) {
              var latin1StrLength = latin1Str.length;
              var words = [];
              for (var i = 0; i < latin1StrLength; i++) {
                words[i >>> 2] |= (latin1Str.charCodeAt(i) & 255) << 24 - i % 4 * 8;
              }
              return new WordArray.init(words, latin1StrLength);
            }
          };
          var Utf8 = C_enc.Utf8 = {
            /**
             * Converts a word array to a UTF-8 string.
             *
             * @param {WordArray} wordArray The word array.
             *
             * @return {string} The UTF-8 string.
             *
             * @static
             *
             * @example
             *
             *     var utf8String = CryptoJS.enc.Utf8.stringify(wordArray);
             */
            stringify: function(wordArray) {
              try {
                return decodeURIComponent(escape(Latin1.stringify(wordArray)));
              } catch (e) {
                throw new Error("Malformed UTF-8 data");
              }
            },
            /**
             * Converts a UTF-8 string to a word array.
             *
             * @param {string} utf8Str The UTF-8 string.
             *
             * @return {WordArray} The word array.
             *
             * @static
             *
             * @example
             *
             *     var wordArray = CryptoJS.enc.Utf8.parse(utf8String);
             */
            parse: function(utf8Str) {
              return Latin1.parse(unescape(encodeURIComponent(utf8Str)));
            }
          };
          var BufferedBlockAlgorithm = C_lib.BufferedBlockAlgorithm = Base.extend({
            /**
             * Resets this block algorithm's data buffer to its initial state.
             *
             * @example
             *
             *     bufferedBlockAlgorithm.reset();
             */
            reset: function() {
              this._data = new WordArray.init();
              this._nDataBytes = 0;
            },
            /**
             * Adds new data to this block algorithm's buffer.
             *
             * @param {WordArray|string} data The data to append. Strings are converted to a WordArray using UTF-8.
             *
             * @example
             *
             *     bufferedBlockAlgorithm._append('data');
             *     bufferedBlockAlgorithm._append(wordArray);
             */
            _append: function(data) {
              if (typeof data == "string") {
                data = Utf8.parse(data);
              }
              this._data.concat(data);
              this._nDataBytes += data.sigBytes;
            },
            /**
             * Processes available data blocks.
             *
             * This method invokes _doProcessBlock(offset), which must be implemented by a concrete subtype.
             *
             * @param {boolean} doFlush Whether all blocks and partial blocks should be processed.
             *
             * @return {WordArray} The processed data.
             *
             * @example
             *
             *     var processedData = bufferedBlockAlgorithm._process();
             *     var processedData = bufferedBlockAlgorithm._process(!!'flush');
             */
            _process: function(doFlush) {
              var processedWords;
              var data = this._data;
              var dataWords = data.words;
              var dataSigBytes = data.sigBytes;
              var blockSize = this.blockSize;
              var blockSizeBytes = blockSize * 4;
              var nBlocksReady = dataSigBytes / blockSizeBytes;
              if (doFlush) {
                nBlocksReady = Math2.ceil(nBlocksReady);
              } else {
                nBlocksReady = Math2.max((nBlocksReady | 0) - this._minBufferSize, 0);
              }
              var nWordsReady = nBlocksReady * blockSize;
              var nBytesReady = Math2.min(nWordsReady * 4, dataSigBytes);
              if (nWordsReady) {
                for (var offset = 0; offset < nWordsReady; offset += blockSize) {
                  this._doProcessBlock(dataWords, offset);
                }
                processedWords = dataWords.splice(0, nWordsReady);
                data.sigBytes -= nBytesReady;
              }
              return new WordArray.init(processedWords, nBytesReady);
            },
            /**
             * Creates a copy of this object.
             *
             * @return {Object} The clone.
             *
             * @example
             *
             *     var clone = bufferedBlockAlgorithm.clone();
             */
            clone: function() {
              var clone = Base.clone.call(this);
              clone._data = this._data.clone();
              return clone;
            },
            _minBufferSize: 0
          });
          var Hasher = C_lib.Hasher = BufferedBlockAlgorithm.extend({
            /**
             * Configuration options.
             */
            cfg: Base.extend(),
            /**
             * Initializes a newly created hasher.
             *
             * @param {Object} cfg (Optional) The configuration options to use for this hash computation.
             *
             * @example
             *
             *     var hasher = CryptoJS.algo.SHA256.create();
             */
            init: function(cfg) {
              this.cfg = this.cfg.extend(cfg);
              this.reset();
            },
            /**
             * Resets this hasher to its initial state.
             *
             * @example
             *
             *     hasher.reset();
             */
            reset: function() {
              BufferedBlockAlgorithm.reset.call(this);
              this._doReset();
            },
            /**
             * Updates this hasher with a message.
             *
             * @param {WordArray|string} messageUpdate The message to append.
             *
             * @return {Hasher} This hasher.
             *
             * @example
             *
             *     hasher.update('message');
             *     hasher.update(wordArray);
             */
            update: function(messageUpdate) {
              this._append(messageUpdate);
              this._process();
              return this;
            },
            /**
             * Finalizes the hash computation.
             * Note that the finalize operation is effectively a destructive, read-once operation.
             *
             * @param {WordArray|string} messageUpdate (Optional) A final message update.
             *
             * @return {WordArray} The hash.
             *
             * @example
             *
             *     var hash = hasher.finalize();
             *     var hash = hasher.finalize('message');
             *     var hash = hasher.finalize(wordArray);
             */
            finalize: function(messageUpdate) {
              if (messageUpdate) {
                this._append(messageUpdate);
              }
              var hash = this._doFinalize();
              return hash;
            },
            blockSize: 512 / 32,
            /**
             * Creates a shortcut function to a hasher's object interface.
             *
             * @param {Hasher} hasher The hasher to create a helper for.
             *
             * @return {Function} The shortcut function.
             *
             * @static
             *
             * @example
             *
             *     var SHA256 = CryptoJS.lib.Hasher._createHelper(CryptoJS.algo.SHA256);
             */
            _createHelper: function(hasher) {
              return function(message, cfg) {
                return new hasher.init(cfg).finalize(message);
              };
            },
            /**
             * Creates a shortcut function to the HMAC's object interface.
             *
             * @param {Hasher} hasher The hasher to use in this HMAC helper.
             *
             * @return {Function} The shortcut function.
             *
             * @static
             *
             * @example
             *
             *     var HmacSHA256 = CryptoJS.lib.Hasher._createHmacHelper(CryptoJS.algo.SHA256);
             */
            _createHmacHelper: function(hasher) {
              return function(message, key) {
                return new C_algo.HMAC.init(hasher, key).finalize(message);
              };
            }
          });
          var C_algo = C.algo = {};
          return C;
        }(Math);
        return CryptoJS;
      });
    }
  });

  // node_modules/crypto-js/x64-core.js
  var require_x64_core = __commonJS({
    "node_modules/crypto-js/x64-core.js"(exports, module) {
      (function(root, factory) {
        if (typeof exports === "object") {
          module.exports = exports = factory(require_core());
        } else if (typeof define === "function" && define.amd) {
          define(["./core"], factory);
        } else {
          factory(root.CryptoJS);
        }
      })(exports, function(CryptoJS) {
        (function(undefined2) {
          var C = CryptoJS;
          var C_lib = C.lib;
          var Base = C_lib.Base;
          var X32WordArray = C_lib.WordArray;
          var C_x64 = C.x64 = {};
          var X64Word = C_x64.Word = Base.extend({
            /**
             * Initializes a newly created 64-bit word.
             *
             * @param {number} high The high 32 bits.
             * @param {number} low The low 32 bits.
             *
             * @example
             *
             *     var x64Word = CryptoJS.x64.Word.create(0x00010203, 0x04050607);
             */
            init: function(high, low) {
              this.high = high;
              this.low = low;
            }
            /**
             * Bitwise NOTs this word.
             *
             * @return {X64Word} A new x64-Word object after negating.
             *
             * @example
             *
             *     var negated = x64Word.not();
             */
            // not: function () {
            // var high = ~this.high;
            // var low = ~this.low;
            // return X64Word.create(high, low);
            // },
            /**
             * Bitwise ANDs this word with the passed word.
             *
             * @param {X64Word} word The x64-Word to AND with this word.
             *
             * @return {X64Word} A new x64-Word object after ANDing.
             *
             * @example
             *
             *     var anded = x64Word.and(anotherX64Word);
             */
            // and: function (word) {
            // var high = this.high & word.high;
            // var low = this.low & word.low;
            // return X64Word.create(high, low);
            // },
            /**
             * Bitwise ORs this word with the passed word.
             *
             * @param {X64Word} word The x64-Word to OR with this word.
             *
             * @return {X64Word} A new x64-Word object after ORing.
             *
             * @example
             *
             *     var ored = x64Word.or(anotherX64Word);
             */
            // or: function (word) {
            // var high = this.high | word.high;
            // var low = this.low | word.low;
            // return X64Word.create(high, low);
            // },
            /**
             * Bitwise XORs this word with the passed word.
             *
             * @param {X64Word} word The x64-Word to XOR with this word.
             *
             * @return {X64Word} A new x64-Word object after XORing.
             *
             * @example
             *
             *     var xored = x64Word.xor(anotherX64Word);
             */
            // xor: function (word) {
            // var high = this.high ^ word.high;
            // var low = this.low ^ word.low;
            // return X64Word.create(high, low);
            // },
            /**
             * Shifts this word n bits to the left.
             *
             * @param {number} n The number of bits to shift.
             *
             * @return {X64Word} A new x64-Word object after shifting.
             *
             * @example
             *
             *     var shifted = x64Word.shiftL(25);
             */
            // shiftL: function (n) {
            // if (n < 32) {
            // var high = (this.high << n) | (this.low >>> (32 - n));
            // var low = this.low << n;
            // } else {
            // var high = this.low << (n - 32);
            // var low = 0;
            // }
            // return X64Word.create(high, low);
            // },
            /**
             * Shifts this word n bits to the right.
             *
             * @param {number} n The number of bits to shift.
             *
             * @return {X64Word} A new x64-Word object after shifting.
             *
             * @example
             *
             *     var shifted = x64Word.shiftR(7);
             */
            // shiftR: function (n) {
            // if (n < 32) {
            // var low = (this.low >>> n) | (this.high << (32 - n));
            // var high = this.high >>> n;
            // } else {
            // var low = this.high >>> (n - 32);
            // var high = 0;
            // }
            // return X64Word.create(high, low);
            // },
            /**
             * Rotates this word n bits to the left.
             *
             * @param {number} n The number of bits to rotate.
             *
             * @return {X64Word} A new x64-Word object after rotating.
             *
             * @example
             *
             *     var rotated = x64Word.rotL(25);
             */
            // rotL: function (n) {
            // return this.shiftL(n).or(this.shiftR(64 - n));
            // },
            /**
             * Rotates this word n bits to the right.
             *
             * @param {number} n The number of bits to rotate.
             *
             * @return {X64Word} A new x64-Word object after rotating.
             *
             * @example
             *
             *     var rotated = x64Word.rotR(7);
             */
            // rotR: function (n) {
            // return this.shiftR(n).or(this.shiftL(64 - n));
            // },
            /**
             * Adds this word with the passed word.
             *
             * @param {X64Word} word The x64-Word to add with this word.
             *
             * @return {X64Word} A new x64-Word object after adding.
             *
             * @example
             *
             *     var added = x64Word.add(anotherX64Word);
             */
            // add: function (word) {
            // var low = (this.low + word.low) | 0;
            // var carry = (low >>> 0) < (this.low >>> 0) ? 1 : 0;
            // var high = (this.high + word.high + carry) | 0;
            // return X64Word.create(high, low);
            // }
          });
          var X64WordArray = C_x64.WordArray = Base.extend({
            /**
             * Initializes a newly created word array.
             *
             * @param {Array} words (Optional) An array of CryptoJS.x64.Word objects.
             * @param {number} sigBytes (Optional) The number of significant bytes in the words.
             *
             * @example
             *
             *     var wordArray = CryptoJS.x64.WordArray.create();
             *
             *     var wordArray = CryptoJS.x64.WordArray.create([
             *         CryptoJS.x64.Word.create(0x00010203, 0x04050607),
             *         CryptoJS.x64.Word.create(0x18191a1b, 0x1c1d1e1f)
             *     ]);
             *
             *     var wordArray = CryptoJS.x64.WordArray.create([
             *         CryptoJS.x64.Word.create(0x00010203, 0x04050607),
             *         CryptoJS.x64.Word.create(0x18191a1b, 0x1c1d1e1f)
             *     ], 10);
             */
            init: function(words, sigBytes) {
              words = this.words = words || [];
              if (sigBytes != undefined2) {
                this.sigBytes = sigBytes;
              } else {
                this.sigBytes = words.length * 8;
              }
            },
            /**
             * Converts this 64-bit word array to a 32-bit word array.
             *
             * @return {CryptoJS.lib.WordArray} This word array's data as a 32-bit word array.
             *
             * @example
             *
             *     var x32WordArray = x64WordArray.toX32();
             */
            toX32: function() {
              var x64Words = this.words;
              var x64WordsLength = x64Words.length;
              var x32Words = [];
              for (var i = 0; i < x64WordsLength; i++) {
                var x64Word = x64Words[i];
                x32Words.push(x64Word.high);
                x32Words.push(x64Word.low);
              }
              return X32WordArray.create(x32Words, this.sigBytes);
            },
            /**
             * Creates a copy of this word array.
             *
             * @return {X64WordArray} The clone.
             *
             * @example
             *
             *     var clone = x64WordArray.clone();
             */
            clone: function() {
              var clone = Base.clone.call(this);
              var words = clone.words = this.words.slice(0);
              var wordsLength = words.length;
              for (var i = 0; i < wordsLength; i++) {
                words[i] = words[i].clone();
              }
              return clone;
            }
          });
        })();
        return CryptoJS;
      });
    }
  });

  // node_modules/crypto-js/lib-typedarrays.js
  var require_lib_typedarrays = __commonJS({
    "node_modules/crypto-js/lib-typedarrays.js"(exports, module) {
      (function(root, factory) {
        if (typeof exports === "object") {
          module.exports = exports = factory(require_core());
        } else if (typeof define === "function" && define.amd) {
          define(["./core"], factory);
        } else {
          factory(root.CryptoJS);
        }
      })(exports, function(CryptoJS) {
        (function() {
          if (typeof ArrayBuffer != "function") {
            return;
          }
          var C = CryptoJS;
          var C_lib = C.lib;
          var WordArray = C_lib.WordArray;
          var superInit = WordArray.init;
          var subInit = WordArray.init = function(typedArray) {
            if (typedArray instanceof ArrayBuffer) {
              typedArray = new Uint8Array(typedArray);
            }
            if (typedArray instanceof Int8Array || typeof Uint8ClampedArray !== "undefined" && typedArray instanceof Uint8ClampedArray || typedArray instanceof Int16Array || typedArray instanceof Uint16Array || typedArray instanceof Int32Array || typedArray instanceof Uint32Array || typedArray instanceof Float32Array || typedArray instanceof Float64Array) {
              typedArray = new Uint8Array(typedArray.buffer, typedArray.byteOffset, typedArray.byteLength);
            }
            if (typedArray instanceof Uint8Array) {
              var typedArrayByteLength = typedArray.byteLength;
              var words = [];
              for (var i = 0; i < typedArrayByteLength; i++) {
                words[i >>> 2] |= typedArray[i] << 24 - i % 4 * 8;
              }
              superInit.call(this, words, typedArrayByteLength);
            } else {
              superInit.apply(this, arguments);
            }
          };
          subInit.prototype = WordArray;
        })();
        return CryptoJS.lib.WordArray;
      });
    }
  });

  // node_modules/crypto-js/enc-utf16.js
  var require_enc_utf16 = __commonJS({
    "node_modules/crypto-js/enc-utf16.js"(exports, module) {
      (function(root, factory) {
        if (typeof exports === "object") {
          module.exports = exports = factory(require_core());
        } else if (typeof define === "function" && define.amd) {
          define(["./core"], factory);
        } else {
          factory(root.CryptoJS);
        }
      })(exports, function(CryptoJS) {
        (function() {
          var C = CryptoJS;
          var C_lib = C.lib;
          var WordArray = C_lib.WordArray;
          var C_enc = C.enc;
          var Utf16BE = C_enc.Utf16 = C_enc.Utf16BE = {
            /**
             * Converts a word array to a UTF-16 BE string.
             *
             * @param {WordArray} wordArray The word array.
             *
             * @return {string} The UTF-16 BE string.
             *
             * @static
             *
             * @example
             *
             *     var utf16String = CryptoJS.enc.Utf16.stringify(wordArray);
             */
            stringify: function(wordArray) {
              var words = wordArray.words;
              var sigBytes = wordArray.sigBytes;
              var utf16Chars = [];
              for (var i = 0; i < sigBytes; i += 2) {
                var codePoint = words[i >>> 2] >>> 16 - i % 4 * 8 & 65535;
                utf16Chars.push(String.fromCharCode(codePoint));
              }
              return utf16Chars.join("");
            },
            /**
             * Converts a UTF-16 BE string to a word array.
             *
             * @param {string} utf16Str The UTF-16 BE string.
             *
             * @return {WordArray} The word array.
             *
             * @static
             *
             * @example
             *
             *     var wordArray = CryptoJS.enc.Utf16.parse(utf16String);
             */
            parse: function(utf16Str) {
              var utf16StrLength = utf16Str.length;
              var words = [];
              for (var i = 0; i < utf16StrLength; i++) {
                words[i >>> 1] |= utf16Str.charCodeAt(i) << 16 - i % 2 * 16;
              }
              return WordArray.create(words, utf16StrLength * 2);
            }
          };
          C_enc.Utf16LE = {
            /**
             * Converts a word array to a UTF-16 LE string.
             *
             * @param {WordArray} wordArray The word array.
             *
             * @return {string} The UTF-16 LE string.
             *
             * @static
             *
             * @example
             *
             *     var utf16Str = CryptoJS.enc.Utf16LE.stringify(wordArray);
             */
            stringify: function(wordArray) {
              var words = wordArray.words;
              var sigBytes = wordArray.sigBytes;
              var utf16Chars = [];
              for (var i = 0; i < sigBytes; i += 2) {
                var codePoint = swapEndian(words[i >>> 2] >>> 16 - i % 4 * 8 & 65535);
                utf16Chars.push(String.fromCharCode(codePoint));
              }
              return utf16Chars.join("");
            },
            /**
             * Converts a UTF-16 LE string to a word array.
             *
             * @param {string} utf16Str The UTF-16 LE string.
             *
             * @return {WordArray} The word array.
             *
             * @static
             *
             * @example
             *
             *     var wordArray = CryptoJS.enc.Utf16LE.parse(utf16Str);
             */
            parse: function(utf16Str) {
              var utf16StrLength = utf16Str.length;
              var words = [];
              for (var i = 0; i < utf16StrLength; i++) {
                words[i >>> 1] |= swapEndian(utf16Str.charCodeAt(i) << 16 - i % 2 * 16);
              }
              return WordArray.create(words, utf16StrLength * 2);
            }
          };
          function swapEndian(word) {
            return word << 8 & 4278255360 | word >>> 8 & 16711935;
          }
        })();
        return CryptoJS.enc.Utf16;
      });
    }
  });

  // node_modules/crypto-js/enc-base64.js
  var require_enc_base64 = __commonJS({
    "node_modules/crypto-js/enc-base64.js"(exports, module) {
      (function(root, factory) {
        if (typeof exports === "object") {
          module.exports = exports = factory(require_core());
        } else if (typeof define === "function" && define.amd) {
          define(["./core"], factory);
        } else {
          factory(root.CryptoJS);
        }
      })(exports, function(CryptoJS) {
        (function() {
          var C = CryptoJS;
          var C_lib = C.lib;
          var WordArray = C_lib.WordArray;
          var C_enc = C.enc;
          var Base64 = C_enc.Base64 = {
            /**
             * Converts a word array to a Base64 string.
             *
             * @param {WordArray} wordArray The word array.
             *
             * @return {string} The Base64 string.
             *
             * @static
             *
             * @example
             *
             *     var base64String = CryptoJS.enc.Base64.stringify(wordArray);
             */
            stringify: function(wordArray) {
              var words = wordArray.words;
              var sigBytes = wordArray.sigBytes;
              var map = this._map;
              wordArray.clamp();
              var base64Chars = [];
              for (var i = 0; i < sigBytes; i += 3) {
                var byte1 = words[i >>> 2] >>> 24 - i % 4 * 8 & 255;
                var byte2 = words[i + 1 >>> 2] >>> 24 - (i + 1) % 4 * 8 & 255;
                var byte3 = words[i + 2 >>> 2] >>> 24 - (i + 2) % 4 * 8 & 255;
                var triplet = byte1 << 16 | byte2 << 8 | byte3;
                for (var j = 0; j < 4 && i + j * 0.75 < sigBytes; j++) {
                  base64Chars.push(map.charAt(triplet >>> 6 * (3 - j) & 63));
                }
              }
              var paddingChar = map.charAt(64);
              if (paddingChar) {
                while (base64Chars.length % 4) {
                  base64Chars.push(paddingChar);
                }
              }
              return base64Chars.join("");
            },
            /**
             * Converts a Base64 string to a word array.
             *
             * @param {string} base64Str The Base64 string.
             *
             * @return {WordArray} The word array.
             *
             * @static
             *
             * @example
             *
             *     var wordArray = CryptoJS.enc.Base64.parse(base64String);
             */
            parse: function(base64Str) {
              var base64StrLength = base64Str.length;
              var map = this._map;
              var reverseMap = this._reverseMap;
              if (!reverseMap) {
                reverseMap = this._reverseMap = [];
                for (var j = 0; j < map.length; j++) {
                  reverseMap[map.charCodeAt(j)] = j;
                }
              }
              var paddingChar = map.charAt(64);
              if (paddingChar) {
                var paddingIndex = base64Str.indexOf(paddingChar);
                if (paddingIndex !== -1) {
                  base64StrLength = paddingIndex;
                }
              }
              return parseLoop(base64Str, base64StrLength, reverseMap);
            },
            _map: "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/="
          };
          function parseLoop(base64Str, base64StrLength, reverseMap) {
            var words = [];
            var nBytes = 0;
            for (var i = 0; i < base64StrLength; i++) {
              if (i % 4) {
                var bits1 = reverseMap[base64Str.charCodeAt(i - 1)] << i % 4 * 2;
                var bits2 = reverseMap[base64Str.charCodeAt(i)] >>> 6 - i % 4 * 2;
                var bitsCombined = bits1 | bits2;
                words[nBytes >>> 2] |= bitsCombined << 24 - nBytes % 4 * 8;
                nBytes++;
              }
            }
            return WordArray.create(words, nBytes);
          }
        })();
        return CryptoJS.enc.Base64;
      });
    }
  });

  // node_modules/crypto-js/enc-base64url.js
  var require_enc_base64url = __commonJS({
    "node_modules/crypto-js/enc-base64url.js"(exports, module) {
      (function(root, factory) {
        if (typeof exports === "object") {
          module.exports = exports = factory(require_core());
        } else if (typeof define === "function" && define.amd) {
          define(["./core"], factory);
        } else {
          factory(root.CryptoJS);
        }
      })(exports, function(CryptoJS) {
        (function() {
          var C = CryptoJS;
          var C_lib = C.lib;
          var WordArray = C_lib.WordArray;
          var C_enc = C.enc;
          var Base64url = C_enc.Base64url = {
            /**
             * Converts a word array to a Base64url string.
             *
             * @param {WordArray} wordArray The word array.
             *
             * @param {boolean} urlSafe Whether to use url safe
             *
             * @return {string} The Base64url string.
             *
             * @static
             *
             * @example
             *
             *     var base64String = CryptoJS.enc.Base64url.stringify(wordArray);
             */
            stringify: function(wordArray, urlSafe = true) {
              var words = wordArray.words;
              var sigBytes = wordArray.sigBytes;
              var map = urlSafe ? this._safe_map : this._map;
              wordArray.clamp();
              var base64Chars = [];
              for (var i = 0; i < sigBytes; i += 3) {
                var byte1 = words[i >>> 2] >>> 24 - i % 4 * 8 & 255;
                var byte2 = words[i + 1 >>> 2] >>> 24 - (i + 1) % 4 * 8 & 255;
                var byte3 = words[i + 2 >>> 2] >>> 24 - (i + 2) % 4 * 8 & 255;
                var triplet = byte1 << 16 | byte2 << 8 | byte3;
                for (var j = 0; j < 4 && i + j * 0.75 < sigBytes; j++) {
                  base64Chars.push(map.charAt(triplet >>> 6 * (3 - j) & 63));
                }
              }
              var paddingChar = map.charAt(64);
              if (paddingChar) {
                while (base64Chars.length % 4) {
                  base64Chars.push(paddingChar);
                }
              }
              return base64Chars.join("");
            },
            /**
             * Converts a Base64url string to a word array.
             *
             * @param {string} base64Str The Base64url string.
             *
             * @param {boolean} urlSafe Whether to use url safe
             *
             * @return {WordArray} The word array.
             *
             * @static
             *
             * @example
             *
             *     var wordArray = CryptoJS.enc.Base64url.parse(base64String);
             */
            parse: function(base64Str, urlSafe = true) {
              var base64StrLength = base64Str.length;
              var map = urlSafe ? this._safe_map : this._map;
              var reverseMap = this._reverseMap;
              if (!reverseMap) {
                reverseMap = this._reverseMap = [];
                for (var j = 0; j < map.length; j++) {
                  reverseMap[map.charCodeAt(j)] = j;
                }
              }
              var paddingChar = map.charAt(64);
              if (paddingChar) {
                var paddingIndex = base64Str.indexOf(paddingChar);
                if (paddingIndex !== -1) {
                  base64StrLength = paddingIndex;
                }
              }
              return parseLoop(base64Str, base64StrLength, reverseMap);
            },
            _map: "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=",
            _safe_map: "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_"
          };
          function parseLoop(base64Str, base64StrLength, reverseMap) {
            var words = [];
            var nBytes = 0;
            for (var i = 0; i < base64StrLength; i++) {
              if (i % 4) {
                var bits1 = reverseMap[base64Str.charCodeAt(i - 1)] << i % 4 * 2;
                var bits2 = reverseMap[base64Str.charCodeAt(i)] >>> 6 - i % 4 * 2;
                var bitsCombined = bits1 | bits2;
                words[nBytes >>> 2] |= bitsCombined << 24 - nBytes % 4 * 8;
                nBytes++;
              }
            }
            return WordArray.create(words, nBytes);
          }
        })();
        return CryptoJS.enc.Base64url;
      });
    }
  });

  // node_modules/crypto-js/md5.js
  var require_md5 = __commonJS({
    "node_modules/crypto-js/md5.js"(exports, module) {
      (function(root, factory) {
        if (typeof exports === "object") {
          module.exports = exports = factory(require_core());
        } else if (typeof define === "function" && define.amd) {
          define(["./core"], factory);
        } else {
          factory(root.CryptoJS);
        }
      })(exports, function(CryptoJS) {
        (function(Math2) {
          var C = CryptoJS;
          var C_lib = C.lib;
          var WordArray = C_lib.WordArray;
          var Hasher = C_lib.Hasher;
          var C_algo = C.algo;
          var T = [];
          (function() {
            for (var i = 0; i < 64; i++) {
              T[i] = Math2.abs(Math2.sin(i + 1)) * 4294967296 | 0;
            }
          })();
          var MD5 = C_algo.MD5 = Hasher.extend({
            _doReset: function() {
              this._hash = new WordArray.init([
                1732584193,
                4023233417,
                2562383102,
                271733878
              ]);
            },
            _doProcessBlock: function(M, offset) {
              for (var i = 0; i < 16; i++) {
                var offset_i = offset + i;
                var M_offset_i = M[offset_i];
                M[offset_i] = (M_offset_i << 8 | M_offset_i >>> 24) & 16711935 | (M_offset_i << 24 | M_offset_i >>> 8) & 4278255360;
              }
              var H = this._hash.words;
              var M_offset_0 = M[offset + 0];
              var M_offset_1 = M[offset + 1];
              var M_offset_2 = M[offset + 2];
              var M_offset_3 = M[offset + 3];
              var M_offset_4 = M[offset + 4];
              var M_offset_5 = M[offset + 5];
              var M_offset_6 = M[offset + 6];
              var M_offset_7 = M[offset + 7];
              var M_offset_8 = M[offset + 8];
              var M_offset_9 = M[offset + 9];
              var M_offset_10 = M[offset + 10];
              var M_offset_11 = M[offset + 11];
              var M_offset_12 = M[offset + 12];
              var M_offset_13 = M[offset + 13];
              var M_offset_14 = M[offset + 14];
              var M_offset_15 = M[offset + 15];
              var a = H[0];
              var b = H[1];
              var c = H[2];
              var d = H[3];
              a = FF(a, b, c, d, M_offset_0, 7, T[0]);
              d = FF(d, a, b, c, M_offset_1, 12, T[1]);
              c = FF(c, d, a, b, M_offset_2, 17, T[2]);
              b = FF(b, c, d, a, M_offset_3, 22, T[3]);
              a = FF(a, b, c, d, M_offset_4, 7, T[4]);
              d = FF(d, a, b, c, M_offset_5, 12, T[5]);
              c = FF(c, d, a, b, M_offset_6, 17, T[6]);
              b = FF(b, c, d, a, M_offset_7, 22, T[7]);
              a = FF(a, b, c, d, M_offset_8, 7, T[8]);
              d = FF(d, a, b, c, M_offset_9, 12, T[9]);
              c = FF(c, d, a, b, M_offset_10, 17, T[10]);
              b = FF(b, c, d, a, M_offset_11, 22, T[11]);
              a = FF(a, b, c, d, M_offset_12, 7, T[12]);
              d = FF(d, a, b, c, M_offset_13, 12, T[13]);
              c = FF(c, d, a, b, M_offset_14, 17, T[14]);
              b = FF(b, c, d, a, M_offset_15, 22, T[15]);
              a = GG(a, b, c, d, M_offset_1, 5, T[16]);
              d = GG(d, a, b, c, M_offset_6, 9, T[17]);
              c = GG(c, d, a, b, M_offset_11, 14, T[18]);
              b = GG(b, c, d, a, M_offset_0, 20, T[19]);
              a = GG(a, b, c, d, M_offset_5, 5, T[20]);
              d = GG(d, a, b, c, M_offset_10, 9, T[21]);
              c = GG(c, d, a, b, M_offset_15, 14, T[22]);
              b = GG(b, c, d, a, M_offset_4, 20, T[23]);
              a = GG(a, b, c, d, M_offset_9, 5, T[24]);
              d = GG(d, a, b, c, M_offset_14, 9, T[25]);
              c = GG(c, d, a, b, M_offset_3, 14, T[26]);
              b = GG(b, c, d, a, M_offset_8, 20, T[27]);
              a = GG(a, b, c, d, M_offset_13, 5, T[28]);
              d = GG(d, a, b, c, M_offset_2, 9, T[29]);
              c = GG(c, d, a, b, M_offset_7, 14, T[30]);
              b = GG(b, c, d, a, M_offset_12, 20, T[31]);
              a = HH(a, b, c, d, M_offset_5, 4, T[32]);
              d = HH(d, a, b, c, M_offset_8, 11, T[33]);
              c = HH(c, d, a, b, M_offset_11, 16, T[34]);
              b = HH(b, c, d, a, M_offset_14, 23, T[35]);
              a = HH(a, b, c, d, M_offset_1, 4, T[36]);
              d = HH(d, a, b, c, M_offset_4, 11, T[37]);
              c = HH(c, d, a, b, M_offset_7, 16, T[38]);
              b = HH(b, c, d, a, M_offset_10, 23, T[39]);
              a = HH(a, b, c, d, M_offset_13, 4, T[40]);
              d = HH(d, a, b, c, M_offset_0, 11, T[41]);
              c = HH(c, d, a, b, M_offset_3, 16, T[42]);
              b = HH(b, c, d, a, M_offset_6, 23, T[43]);
              a = HH(a, b, c, d, M_offset_9, 4, T[44]);
              d = HH(d, a, b, c, M_offset_12, 11, T[45]);
              c = HH(c, d, a, b, M_offset_15, 16, T[46]);
              b = HH(b, c, d, a, M_offset_2, 23, T[47]);
              a = II(a, b, c, d, M_offset_0, 6, T[48]);
              d = II(d, a, b, c, M_offset_7, 10, T[49]);
              c = II(c, d, a, b, M_offset_14, 15, T[50]);
              b = II(b, c, d, a, M_offset_5, 21, T[51]);
              a = II(a, b, c, d, M_offset_12, 6, T[52]);
              d = II(d, a, b, c, M_offset_3, 10, T[53]);
              c = II(c, d, a, b, M_offset_10, 15, T[54]);
              b = II(b, c, d, a, M_offset_1, 21, T[55]);
              a = II(a, b, c, d, M_offset_8, 6, T[56]);
              d = II(d, a, b, c, M_offset_15, 10, T[57]);
              c = II(c, d, a, b, M_offset_6, 15, T[58]);
              b = II(b, c, d, a, M_offset_13, 21, T[59]);
              a = II(a, b, c, d, M_offset_4, 6, T[60]);
              d = II(d, a, b, c, M_offset_11, 10, T[61]);
              c = II(c, d, a, b, M_offset_2, 15, T[62]);
              b = II(b, c, d, a, M_offset_9, 21, T[63]);
              H[0] = H[0] + a | 0;
              H[1] = H[1] + b | 0;
              H[2] = H[2] + c | 0;
              H[3] = H[3] + d | 0;
            },
            _doFinalize: function() {
              var data = this._data;
              var dataWords = data.words;
              var nBitsTotal = this._nDataBytes * 8;
              var nBitsLeft = data.sigBytes * 8;
              dataWords[nBitsLeft >>> 5] |= 128 << 24 - nBitsLeft % 32;
              var nBitsTotalH = Math2.floor(nBitsTotal / 4294967296);
              var nBitsTotalL = nBitsTotal;
              dataWords[(nBitsLeft + 64 >>> 9 << 4) + 15] = (nBitsTotalH << 8 | nBitsTotalH >>> 24) & 16711935 | (nBitsTotalH << 24 | nBitsTotalH >>> 8) & 4278255360;
              dataWords[(nBitsLeft + 64 >>> 9 << 4) + 14] = (nBitsTotalL << 8 | nBitsTotalL >>> 24) & 16711935 | (nBitsTotalL << 24 | nBitsTotalL >>> 8) & 4278255360;
              data.sigBytes = (dataWords.length + 1) * 4;
              this._process();
              var hash = this._hash;
              var H = hash.words;
              for (var i = 0; i < 4; i++) {
                var H_i = H[i];
                H[i] = (H_i << 8 | H_i >>> 24) & 16711935 | (H_i << 24 | H_i >>> 8) & 4278255360;
              }
              return hash;
            },
            clone: function() {
              var clone = Hasher.clone.call(this);
              clone._hash = this._hash.clone();
              return clone;
            }
          });
          function FF(a, b, c, d, x, s, t) {
            var n = a + (b & c | ~b & d) + x + t;
            return (n << s | n >>> 32 - s) + b;
          }
          function GG(a, b, c, d, x, s, t) {
            var n = a + (b & d | c & ~d) + x + t;
            return (n << s | n >>> 32 - s) + b;
          }
          function HH(a, b, c, d, x, s, t) {
            var n = a + (b ^ c ^ d) + x + t;
            return (n << s | n >>> 32 - s) + b;
          }
          function II(a, b, c, d, x, s, t) {
            var n = a + (c ^ (b | ~d)) + x + t;
            return (n << s | n >>> 32 - s) + b;
          }
          C.MD5 = Hasher._createHelper(MD5);
          C.HmacMD5 = Hasher._createHmacHelper(MD5);
        })(Math);
        return CryptoJS.MD5;
      });
    }
  });

  // node_modules/crypto-js/sha1.js
  var require_sha1 = __commonJS({
    "node_modules/crypto-js/sha1.js"(exports, module) {
      (function(root, factory) {
        if (typeof exports === "object") {
          module.exports = exports = factory(require_core());
        } else if (typeof define === "function" && define.amd) {
          define(["./core"], factory);
        } else {
          factory(root.CryptoJS);
        }
      })(exports, function(CryptoJS) {
        (function() {
          var C = CryptoJS;
          var C_lib = C.lib;
          var WordArray = C_lib.WordArray;
          var Hasher = C_lib.Hasher;
          var C_algo = C.algo;
          var W = [];
          var SHA1 = C_algo.SHA1 = Hasher.extend({
            _doReset: function() {
              this._hash = new WordArray.init([
                1732584193,
                4023233417,
                2562383102,
                271733878,
                3285377520
              ]);
            },
            _doProcessBlock: function(M, offset) {
              var H = this._hash.words;
              var a = H[0];
              var b = H[1];
              var c = H[2];
              var d = H[3];
              var e = H[4];
              for (var i = 0; i < 80; i++) {
                if (i < 16) {
                  W[i] = M[offset + i] | 0;
                } else {
                  var n = W[i - 3] ^ W[i - 8] ^ W[i - 14] ^ W[i - 16];
                  W[i] = n << 1 | n >>> 31;
                }
                var t = (a << 5 | a >>> 27) + e + W[i];
                if (i < 20) {
                  t += (b & c | ~b & d) + 1518500249;
                } else if (i < 40) {
                  t += (b ^ c ^ d) + 1859775393;
                } else if (i < 60) {
                  t += (b & c | b & d | c & d) - 1894007588;
                } else {
                  t += (b ^ c ^ d) - 899497514;
                }
                e = d;
                d = c;
                c = b << 30 | b >>> 2;
                b = a;
                a = t;
              }
              H[0] = H[0] + a | 0;
              H[1] = H[1] + b | 0;
              H[2] = H[2] + c | 0;
              H[3] = H[3] + d | 0;
              H[4] = H[4] + e | 0;
            },
            _doFinalize: function() {
              var data = this._data;
              var dataWords = data.words;
              var nBitsTotal = this._nDataBytes * 8;
              var nBitsLeft = data.sigBytes * 8;
              dataWords[nBitsLeft >>> 5] |= 128 << 24 - nBitsLeft % 32;
              dataWords[(nBitsLeft + 64 >>> 9 << 4) + 14] = Math.floor(nBitsTotal / 4294967296);
              dataWords[(nBitsLeft + 64 >>> 9 << 4) + 15] = nBitsTotal;
              data.sigBytes = dataWords.length * 4;
              this._process();
              return this._hash;
            },
            clone: function() {
              var clone = Hasher.clone.call(this);
              clone._hash = this._hash.clone();
              return clone;
            }
          });
          C.SHA1 = Hasher._createHelper(SHA1);
          C.HmacSHA1 = Hasher._createHmacHelper(SHA1);
        })();
        return CryptoJS.SHA1;
      });
    }
  });

  // node_modules/crypto-js/sha256.js
  var require_sha256 = __commonJS({
    "node_modules/crypto-js/sha256.js"(exports, module) {
      (function(root, factory) {
        if (typeof exports === "object") {
          module.exports = exports = factory(require_core());
        } else if (typeof define === "function" && define.amd) {
          define(["./core"], factory);
        } else {
          factory(root.CryptoJS);
        }
      })(exports, function(CryptoJS) {
        (function(Math2) {
          var C = CryptoJS;
          var C_lib = C.lib;
          var WordArray = C_lib.WordArray;
          var Hasher = C_lib.Hasher;
          var C_algo = C.algo;
          var H = [];
          var K = [];
          (function() {
            function isPrime(n2) {
              var sqrtN = Math2.sqrt(n2);
              for (var factor = 2; factor <= sqrtN; factor++) {
                if (!(n2 % factor)) {
                  return false;
                }
              }
              return true;
            }
            function getFractionalBits(n2) {
              return (n2 - (n2 | 0)) * 4294967296 | 0;
            }
            var n = 2;
            var nPrime = 0;
            while (nPrime < 64) {
              if (isPrime(n)) {
                if (nPrime < 8) {
                  H[nPrime] = getFractionalBits(Math2.pow(n, 1 / 2));
                }
                K[nPrime] = getFractionalBits(Math2.pow(n, 1 / 3));
                nPrime++;
              }
              n++;
            }
          })();
          var W = [];
          var SHA256 = C_algo.SHA256 = Hasher.extend({
            _doReset: function() {
              this._hash = new WordArray.init(H.slice(0));
            },
            _doProcessBlock: function(M, offset) {
              var H2 = this._hash.words;
              var a = H2[0];
              var b = H2[1];
              var c = H2[2];
              var d = H2[3];
              var e = H2[4];
              var f = H2[5];
              var g = H2[6];
              var h = H2[7];
              for (var i = 0; i < 64; i++) {
                if (i < 16) {
                  W[i] = M[offset + i] | 0;
                } else {
                  var gamma0x = W[i - 15];
                  var gamma0 = (gamma0x << 25 | gamma0x >>> 7) ^ (gamma0x << 14 | gamma0x >>> 18) ^ gamma0x >>> 3;
                  var gamma1x = W[i - 2];
                  var gamma1 = (gamma1x << 15 | gamma1x >>> 17) ^ (gamma1x << 13 | gamma1x >>> 19) ^ gamma1x >>> 10;
                  W[i] = gamma0 + W[i - 7] + gamma1 + W[i - 16];
                }
                var ch = e & f ^ ~e & g;
                var maj = a & b ^ a & c ^ b & c;
                var sigma0 = (a << 30 | a >>> 2) ^ (a << 19 | a >>> 13) ^ (a << 10 | a >>> 22);
                var sigma1 = (e << 26 | e >>> 6) ^ (e << 21 | e >>> 11) ^ (e << 7 | e >>> 25);
                var t1 = h + sigma1 + ch + K[i] + W[i];
                var t2 = sigma0 + maj;
                h = g;
                g = f;
                f = e;
                e = d + t1 | 0;
                d = c;
                c = b;
                b = a;
                a = t1 + t2 | 0;
              }
              H2[0] = H2[0] + a | 0;
              H2[1] = H2[1] + b | 0;
              H2[2] = H2[2] + c | 0;
              H2[3] = H2[3] + d | 0;
              H2[4] = H2[4] + e | 0;
              H2[5] = H2[5] + f | 0;
              H2[6] = H2[6] + g | 0;
              H2[7] = H2[7] + h | 0;
            },
            _doFinalize: function() {
              var data = this._data;
              var dataWords = data.words;
              var nBitsTotal = this._nDataBytes * 8;
              var nBitsLeft = data.sigBytes * 8;
              dataWords[nBitsLeft >>> 5] |= 128 << 24 - nBitsLeft % 32;
              dataWords[(nBitsLeft + 64 >>> 9 << 4) + 14] = Math2.floor(nBitsTotal / 4294967296);
              dataWords[(nBitsLeft + 64 >>> 9 << 4) + 15] = nBitsTotal;
              data.sigBytes = dataWords.length * 4;
              this._process();
              return this._hash;
            },
            clone: function() {
              var clone = Hasher.clone.call(this);
              clone._hash = this._hash.clone();
              return clone;
            }
          });
          C.SHA256 = Hasher._createHelper(SHA256);
          C.HmacSHA256 = Hasher._createHmacHelper(SHA256);
        })(Math);
        return CryptoJS.SHA256;
      });
    }
  });

  // node_modules/crypto-js/sha224.js
  var require_sha224 = __commonJS({
    "node_modules/crypto-js/sha224.js"(exports, module) {
      (function(root, factory, undef) {
        if (typeof exports === "object") {
          module.exports = exports = factory(require_core(), require_sha256());
        } else if (typeof define === "function" && define.amd) {
          define(["./core", "./sha256"], factory);
        } else {
          factory(root.CryptoJS);
        }
      })(exports, function(CryptoJS) {
        (function() {
          var C = CryptoJS;
          var C_lib = C.lib;
          var WordArray = C_lib.WordArray;
          var C_algo = C.algo;
          var SHA256 = C_algo.SHA256;
          var SHA224 = C_algo.SHA224 = SHA256.extend({
            _doReset: function() {
              this._hash = new WordArray.init([
                3238371032,
                914150663,
                812702999,
                4144912697,
                4290775857,
                1750603025,
                1694076839,
                3204075428
              ]);
            },
            _doFinalize: function() {
              var hash = SHA256._doFinalize.call(this);
              hash.sigBytes -= 4;
              return hash;
            }
          });
          C.SHA224 = SHA256._createHelper(SHA224);
          C.HmacSHA224 = SHA256._createHmacHelper(SHA224);
        })();
        return CryptoJS.SHA224;
      });
    }
  });

  // node_modules/crypto-js/sha512.js
  var require_sha512 = __commonJS({
    "node_modules/crypto-js/sha512.js"(exports, module) {
      (function(root, factory, undef) {
        if (typeof exports === "object") {
          module.exports = exports = factory(require_core(), require_x64_core());
        } else if (typeof define === "function" && define.amd) {
          define(["./core", "./x64-core"], factory);
        } else {
          factory(root.CryptoJS);
        }
      })(exports, function(CryptoJS) {
        (function() {
          var C = CryptoJS;
          var C_lib = C.lib;
          var Hasher = C_lib.Hasher;
          var C_x64 = C.x64;
          var X64Word = C_x64.Word;
          var X64WordArray = C_x64.WordArray;
          var C_algo = C.algo;
          function X64Word_create() {
            return X64Word.create.apply(X64Word, arguments);
          }
          var K = [
            X64Word_create(1116352408, 3609767458),
            X64Word_create(1899447441, 602891725),
            X64Word_create(3049323471, 3964484399),
            X64Word_create(3921009573, 2173295548),
            X64Word_create(961987163, 4081628472),
            X64Word_create(1508970993, 3053834265),
            X64Word_create(2453635748, 2937671579),
            X64Word_create(2870763221, 3664609560),
            X64Word_create(3624381080, 2734883394),
            X64Word_create(310598401, 1164996542),
            X64Word_create(607225278, 1323610764),
            X64Word_create(1426881987, 3590304994),
            X64Word_create(1925078388, 4068182383),
            X64Word_create(2162078206, 991336113),
            X64Word_create(2614888103, 633803317),
            X64Word_create(3248222580, 3479774868),
            X64Word_create(3835390401, 2666613458),
            X64Word_create(4022224774, 944711139),
            X64Word_create(264347078, 2341262773),
            X64Word_create(604807628, 2007800933),
            X64Word_create(770255983, 1495990901),
            X64Word_create(1249150122, 1856431235),
            X64Word_create(1555081692, 3175218132),
            X64Word_create(1996064986, 2198950837),
            X64Word_create(2554220882, 3999719339),
            X64Word_create(2821834349, 766784016),
            X64Word_create(2952996808, 2566594879),
            X64Word_create(3210313671, 3203337956),
            X64Word_create(3336571891, 1034457026),
            X64Word_create(3584528711, 2466948901),
            X64Word_create(113926993, 3758326383),
            X64Word_create(338241895, 168717936),
            X64Word_create(666307205, 1188179964),
            X64Word_create(773529912, 1546045734),
            X64Word_create(1294757372, 1522805485),
            X64Word_create(1396182291, 2643833823),
            X64Word_create(1695183700, 2343527390),
            X64Word_create(1986661051, 1014477480),
            X64Word_create(2177026350, 1206759142),
            X64Word_create(2456956037, 344077627),
            X64Word_create(2730485921, 1290863460),
            X64Word_create(2820302411, 3158454273),
            X64Word_create(3259730800, 3505952657),
            X64Word_create(3345764771, 106217008),
            X64Word_create(3516065817, 3606008344),
            X64Word_create(3600352804, 1432725776),
            X64Word_create(4094571909, 1467031594),
            X64Word_create(275423344, 851169720),
            X64Word_create(430227734, 3100823752),
            X64Word_create(506948616, 1363258195),
            X64Word_create(659060556, 3750685593),
            X64Word_create(883997877, 3785050280),
            X64Word_create(958139571, 3318307427),
            X64Word_create(1322822218, 3812723403),
            X64Word_create(1537002063, 2003034995),
            X64Word_create(1747873779, 3602036899),
            X64Word_create(1955562222, 1575990012),
            X64Word_create(2024104815, 1125592928),
            X64Word_create(2227730452, 2716904306),
            X64Word_create(2361852424, 442776044),
            X64Word_create(2428436474, 593698344),
            X64Word_create(2756734187, 3733110249),
            X64Word_create(3204031479, 2999351573),
            X64Word_create(3329325298, 3815920427),
            X64Word_create(3391569614, 3928383900),
            X64Word_create(3515267271, 566280711),
            X64Word_create(3940187606, 3454069534),
            X64Word_create(4118630271, 4000239992),
            X64Word_create(116418474, 1914138554),
            X64Word_create(174292421, 2731055270),
            X64Word_create(289380356, 3203993006),
            X64Word_create(460393269, 320620315),
            X64Word_create(685471733, 587496836),
            X64Word_create(852142971, 1086792851),
            X64Word_create(1017036298, 365543100),
            X64Word_create(1126000580, 2618297676),
            X64Word_create(1288033470, 3409855158),
            X64Word_create(1501505948, 4234509866),
            X64Word_create(1607167915, 987167468),
            X64Word_create(1816402316, 1246189591)
          ];
          var W = [];
          (function() {
            for (var i = 0; i < 80; i++) {
              W[i] = X64Word_create();
            }
          })();
          var SHA512 = C_algo.SHA512 = Hasher.extend({
            _doReset: function() {
              this._hash = new X64WordArray.init([
                new X64Word.init(1779033703, 4089235720),
                new X64Word.init(3144134277, 2227873595),
                new X64Word.init(1013904242, 4271175723),
                new X64Word.init(2773480762, 1595750129),
                new X64Word.init(1359893119, 2917565137),
                new X64Word.init(2600822924, 725511199),
                new X64Word.init(528734635, 4215389547),
                new X64Word.init(1541459225, 327033209)
              ]);
            },
            _doProcessBlock: function(M, offset) {
              var H = this._hash.words;
              var H0 = H[0];
              var H1 = H[1];
              var H2 = H[2];
              var H3 = H[3];
              var H4 = H[4];
              var H5 = H[5];
              var H6 = H[6];
              var H7 = H[7];
              var H0h = H0.high;
              var H0l = H0.low;
              var H1h = H1.high;
              var H1l = H1.low;
              var H2h = H2.high;
              var H2l = H2.low;
              var H3h = H3.high;
              var H3l = H3.low;
              var H4h = H4.high;
              var H4l = H4.low;
              var H5h = H5.high;
              var H5l = H5.low;
              var H6h = H6.high;
              var H6l = H6.low;
              var H7h = H7.high;
              var H7l = H7.low;
              var ah = H0h;
              var al = H0l;
              var bh = H1h;
              var bl = H1l;
              var ch = H2h;
              var cl = H2l;
              var dh = H3h;
              var dl = H3l;
              var eh = H4h;
              var el = H4l;
              var fh = H5h;
              var fl = H5l;
              var gh = H6h;
              var gl = H6l;
              var hh = H7h;
              var hl = H7l;
              for (var i = 0; i < 80; i++) {
                var Wil;
                var Wih;
                var Wi = W[i];
                if (i < 16) {
                  Wih = Wi.high = M[offset + i * 2] | 0;
                  Wil = Wi.low = M[offset + i * 2 + 1] | 0;
                } else {
                  var gamma0x = W[i - 15];
                  var gamma0xh = gamma0x.high;
                  var gamma0xl = gamma0x.low;
                  var gamma0h = (gamma0xh >>> 1 | gamma0xl << 31) ^ (gamma0xh >>> 8 | gamma0xl << 24) ^ gamma0xh >>> 7;
                  var gamma0l = (gamma0xl >>> 1 | gamma0xh << 31) ^ (gamma0xl >>> 8 | gamma0xh << 24) ^ (gamma0xl >>> 7 | gamma0xh << 25);
                  var gamma1x = W[i - 2];
                  var gamma1xh = gamma1x.high;
                  var gamma1xl = gamma1x.low;
                  var gamma1h = (gamma1xh >>> 19 | gamma1xl << 13) ^ (gamma1xh << 3 | gamma1xl >>> 29) ^ gamma1xh >>> 6;
                  var gamma1l = (gamma1xl >>> 19 | gamma1xh << 13) ^ (gamma1xl << 3 | gamma1xh >>> 29) ^ (gamma1xl >>> 6 | gamma1xh << 26);
                  var Wi7 = W[i - 7];
                  var Wi7h = Wi7.high;
                  var Wi7l = Wi7.low;
                  var Wi16 = W[i - 16];
                  var Wi16h = Wi16.high;
                  var Wi16l = Wi16.low;
                  Wil = gamma0l + Wi7l;
                  Wih = gamma0h + Wi7h + (Wil >>> 0 < gamma0l >>> 0 ? 1 : 0);
                  Wil = Wil + gamma1l;
                  Wih = Wih + gamma1h + (Wil >>> 0 < gamma1l >>> 0 ? 1 : 0);
                  Wil = Wil + Wi16l;
                  Wih = Wih + Wi16h + (Wil >>> 0 < Wi16l >>> 0 ? 1 : 0);
                  Wi.high = Wih;
                  Wi.low = Wil;
                }
                var chh = eh & fh ^ ~eh & gh;
                var chl = el & fl ^ ~el & gl;
                var majh = ah & bh ^ ah & ch ^ bh & ch;
                var majl = al & bl ^ al & cl ^ bl & cl;
                var sigma0h = (ah >>> 28 | al << 4) ^ (ah << 30 | al >>> 2) ^ (ah << 25 | al >>> 7);
                var sigma0l = (al >>> 28 | ah << 4) ^ (al << 30 | ah >>> 2) ^ (al << 25 | ah >>> 7);
                var sigma1h = (eh >>> 14 | el << 18) ^ (eh >>> 18 | el << 14) ^ (eh << 23 | el >>> 9);
                var sigma1l = (el >>> 14 | eh << 18) ^ (el >>> 18 | eh << 14) ^ (el << 23 | eh >>> 9);
                var Ki = K[i];
                var Kih = Ki.high;
                var Kil = Ki.low;
                var t1l = hl + sigma1l;
                var t1h = hh + sigma1h + (t1l >>> 0 < hl >>> 0 ? 1 : 0);
                var t1l = t1l + chl;
                var t1h = t1h + chh + (t1l >>> 0 < chl >>> 0 ? 1 : 0);
                var t1l = t1l + Kil;
                var t1h = t1h + Kih + (t1l >>> 0 < Kil >>> 0 ? 1 : 0);
                var t1l = t1l + Wil;
                var t1h = t1h + Wih + (t1l >>> 0 < Wil >>> 0 ? 1 : 0);
                var t2l = sigma0l + majl;
                var t2h = sigma0h + majh + (t2l >>> 0 < sigma0l >>> 0 ? 1 : 0);
                hh = gh;
                hl = gl;
                gh = fh;
                gl = fl;
                fh = eh;
                fl = el;
                el = dl + t1l | 0;
                eh = dh + t1h + (el >>> 0 < dl >>> 0 ? 1 : 0) | 0;
                dh = ch;
                dl = cl;
                ch = bh;
                cl = bl;
                bh = ah;
                bl = al;
                al = t1l + t2l | 0;
                ah = t1h + t2h + (al >>> 0 < t1l >>> 0 ? 1 : 0) | 0;
              }
              H0l = H0.low = H0l + al;
              H0.high = H0h + ah + (H0l >>> 0 < al >>> 0 ? 1 : 0);
              H1l = H1.low = H1l + bl;
              H1.high = H1h + bh + (H1l >>> 0 < bl >>> 0 ? 1 : 0);
              H2l = H2.low = H2l + cl;
              H2.high = H2h + ch + (H2l >>> 0 < cl >>> 0 ? 1 : 0);
              H3l = H3.low = H3l + dl;
              H3.high = H3h + dh + (H3l >>> 0 < dl >>> 0 ? 1 : 0);
              H4l = H4.low = H4l + el;
              H4.high = H4h + eh + (H4l >>> 0 < el >>> 0 ? 1 : 0);
              H5l = H5.low = H5l + fl;
              H5.high = H5h + fh + (H5l >>> 0 < fl >>> 0 ? 1 : 0);
              H6l = H6.low = H6l + gl;
              H6.high = H6h + gh + (H6l >>> 0 < gl >>> 0 ? 1 : 0);
              H7l = H7.low = H7l + hl;
              H7.high = H7h + hh + (H7l >>> 0 < hl >>> 0 ? 1 : 0);
            },
            _doFinalize: function() {
              var data = this._data;
              var dataWords = data.words;
              var nBitsTotal = this._nDataBytes * 8;
              var nBitsLeft = data.sigBytes * 8;
              dataWords[nBitsLeft >>> 5] |= 128 << 24 - nBitsLeft % 32;
              dataWords[(nBitsLeft + 128 >>> 10 << 5) + 30] = Math.floor(nBitsTotal / 4294967296);
              dataWords[(nBitsLeft + 128 >>> 10 << 5) + 31] = nBitsTotal;
              data.sigBytes = dataWords.length * 4;
              this._process();
              var hash = this._hash.toX32();
              return hash;
            },
            clone: function() {
              var clone = Hasher.clone.call(this);
              clone._hash = this._hash.clone();
              return clone;
            },
            blockSize: 1024 / 32
          });
          C.SHA512 = Hasher._createHelper(SHA512);
          C.HmacSHA512 = Hasher._createHmacHelper(SHA512);
        })();
        return CryptoJS.SHA512;
      });
    }
  });

  // node_modules/crypto-js/sha384.js
  var require_sha384 = __commonJS({
    "node_modules/crypto-js/sha384.js"(exports, module) {
      (function(root, factory, undef) {
        if (typeof exports === "object") {
          module.exports = exports = factory(require_core(), require_x64_core(), require_sha512());
        } else if (typeof define === "function" && define.amd) {
          define(["./core", "./x64-core", "./sha512"], factory);
        } else {
          factory(root.CryptoJS);
        }
      })(exports, function(CryptoJS) {
        (function() {
          var C = CryptoJS;
          var C_x64 = C.x64;
          var X64Word = C_x64.Word;
          var X64WordArray = C_x64.WordArray;
          var C_algo = C.algo;
          var SHA512 = C_algo.SHA512;
          var SHA384 = C_algo.SHA384 = SHA512.extend({
            _doReset: function() {
              this._hash = new X64WordArray.init([
                new X64Word.init(3418070365, 3238371032),
                new X64Word.init(1654270250, 914150663),
                new X64Word.init(2438529370, 812702999),
                new X64Word.init(355462360, 4144912697),
                new X64Word.init(1731405415, 4290775857),
                new X64Word.init(2394180231, 1750603025),
                new X64Word.init(3675008525, 1694076839),
                new X64Word.init(1203062813, 3204075428)
              ]);
            },
            _doFinalize: function() {
              var hash = SHA512._doFinalize.call(this);
              hash.sigBytes -= 16;
              return hash;
            }
          });
          C.SHA384 = SHA512._createHelper(SHA384);
          C.HmacSHA384 = SHA512._createHmacHelper(SHA384);
        })();
        return CryptoJS.SHA384;
      });
    }
  });

  // node_modules/crypto-js/sha3.js
  var require_sha3 = __commonJS({
    "node_modules/crypto-js/sha3.js"(exports, module) {
      (function(root, factory, undef) {
        if (typeof exports === "object") {
          module.exports = exports = factory(require_core(), require_x64_core());
        } else if (typeof define === "function" && define.amd) {
          define(["./core", "./x64-core"], factory);
        } else {
          factory(root.CryptoJS);
        }
      })(exports, function(CryptoJS) {
        (function(Math2) {
          var C = CryptoJS;
          var C_lib = C.lib;
          var WordArray = C_lib.WordArray;
          var Hasher = C_lib.Hasher;
          var C_x64 = C.x64;
          var X64Word = C_x64.Word;
          var C_algo = C.algo;
          var RHO_OFFSETS = [];
          var PI_INDEXES = [];
          var ROUND_CONSTANTS = [];
          (function() {
            var x = 1, y = 0;
            for (var t = 0; t < 24; t++) {
              RHO_OFFSETS[x + 5 * y] = (t + 1) * (t + 2) / 2 % 64;
              var newX = y % 5;
              var newY = (2 * x + 3 * y) % 5;
              x = newX;
              y = newY;
            }
            for (var x = 0; x < 5; x++) {
              for (var y = 0; y < 5; y++) {
                PI_INDEXES[x + 5 * y] = y + (2 * x + 3 * y) % 5 * 5;
              }
            }
            var LFSR = 1;
            for (var i = 0; i < 24; i++) {
              var roundConstantMsw = 0;
              var roundConstantLsw = 0;
              for (var j = 0; j < 7; j++) {
                if (LFSR & 1) {
                  var bitPosition = (1 << j) - 1;
                  if (bitPosition < 32) {
                    roundConstantLsw ^= 1 << bitPosition;
                  } else {
                    roundConstantMsw ^= 1 << bitPosition - 32;
                  }
                }
                if (LFSR & 128) {
                  LFSR = LFSR << 1 ^ 113;
                } else {
                  LFSR <<= 1;
                }
              }
              ROUND_CONSTANTS[i] = X64Word.create(roundConstantMsw, roundConstantLsw);
            }
          })();
          var T = [];
          (function() {
            for (var i = 0; i < 25; i++) {
              T[i] = X64Word.create();
            }
          })();
          var SHA3 = C_algo.SHA3 = Hasher.extend({
            /**
             * Configuration options.
             *
             * @property {number} outputLength
             *   The desired number of bits in the output hash.
             *   Only values permitted are: 224, 256, 384, 512.
             *   Default: 512
             */
            cfg: Hasher.cfg.extend({
              outputLength: 512
            }),
            _doReset: function() {
              var state = this._state = [];
              for (var i = 0; i < 25; i++) {
                state[i] = new X64Word.init();
              }
              this.blockSize = (1600 - 2 * this.cfg.outputLength) / 32;
            },
            _doProcessBlock: function(M, offset) {
              var state = this._state;
              var nBlockSizeLanes = this.blockSize / 2;
              for (var i = 0; i < nBlockSizeLanes; i++) {
                var M2i = M[offset + 2 * i];
                var M2i1 = M[offset + 2 * i + 1];
                M2i = (M2i << 8 | M2i >>> 24) & 16711935 | (M2i << 24 | M2i >>> 8) & 4278255360;
                M2i1 = (M2i1 << 8 | M2i1 >>> 24) & 16711935 | (M2i1 << 24 | M2i1 >>> 8) & 4278255360;
                var lane = state[i];
                lane.high ^= M2i1;
                lane.low ^= M2i;
              }
              for (var round = 0; round < 24; round++) {
                for (var x = 0; x < 5; x++) {
                  var tMsw = 0, tLsw = 0;
                  for (var y = 0; y < 5; y++) {
                    var lane = state[x + 5 * y];
                    tMsw ^= lane.high;
                    tLsw ^= lane.low;
                  }
                  var Tx = T[x];
                  Tx.high = tMsw;
                  Tx.low = tLsw;
                }
                for (var x = 0; x < 5; x++) {
                  var Tx4 = T[(x + 4) % 5];
                  var Tx1 = T[(x + 1) % 5];
                  var Tx1Msw = Tx1.high;
                  var Tx1Lsw = Tx1.low;
                  var tMsw = Tx4.high ^ (Tx1Msw << 1 | Tx1Lsw >>> 31);
                  var tLsw = Tx4.low ^ (Tx1Lsw << 1 | Tx1Msw >>> 31);
                  for (var y = 0; y < 5; y++) {
                    var lane = state[x + 5 * y];
                    lane.high ^= tMsw;
                    lane.low ^= tLsw;
                  }
                }
                for (var laneIndex = 1; laneIndex < 25; laneIndex++) {
                  var tMsw;
                  var tLsw;
                  var lane = state[laneIndex];
                  var laneMsw = lane.high;
                  var laneLsw = lane.low;
                  var rhoOffset = RHO_OFFSETS[laneIndex];
                  if (rhoOffset < 32) {
                    tMsw = laneMsw << rhoOffset | laneLsw >>> 32 - rhoOffset;
                    tLsw = laneLsw << rhoOffset | laneMsw >>> 32 - rhoOffset;
                  } else {
                    tMsw = laneLsw << rhoOffset - 32 | laneMsw >>> 64 - rhoOffset;
                    tLsw = laneMsw << rhoOffset - 32 | laneLsw >>> 64 - rhoOffset;
                  }
                  var TPiLane = T[PI_INDEXES[laneIndex]];
                  TPiLane.high = tMsw;
                  TPiLane.low = tLsw;
                }
                var T0 = T[0];
                var state0 = state[0];
                T0.high = state0.high;
                T0.low = state0.low;
                for (var x = 0; x < 5; x++) {
                  for (var y = 0; y < 5; y++) {
                    var laneIndex = x + 5 * y;
                    var lane = state[laneIndex];
                    var TLane = T[laneIndex];
                    var Tx1Lane = T[(x + 1) % 5 + 5 * y];
                    var Tx2Lane = T[(x + 2) % 5 + 5 * y];
                    lane.high = TLane.high ^ ~Tx1Lane.high & Tx2Lane.high;
                    lane.low = TLane.low ^ ~Tx1Lane.low & Tx2Lane.low;
                  }
                }
                var lane = state[0];
                var roundConstant = ROUND_CONSTANTS[round];
                lane.high ^= roundConstant.high;
                lane.low ^= roundConstant.low;
              }
            },
            _doFinalize: function() {
              var data = this._data;
              var dataWords = data.words;
              var nBitsTotal = this._nDataBytes * 8;
              var nBitsLeft = data.sigBytes * 8;
              var blockSizeBits = this.blockSize * 32;
              dataWords[nBitsLeft >>> 5] |= 1 << 24 - nBitsLeft % 32;
              dataWords[(Math2.ceil((nBitsLeft + 1) / blockSizeBits) * blockSizeBits >>> 5) - 1] |= 128;
              data.sigBytes = dataWords.length * 4;
              this._process();
              var state = this._state;
              var outputLengthBytes = this.cfg.outputLength / 8;
              var outputLengthLanes = outputLengthBytes / 8;
              var hashWords = [];
              for (var i = 0; i < outputLengthLanes; i++) {
                var lane = state[i];
                var laneMsw = lane.high;
                var laneLsw = lane.low;
                laneMsw = (laneMsw << 8 | laneMsw >>> 24) & 16711935 | (laneMsw << 24 | laneMsw >>> 8) & 4278255360;
                laneLsw = (laneLsw << 8 | laneLsw >>> 24) & 16711935 | (laneLsw << 24 | laneLsw >>> 8) & 4278255360;
                hashWords.push(laneLsw);
                hashWords.push(laneMsw);
              }
              return new WordArray.init(hashWords, outputLengthBytes);
            },
            clone: function() {
              var clone = Hasher.clone.call(this);
              var state = clone._state = this._state.slice(0);
              for (var i = 0; i < 25; i++) {
                state[i] = state[i].clone();
              }
              return clone;
            }
          });
          C.SHA3 = Hasher._createHelper(SHA3);
          C.HmacSHA3 = Hasher._createHmacHelper(SHA3);
        })(Math);
        return CryptoJS.SHA3;
      });
    }
  });

  // node_modules/crypto-js/ripemd160.js
  var require_ripemd160 = __commonJS({
    "node_modules/crypto-js/ripemd160.js"(exports, module) {
      (function(root, factory) {
        if (typeof exports === "object") {
          module.exports = exports = factory(require_core());
        } else if (typeof define === "function" && define.amd) {
          define(["./core"], factory);
        } else {
          factory(root.CryptoJS);
        }
      })(exports, function(CryptoJS) {
        (function(Math2) {
          var C = CryptoJS;
          var C_lib = C.lib;
          var WordArray = C_lib.WordArray;
          var Hasher = C_lib.Hasher;
          var C_algo = C.algo;
          var _zl = WordArray.create([
            0,
            1,
            2,
            3,
            4,
            5,
            6,
            7,
            8,
            9,
            10,
            11,
            12,
            13,
            14,
            15,
            7,
            4,
            13,
            1,
            10,
            6,
            15,
            3,
            12,
            0,
            9,
            5,
            2,
            14,
            11,
            8,
            3,
            10,
            14,
            4,
            9,
            15,
            8,
            1,
            2,
            7,
            0,
            6,
            13,
            11,
            5,
            12,
            1,
            9,
            11,
            10,
            0,
            8,
            12,
            4,
            13,
            3,
            7,
            15,
            14,
            5,
            6,
            2,
            4,
            0,
            5,
            9,
            7,
            12,
            2,
            10,
            14,
            1,
            3,
            8,
            11,
            6,
            15,
            13
          ]);
          var _zr = WordArray.create([
            5,
            14,
            7,
            0,
            9,
            2,
            11,
            4,
            13,
            6,
            15,
            8,
            1,
            10,
            3,
            12,
            6,
            11,
            3,
            7,
            0,
            13,
            5,
            10,
            14,
            15,
            8,
            12,
            4,
            9,
            1,
            2,
            15,
            5,
            1,
            3,
            7,
            14,
            6,
            9,
            11,
            8,
            12,
            2,
            10,
            0,
            4,
            13,
            8,
            6,
            4,
            1,
            3,
            11,
            15,
            0,
            5,
            12,
            2,
            13,
            9,
            7,
            10,
            14,
            12,
            15,
            10,
            4,
            1,
            5,
            8,
            7,
            6,
            2,
            13,
            14,
            0,
            3,
            9,
            11
          ]);
          var _sl = WordArray.create([
            11,
            14,
            15,
            12,
            5,
            8,
            7,
            9,
            11,
            13,
            14,
            15,
            6,
            7,
            9,
            8,
            7,
            6,
            8,
            13,
            11,
            9,
            7,
            15,
            7,
            12,
            15,
            9,
            11,
            7,
            13,
            12,
            11,
            13,
            6,
            7,
            14,
            9,
            13,
            15,
            14,
            8,
            13,
            6,
            5,
            12,
            7,
            5,
            11,
            12,
            14,
            15,
            14,
            15,
            9,
            8,
            9,
            14,
            5,
            6,
            8,
            6,
            5,
            12,
            9,
            15,
            5,
            11,
            6,
            8,
            13,
            12,
            5,
            12,
            13,
            14,
            11,
            8,
            5,
            6
          ]);
          var _sr = WordArray.create([
            8,
            9,
            9,
            11,
            13,
            15,
            15,
            5,
            7,
            7,
            8,
            11,
            14,
            14,
            12,
            6,
            9,
            13,
            15,
            7,
            12,
            8,
            9,
            11,
            7,
            7,
            12,
            7,
            6,
            15,
            13,
            11,
            9,
            7,
            15,
            11,
            8,
            6,
            6,
            14,
            12,
            13,
            5,
            14,
            13,
            13,
            7,
            5,
            15,
            5,
            8,
            11,
            14,
            14,
            6,
            14,
            6,
            9,
            12,
            9,
            12,
            5,
            15,
            8,
            8,
            5,
            12,
            9,
            12,
            5,
            14,
            6,
            8,
            13,
            6,
            5,
            15,
            13,
            11,
            11
          ]);
          var _hl = WordArray.create([0, 1518500249, 1859775393, 2400959708, 2840853838]);
          var _hr = WordArray.create([1352829926, 1548603684, 1836072691, 2053994217, 0]);
          var RIPEMD160 = C_algo.RIPEMD160 = Hasher.extend({
            _doReset: function() {
              this._hash = WordArray.create([1732584193, 4023233417, 2562383102, 271733878, 3285377520]);
            },
            _doProcessBlock: function(M, offset) {
              for (var i = 0; i < 16; i++) {
                var offset_i = offset + i;
                var M_offset_i = M[offset_i];
                M[offset_i] = (M_offset_i << 8 | M_offset_i >>> 24) & 16711935 | (M_offset_i << 24 | M_offset_i >>> 8) & 4278255360;
              }
              var H = this._hash.words;
              var hl = _hl.words;
              var hr = _hr.words;
              var zl = _zl.words;
              var zr = _zr.words;
              var sl = _sl.words;
              var sr = _sr.words;
              var al, bl, cl, dl, el;
              var ar, br, cr, dr, er;
              ar = al = H[0];
              br = bl = H[1];
              cr = cl = H[2];
              dr = dl = H[3];
              er = el = H[4];
              var t;
              for (var i = 0; i < 80; i += 1) {
                t = al + M[offset + zl[i]] | 0;
                if (i < 16) {
                  t += f1(bl, cl, dl) + hl[0];
                } else if (i < 32) {
                  t += f2(bl, cl, dl) + hl[1];
                } else if (i < 48) {
                  t += f3(bl, cl, dl) + hl[2];
                } else if (i < 64) {
                  t += f4(bl, cl, dl) + hl[3];
                } else {
                  t += f5(bl, cl, dl) + hl[4];
                }
                t = t | 0;
                t = rotl(t, sl[i]);
                t = t + el | 0;
                al = el;
                el = dl;
                dl = rotl(cl, 10);
                cl = bl;
                bl = t;
                t = ar + M[offset + zr[i]] | 0;
                if (i < 16) {
                  t += f5(br, cr, dr) + hr[0];
                } else if (i < 32) {
                  t += f4(br, cr, dr) + hr[1];
                } else if (i < 48) {
                  t += f3(br, cr, dr) + hr[2];
                } else if (i < 64) {
                  t += f2(br, cr, dr) + hr[3];
                } else {
                  t += f1(br, cr, dr) + hr[4];
                }
                t = t | 0;
                t = rotl(t, sr[i]);
                t = t + er | 0;
                ar = er;
                er = dr;
                dr = rotl(cr, 10);
                cr = br;
                br = t;
              }
              t = H[1] + cl + dr | 0;
              H[1] = H[2] + dl + er | 0;
              H[2] = H[3] + el + ar | 0;
              H[3] = H[4] + al + br | 0;
              H[4] = H[0] + bl + cr | 0;
              H[0] = t;
            },
            _doFinalize: function() {
              var data = this._data;
              var dataWords = data.words;
              var nBitsTotal = this._nDataBytes * 8;
              var nBitsLeft = data.sigBytes * 8;
              dataWords[nBitsLeft >>> 5] |= 128 << 24 - nBitsLeft % 32;
              dataWords[(nBitsLeft + 64 >>> 9 << 4) + 14] = (nBitsTotal << 8 | nBitsTotal >>> 24) & 16711935 | (nBitsTotal << 24 | nBitsTotal >>> 8) & 4278255360;
              data.sigBytes = (dataWords.length + 1) * 4;
              this._process();
              var hash = this._hash;
              var H = hash.words;
              for (var i = 0; i < 5; i++) {
                var H_i = H[i];
                H[i] = (H_i << 8 | H_i >>> 24) & 16711935 | (H_i << 24 | H_i >>> 8) & 4278255360;
              }
              return hash;
            },
            clone: function() {
              var clone = Hasher.clone.call(this);
              clone._hash = this._hash.clone();
              return clone;
            }
          });
          function f1(x, y, z) {
            return x ^ y ^ z;
          }
          function f2(x, y, z) {
            return x & y | ~x & z;
          }
          function f3(x, y, z) {
            return (x | ~y) ^ z;
          }
          function f4(x, y, z) {
            return x & z | y & ~z;
          }
          function f5(x, y, z) {
            return x ^ (y | ~z);
          }
          function rotl(x, n) {
            return x << n | x >>> 32 - n;
          }
          C.RIPEMD160 = Hasher._createHelper(RIPEMD160);
          C.HmacRIPEMD160 = Hasher._createHmacHelper(RIPEMD160);
        })(Math);
        return CryptoJS.RIPEMD160;
      });
    }
  });

  // node_modules/crypto-js/hmac.js
  var require_hmac = __commonJS({
    "node_modules/crypto-js/hmac.js"(exports, module) {
      (function(root, factory) {
        if (typeof exports === "object") {
          module.exports = exports = factory(require_core());
        } else if (typeof define === "function" && define.amd) {
          define(["./core"], factory);
        } else {
          factory(root.CryptoJS);
        }
      })(exports, function(CryptoJS) {
        (function() {
          var C = CryptoJS;
          var C_lib = C.lib;
          var Base = C_lib.Base;
          var C_enc = C.enc;
          var Utf8 = C_enc.Utf8;
          var C_algo = C.algo;
          var HMAC = C_algo.HMAC = Base.extend({
            /**
             * Initializes a newly created HMAC.
             *
             * @param {Hasher} hasher The hash algorithm to use.
             * @param {WordArray|string} key The secret key.
             *
             * @example
             *
             *     var hmacHasher = CryptoJS.algo.HMAC.create(CryptoJS.algo.SHA256, key);
             */
            init: function(hasher, key) {
              hasher = this._hasher = new hasher.init();
              if (typeof key == "string") {
                key = Utf8.parse(key);
              }
              var hasherBlockSize = hasher.blockSize;
              var hasherBlockSizeBytes = hasherBlockSize * 4;
              if (key.sigBytes > hasherBlockSizeBytes) {
                key = hasher.finalize(key);
              }
              key.clamp();
              var oKey = this._oKey = key.clone();
              var iKey = this._iKey = key.clone();
              var oKeyWords = oKey.words;
              var iKeyWords = iKey.words;
              for (var i = 0; i < hasherBlockSize; i++) {
                oKeyWords[i] ^= 1549556828;
                iKeyWords[i] ^= 909522486;
              }
              oKey.sigBytes = iKey.sigBytes = hasherBlockSizeBytes;
              this.reset();
            },
            /**
             * Resets this HMAC to its initial state.
             *
             * @example
             *
             *     hmacHasher.reset();
             */
            reset: function() {
              var hasher = this._hasher;
              hasher.reset();
              hasher.update(this._iKey);
            },
            /**
             * Updates this HMAC with a message.
             *
             * @param {WordArray|string} messageUpdate The message to append.
             *
             * @return {HMAC} This HMAC instance.
             *
             * @example
             *
             *     hmacHasher.update('message');
             *     hmacHasher.update(wordArray);
             */
            update: function(messageUpdate) {
              this._hasher.update(messageUpdate);
              return this;
            },
            /**
             * Finalizes the HMAC computation.
             * Note that the finalize operation is effectively a destructive, read-once operation.
             *
             * @param {WordArray|string} messageUpdate (Optional) A final message update.
             *
             * @return {WordArray} The HMAC.
             *
             * @example
             *
             *     var hmac = hmacHasher.finalize();
             *     var hmac = hmacHasher.finalize('message');
             *     var hmac = hmacHasher.finalize(wordArray);
             */
            finalize: function(messageUpdate) {
              var hasher = this._hasher;
              var innerHash = hasher.finalize(messageUpdate);
              hasher.reset();
              var hmac = hasher.finalize(this._oKey.clone().concat(innerHash));
              return hmac;
            }
          });
        })();
      });
    }
  });

  // node_modules/crypto-js/pbkdf2.js
  var require_pbkdf2 = __commonJS({
    "node_modules/crypto-js/pbkdf2.js"(exports, module) {
      (function(root, factory, undef) {
        if (typeof exports === "object") {
          module.exports = exports = factory(require_core(), require_sha1(), require_hmac());
        } else if (typeof define === "function" && define.amd) {
          define(["./core", "./sha1", "./hmac"], factory);
        } else {
          factory(root.CryptoJS);
        }
      })(exports, function(CryptoJS) {
        (function() {
          var C = CryptoJS;
          var C_lib = C.lib;
          var Base = C_lib.Base;
          var WordArray = C_lib.WordArray;
          var C_algo = C.algo;
          var SHA1 = C_algo.SHA1;
          var HMAC = C_algo.HMAC;
          var PBKDF2 = C_algo.PBKDF2 = Base.extend({
            /**
             * Configuration options.
             *
             * @property {number} keySize The key size in words to generate. Default: 4 (128 bits)
             * @property {Hasher} hasher The hasher to use. Default: SHA1
             * @property {number} iterations The number of iterations to perform. Default: 1
             */
            cfg: Base.extend({
              keySize: 128 / 32,
              hasher: SHA1,
              iterations: 1
            }),
            /**
             * Initializes a newly created key derivation function.
             *
             * @param {Object} cfg (Optional) The configuration options to use for the derivation.
             *
             * @example
             *
             *     var kdf = CryptoJS.algo.PBKDF2.create();
             *     var kdf = CryptoJS.algo.PBKDF2.create({ keySize: 8 });
             *     var kdf = CryptoJS.algo.PBKDF2.create({ keySize: 8, iterations: 1000 });
             */
            init: function(cfg) {
              this.cfg = this.cfg.extend(cfg);
            },
            /**
             * Computes the Password-Based Key Derivation Function 2.
             *
             * @param {WordArray|string} password The password.
             * @param {WordArray|string} salt A salt.
             *
             * @return {WordArray} The derived key.
             *
             * @example
             *
             *     var key = kdf.compute(password, salt);
             */
            compute: function(password, salt) {
              var cfg = this.cfg;
              var hmac = HMAC.create(cfg.hasher, password);
              var derivedKey = WordArray.create();
              var blockIndex = WordArray.create([1]);
              var derivedKeyWords = derivedKey.words;
              var blockIndexWords = blockIndex.words;
              var keySize = cfg.keySize;
              var iterations = cfg.iterations;
              while (derivedKeyWords.length < keySize) {
                var block = hmac.update(salt).finalize(blockIndex);
                hmac.reset();
                var blockWords = block.words;
                var blockWordsLength = blockWords.length;
                var intermediate = block;
                for (var i = 1; i < iterations; i++) {
                  intermediate = hmac.finalize(intermediate);
                  hmac.reset();
                  var intermediateWords = intermediate.words;
                  for (var j = 0; j < blockWordsLength; j++) {
                    blockWords[j] ^= intermediateWords[j];
                  }
                }
                derivedKey.concat(block);
                blockIndexWords[0]++;
              }
              derivedKey.sigBytes = keySize * 4;
              return derivedKey;
            }
          });
          C.PBKDF2 = function(password, salt, cfg) {
            return PBKDF2.create(cfg).compute(password, salt);
          };
        })();
        return CryptoJS.PBKDF2;
      });
    }
  });

  // node_modules/crypto-js/evpkdf.js
  var require_evpkdf = __commonJS({
    "node_modules/crypto-js/evpkdf.js"(exports, module) {
      (function(root, factory, undef) {
        if (typeof exports === "object") {
          module.exports = exports = factory(require_core(), require_sha1(), require_hmac());
        } else if (typeof define === "function" && define.amd) {
          define(["./core", "./sha1", "./hmac"], factory);
        } else {
          factory(root.CryptoJS);
        }
      })(exports, function(CryptoJS) {
        (function() {
          var C = CryptoJS;
          var C_lib = C.lib;
          var Base = C_lib.Base;
          var WordArray = C_lib.WordArray;
          var C_algo = C.algo;
          var MD5 = C_algo.MD5;
          var EvpKDF = C_algo.EvpKDF = Base.extend({
            /**
             * Configuration options.
             *
             * @property {number} keySize The key size in words to generate. Default: 4 (128 bits)
             * @property {Hasher} hasher The hash algorithm to use. Default: MD5
             * @property {number} iterations The number of iterations to perform. Default: 1
             */
            cfg: Base.extend({
              keySize: 128 / 32,
              hasher: MD5,
              iterations: 1
            }),
            /**
             * Initializes a newly created key derivation function.
             *
             * @param {Object} cfg (Optional) The configuration options to use for the derivation.
             *
             * @example
             *
             *     var kdf = CryptoJS.algo.EvpKDF.create();
             *     var kdf = CryptoJS.algo.EvpKDF.create({ keySize: 8 });
             *     var kdf = CryptoJS.algo.EvpKDF.create({ keySize: 8, iterations: 1000 });
             */
            init: function(cfg) {
              this.cfg = this.cfg.extend(cfg);
            },
            /**
             * Derives a key from a password.
             *
             * @param {WordArray|string} password The password.
             * @param {WordArray|string} salt A salt.
             *
             * @return {WordArray} The derived key.
             *
             * @example
             *
             *     var key = kdf.compute(password, salt);
             */
            compute: function(password, salt) {
              var block;
              var cfg = this.cfg;
              var hasher = cfg.hasher.create();
              var derivedKey = WordArray.create();
              var derivedKeyWords = derivedKey.words;
              var keySize = cfg.keySize;
              var iterations = cfg.iterations;
              while (derivedKeyWords.length < keySize) {
                if (block) {
                  hasher.update(block);
                }
                block = hasher.update(password).finalize(salt);
                hasher.reset();
                for (var i = 1; i < iterations; i++) {
                  block = hasher.finalize(block);
                  hasher.reset();
                }
                derivedKey.concat(block);
              }
              derivedKey.sigBytes = keySize * 4;
              return derivedKey;
            }
          });
          C.EvpKDF = function(password, salt, cfg) {
            return EvpKDF.create(cfg).compute(password, salt);
          };
        })();
        return CryptoJS.EvpKDF;
      });
    }
  });

  // node_modules/crypto-js/cipher-core.js
  var require_cipher_core = __commonJS({
    "node_modules/crypto-js/cipher-core.js"(exports, module) {
      (function(root, factory, undef) {
        if (typeof exports === "object") {
          module.exports = exports = factory(require_core(), require_evpkdf());
        } else if (typeof define === "function" && define.amd) {
          define(["./core", "./evpkdf"], factory);
        } else {
          factory(root.CryptoJS);
        }
      })(exports, function(CryptoJS) {
        CryptoJS.lib.Cipher || function(undefined2) {
          var C = CryptoJS;
          var C_lib = C.lib;
          var Base = C_lib.Base;
          var WordArray = C_lib.WordArray;
          var BufferedBlockAlgorithm = C_lib.BufferedBlockAlgorithm;
          var C_enc = C.enc;
          var Utf8 = C_enc.Utf8;
          var Base64 = C_enc.Base64;
          var C_algo = C.algo;
          var EvpKDF = C_algo.EvpKDF;
          var Cipher = C_lib.Cipher = BufferedBlockAlgorithm.extend({
            /**
             * Configuration options.
             *
             * @property {WordArray} iv The IV to use for this operation.
             */
            cfg: Base.extend(),
            /**
             * Creates this cipher in encryption mode.
             *
             * @param {WordArray} key The key.
             * @param {Object} cfg (Optional) The configuration options to use for this operation.
             *
             * @return {Cipher} A cipher instance.
             *
             * @static
             *
             * @example
             *
             *     var cipher = CryptoJS.algo.AES.createEncryptor(keyWordArray, { iv: ivWordArray });
             */
            createEncryptor: function(key, cfg) {
              return this.create(this._ENC_XFORM_MODE, key, cfg);
            },
            /**
             * Creates this cipher in decryption mode.
             *
             * @param {WordArray} key The key.
             * @param {Object} cfg (Optional) The configuration options to use for this operation.
             *
             * @return {Cipher} A cipher instance.
             *
             * @static
             *
             * @example
             *
             *     var cipher = CryptoJS.algo.AES.createDecryptor(keyWordArray, { iv: ivWordArray });
             */
            createDecryptor: function(key, cfg) {
              return this.create(this._DEC_XFORM_MODE, key, cfg);
            },
            /**
             * Initializes a newly created cipher.
             *
             * @param {number} xformMode Either the encryption or decryption transormation mode constant.
             * @param {WordArray} key The key.
             * @param {Object} cfg (Optional) The configuration options to use for this operation.
             *
             * @example
             *
             *     var cipher = CryptoJS.algo.AES.create(CryptoJS.algo.AES._ENC_XFORM_MODE, keyWordArray, { iv: ivWordArray });
             */
            init: function(xformMode, key, cfg) {
              this.cfg = this.cfg.extend(cfg);
              this._xformMode = xformMode;
              this._key = key;
              this.reset();
            },
            /**
             * Resets this cipher to its initial state.
             *
             * @example
             *
             *     cipher.reset();
             */
            reset: function() {
              BufferedBlockAlgorithm.reset.call(this);
              this._doReset();
            },
            /**
             * Adds data to be encrypted or decrypted.
             *
             * @param {WordArray|string} dataUpdate The data to encrypt or decrypt.
             *
             * @return {WordArray} The data after processing.
             *
             * @example
             *
             *     var encrypted = cipher.process('data');
             *     var encrypted = cipher.process(wordArray);
             */
            process: function(dataUpdate) {
              this._append(dataUpdate);
              return this._process();
            },
            /**
             * Finalizes the encryption or decryption process.
             * Note that the finalize operation is effectively a destructive, read-once operation.
             *
             * @param {WordArray|string} dataUpdate The final data to encrypt or decrypt.
             *
             * @return {WordArray} The data after final processing.
             *
             * @example
             *
             *     var encrypted = cipher.finalize();
             *     var encrypted = cipher.finalize('data');
             *     var encrypted = cipher.finalize(wordArray);
             */
            finalize: function(dataUpdate) {
              if (dataUpdate) {
                this._append(dataUpdate);
              }
              var finalProcessedData = this._doFinalize();
              return finalProcessedData;
            },
            keySize: 128 / 32,
            ivSize: 128 / 32,
            _ENC_XFORM_MODE: 1,
            _DEC_XFORM_MODE: 2,
            /**
             * Creates shortcut functions to a cipher's object interface.
             *
             * @param {Cipher} cipher The cipher to create a helper for.
             *
             * @return {Object} An object with encrypt and decrypt shortcut functions.
             *
             * @static
             *
             * @example
             *
             *     var AES = CryptoJS.lib.Cipher._createHelper(CryptoJS.algo.AES);
             */
            _createHelper: function() {
              function selectCipherStrategy(key) {
                if (typeof key == "string") {
                  return PasswordBasedCipher;
                } else {
                  return SerializableCipher;
                }
              }
              return function(cipher) {
                return {
                  encrypt: function(message, key, cfg) {
                    return selectCipherStrategy(key).encrypt(cipher, message, key, cfg);
                  },
                  decrypt: function(ciphertext, key, cfg) {
                    return selectCipherStrategy(key).decrypt(cipher, ciphertext, key, cfg);
                  }
                };
              };
            }()
          });
          var StreamCipher = C_lib.StreamCipher = Cipher.extend({
            _doFinalize: function() {
              var finalProcessedBlocks = this._process(true);
              return finalProcessedBlocks;
            },
            blockSize: 1
          });
          var C_mode = C.mode = {};
          var BlockCipherMode = C_lib.BlockCipherMode = Base.extend({
            /**
             * Creates this mode for encryption.
             *
             * @param {Cipher} cipher A block cipher instance.
             * @param {Array} iv The IV words.
             *
             * @static
             *
             * @example
             *
             *     var mode = CryptoJS.mode.CBC.createEncryptor(cipher, iv.words);
             */
            createEncryptor: function(cipher, iv) {
              return this.Encryptor.create(cipher, iv);
            },
            /**
             * Creates this mode for decryption.
             *
             * @param {Cipher} cipher A block cipher instance.
             * @param {Array} iv The IV words.
             *
             * @static
             *
             * @example
             *
             *     var mode = CryptoJS.mode.CBC.createDecryptor(cipher, iv.words);
             */
            createDecryptor: function(cipher, iv) {
              return this.Decryptor.create(cipher, iv);
            },
            /**
             * Initializes a newly created mode.
             *
             * @param {Cipher} cipher A block cipher instance.
             * @param {Array} iv The IV words.
             *
             * @example
             *
             *     var mode = CryptoJS.mode.CBC.Encryptor.create(cipher, iv.words);
             */
            init: function(cipher, iv) {
              this._cipher = cipher;
              this._iv = iv;
            }
          });
          var CBC = C_mode.CBC = function() {
            var CBC2 = BlockCipherMode.extend();
            CBC2.Encryptor = CBC2.extend({
              /**
               * Processes the data block at offset.
               *
               * @param {Array} words The data words to operate on.
               * @param {number} offset The offset where the block starts.
               *
               * @example
               *
               *     mode.processBlock(data.words, offset);
               */
              processBlock: function(words, offset) {
                var cipher = this._cipher;
                var blockSize = cipher.blockSize;
                xorBlock.call(this, words, offset, blockSize);
                cipher.encryptBlock(words, offset);
                this._prevBlock = words.slice(offset, offset + blockSize);
              }
            });
            CBC2.Decryptor = CBC2.extend({
              /**
               * Processes the data block at offset.
               *
               * @param {Array} words The data words to operate on.
               * @param {number} offset The offset where the block starts.
               *
               * @example
               *
               *     mode.processBlock(data.words, offset);
               */
              processBlock: function(words, offset) {
                var cipher = this._cipher;
                var blockSize = cipher.blockSize;
                var thisBlock = words.slice(offset, offset + blockSize);
                cipher.decryptBlock(words, offset);
                xorBlock.call(this, words, offset, blockSize);
                this._prevBlock = thisBlock;
              }
            });
            function xorBlock(words, offset, blockSize) {
              var block;
              var iv = this._iv;
              if (iv) {
                block = iv;
                this._iv = undefined2;
              } else {
                block = this._prevBlock;
              }
              for (var i = 0; i < blockSize; i++) {
                words[offset + i] ^= block[i];
              }
            }
            return CBC2;
          }();
          var C_pad = C.pad = {};
          var Pkcs7 = C_pad.Pkcs7 = {
            /**
             * Pads data using the algorithm defined in PKCS #5/7.
             *
             * @param {WordArray} data The data to pad.
             * @param {number} blockSize The multiple that the data should be padded to.
             *
             * @static
             *
             * @example
             *
             *     CryptoJS.pad.Pkcs7.pad(wordArray, 4);
             */
            pad: function(data, blockSize) {
              var blockSizeBytes = blockSize * 4;
              var nPaddingBytes = blockSizeBytes - data.sigBytes % blockSizeBytes;
              var paddingWord = nPaddingBytes << 24 | nPaddingBytes << 16 | nPaddingBytes << 8 | nPaddingBytes;
              var paddingWords = [];
              for (var i = 0; i < nPaddingBytes; i += 4) {
                paddingWords.push(paddingWord);
              }
              var padding = WordArray.create(paddingWords, nPaddingBytes);
              data.concat(padding);
            },
            /**
             * Unpads data that had been padded using the algorithm defined in PKCS #5/7.
             *
             * @param {WordArray} data The data to unpad.
             *
             * @static
             *
             * @example
             *
             *     CryptoJS.pad.Pkcs7.unpad(wordArray);
             */
            unpad: function(data) {
              var nPaddingBytes = data.words[data.sigBytes - 1 >>> 2] & 255;
              data.sigBytes -= nPaddingBytes;
            }
          };
          var BlockCipher = C_lib.BlockCipher = Cipher.extend({
            /**
             * Configuration options.
             *
             * @property {Mode} mode The block mode to use. Default: CBC
             * @property {Padding} padding The padding strategy to use. Default: Pkcs7
             */
            cfg: Cipher.cfg.extend({
              mode: CBC,
              padding: Pkcs7
            }),
            reset: function() {
              var modeCreator;
              Cipher.reset.call(this);
              var cfg = this.cfg;
              var iv = cfg.iv;
              var mode = cfg.mode;
              if (this._xformMode == this._ENC_XFORM_MODE) {
                modeCreator = mode.createEncryptor;
              } else {
                modeCreator = mode.createDecryptor;
                this._minBufferSize = 1;
              }
              if (this._mode && this._mode.__creator == modeCreator) {
                this._mode.init(this, iv && iv.words);
              } else {
                this._mode = modeCreator.call(mode, this, iv && iv.words);
                this._mode.__creator = modeCreator;
              }
            },
            _doProcessBlock: function(words, offset) {
              this._mode.processBlock(words, offset);
            },
            _doFinalize: function() {
              var finalProcessedBlocks;
              var padding = this.cfg.padding;
              if (this._xformMode == this._ENC_XFORM_MODE) {
                padding.pad(this._data, this.blockSize);
                finalProcessedBlocks = this._process(true);
              } else {
                finalProcessedBlocks = this._process(true);
                padding.unpad(finalProcessedBlocks);
              }
              return finalProcessedBlocks;
            },
            blockSize: 128 / 32
          });
          var CipherParams = C_lib.CipherParams = Base.extend({
            /**
             * Initializes a newly created cipher params object.
             *
             * @param {Object} cipherParams An object with any of the possible cipher parameters.
             *
             * @example
             *
             *     var cipherParams = CryptoJS.lib.CipherParams.create({
             *         ciphertext: ciphertextWordArray,
             *         key: keyWordArray,
             *         iv: ivWordArray,
             *         salt: saltWordArray,
             *         algorithm: CryptoJS.algo.AES,
             *         mode: CryptoJS.mode.CBC,
             *         padding: CryptoJS.pad.PKCS7,
             *         blockSize: 4,
             *         formatter: CryptoJS.format.OpenSSL
             *     });
             */
            init: function(cipherParams) {
              this.mixIn(cipherParams);
            },
            /**
             * Converts this cipher params object to a string.
             *
             * @param {Format} formatter (Optional) The formatting strategy to use.
             *
             * @return {string} The stringified cipher params.
             *
             * @throws Error If neither the formatter nor the default formatter is set.
             *
             * @example
             *
             *     var string = cipherParams + '';
             *     var string = cipherParams.toString();
             *     var string = cipherParams.toString(CryptoJS.format.OpenSSL);
             */
            toString: function(formatter) {
              return (formatter || this.formatter).stringify(this);
            }
          });
          var C_format = C.format = {};
          var OpenSSLFormatter = C_format.OpenSSL = {
            /**
             * Converts a cipher params object to an OpenSSL-compatible string.
             *
             * @param {CipherParams} cipherParams The cipher params object.
             *
             * @return {string} The OpenSSL-compatible string.
             *
             * @static
             *
             * @example
             *
             *     var openSSLString = CryptoJS.format.OpenSSL.stringify(cipherParams);
             */
            stringify: function(cipherParams) {
              var wordArray;
              var ciphertext = cipherParams.ciphertext;
              var salt = cipherParams.salt;
              if (salt) {
                wordArray = WordArray.create([1398893684, 1701076831]).concat(salt).concat(ciphertext);
              } else {
                wordArray = ciphertext;
              }
              return wordArray.toString(Base64);
            },
            /**
             * Converts an OpenSSL-compatible string to a cipher params object.
             *
             * @param {string} openSSLStr The OpenSSL-compatible string.
             *
             * @return {CipherParams} The cipher params object.
             *
             * @static
             *
             * @example
             *
             *     var cipherParams = CryptoJS.format.OpenSSL.parse(openSSLString);
             */
            parse: function(openSSLStr) {
              var salt;
              var ciphertext = Base64.parse(openSSLStr);
              var ciphertextWords = ciphertext.words;
              if (ciphertextWords[0] == 1398893684 && ciphertextWords[1] == 1701076831) {
                salt = WordArray.create(ciphertextWords.slice(2, 4));
                ciphertextWords.splice(0, 4);
                ciphertext.sigBytes -= 16;
              }
              return CipherParams.create({ ciphertext, salt });
            }
          };
          var SerializableCipher = C_lib.SerializableCipher = Base.extend({
            /**
             * Configuration options.
             *
             * @property {Formatter} format The formatting strategy to convert cipher param objects to and from a string. Default: OpenSSL
             */
            cfg: Base.extend({
              format: OpenSSLFormatter
            }),
            /**
             * Encrypts a message.
             *
             * @param {Cipher} cipher The cipher algorithm to use.
             * @param {WordArray|string} message The message to encrypt.
             * @param {WordArray} key The key.
             * @param {Object} cfg (Optional) The configuration options to use for this operation.
             *
             * @return {CipherParams} A cipher params object.
             *
             * @static
             *
             * @example
             *
             *     var ciphertextParams = CryptoJS.lib.SerializableCipher.encrypt(CryptoJS.algo.AES, message, key);
             *     var ciphertextParams = CryptoJS.lib.SerializableCipher.encrypt(CryptoJS.algo.AES, message, key, { iv: iv });
             *     var ciphertextParams = CryptoJS.lib.SerializableCipher.encrypt(CryptoJS.algo.AES, message, key, { iv: iv, format: CryptoJS.format.OpenSSL });
             */
            encrypt: function(cipher, message, key, cfg) {
              cfg = this.cfg.extend(cfg);
              var encryptor = cipher.createEncryptor(key, cfg);
              var ciphertext = encryptor.finalize(message);
              var cipherCfg = encryptor.cfg;
              return CipherParams.create({
                ciphertext,
                key,
                iv: cipherCfg.iv,
                algorithm: cipher,
                mode: cipherCfg.mode,
                padding: cipherCfg.padding,
                blockSize: cipher.blockSize,
                formatter: cfg.format
              });
            },
            /**
             * Decrypts serialized ciphertext.
             *
             * @param {Cipher} cipher The cipher algorithm to use.
             * @param {CipherParams|string} ciphertext The ciphertext to decrypt.
             * @param {WordArray} key The key.
             * @param {Object} cfg (Optional) The configuration options to use for this operation.
             *
             * @return {WordArray} The plaintext.
             *
             * @static
             *
             * @example
             *
             *     var plaintext = CryptoJS.lib.SerializableCipher.decrypt(CryptoJS.algo.AES, formattedCiphertext, key, { iv: iv, format: CryptoJS.format.OpenSSL });
             *     var plaintext = CryptoJS.lib.SerializableCipher.decrypt(CryptoJS.algo.AES, ciphertextParams, key, { iv: iv, format: CryptoJS.format.OpenSSL });
             */
            decrypt: function(cipher, ciphertext, key, cfg) {
              cfg = this.cfg.extend(cfg);
              ciphertext = this._parse(ciphertext, cfg.format);
              var plaintext = cipher.createDecryptor(key, cfg).finalize(ciphertext.ciphertext);
              return plaintext;
            },
            /**
             * Converts serialized ciphertext to CipherParams,
             * else assumed CipherParams already and returns ciphertext unchanged.
             *
             * @param {CipherParams|string} ciphertext The ciphertext.
             * @param {Formatter} format The formatting strategy to use to parse serialized ciphertext.
             *
             * @return {CipherParams} The unserialized ciphertext.
             *
             * @static
             *
             * @example
             *
             *     var ciphertextParams = CryptoJS.lib.SerializableCipher._parse(ciphertextStringOrParams, format);
             */
            _parse: function(ciphertext, format) {
              if (typeof ciphertext == "string") {
                return format.parse(ciphertext, this);
              } else {
                return ciphertext;
              }
            }
          });
          var C_kdf = C.kdf = {};
          var OpenSSLKdf = C_kdf.OpenSSL = {
            /**
             * Derives a key and IV from a password.
             *
             * @param {string} password The password to derive from.
             * @param {number} keySize The size in words of the key to generate.
             * @param {number} ivSize The size in words of the IV to generate.
             * @param {WordArray|string} salt (Optional) A 64-bit salt to use. If omitted, a salt will be generated randomly.
             *
             * @return {CipherParams} A cipher params object with the key, IV, and salt.
             *
             * @static
             *
             * @example
             *
             *     var derivedParams = CryptoJS.kdf.OpenSSL.execute('Password', 256/32, 128/32);
             *     var derivedParams = CryptoJS.kdf.OpenSSL.execute('Password', 256/32, 128/32, 'saltsalt');
             */
            execute: function(password, keySize, ivSize, salt) {
              if (!salt) {
                salt = WordArray.random(64 / 8);
              }
              var key = EvpKDF.create({ keySize: keySize + ivSize }).compute(password, salt);
              var iv = WordArray.create(key.words.slice(keySize), ivSize * 4);
              key.sigBytes = keySize * 4;
              return CipherParams.create({ key, iv, salt });
            }
          };
          var PasswordBasedCipher = C_lib.PasswordBasedCipher = SerializableCipher.extend({
            /**
             * Configuration options.
             *
             * @property {KDF} kdf The key derivation function to use to generate a key and IV from a password. Default: OpenSSL
             */
            cfg: SerializableCipher.cfg.extend({
              kdf: OpenSSLKdf
            }),
            /**
             * Encrypts a message using a password.
             *
             * @param {Cipher} cipher The cipher algorithm to use.
             * @param {WordArray|string} message The message to encrypt.
             * @param {string} password The password.
             * @param {Object} cfg (Optional) The configuration options to use for this operation.
             *
             * @return {CipherParams} A cipher params object.
             *
             * @static
             *
             * @example
             *
             *     var ciphertextParams = CryptoJS.lib.PasswordBasedCipher.encrypt(CryptoJS.algo.AES, message, 'password');
             *     var ciphertextParams = CryptoJS.lib.PasswordBasedCipher.encrypt(CryptoJS.algo.AES, message, 'password', { format: CryptoJS.format.OpenSSL });
             */
            encrypt: function(cipher, message, password, cfg) {
              cfg = this.cfg.extend(cfg);
              var derivedParams = cfg.kdf.execute(password, cipher.keySize, cipher.ivSize);
              cfg.iv = derivedParams.iv;
              var ciphertext = SerializableCipher.encrypt.call(this, cipher, message, derivedParams.key, cfg);
              ciphertext.mixIn(derivedParams);
              return ciphertext;
            },
            /**
             * Decrypts serialized ciphertext using a password.
             *
             * @param {Cipher} cipher The cipher algorithm to use.
             * @param {CipherParams|string} ciphertext The ciphertext to decrypt.
             * @param {string} password The password.
             * @param {Object} cfg (Optional) The configuration options to use for this operation.
             *
             * @return {WordArray} The plaintext.
             *
             * @static
             *
             * @example
             *
             *     var plaintext = CryptoJS.lib.PasswordBasedCipher.decrypt(CryptoJS.algo.AES, formattedCiphertext, 'password', { format: CryptoJS.format.OpenSSL });
             *     var plaintext = CryptoJS.lib.PasswordBasedCipher.decrypt(CryptoJS.algo.AES, ciphertextParams, 'password', { format: CryptoJS.format.OpenSSL });
             */
            decrypt: function(cipher, ciphertext, password, cfg) {
              cfg = this.cfg.extend(cfg);
              ciphertext = this._parse(ciphertext, cfg.format);
              var derivedParams = cfg.kdf.execute(password, cipher.keySize, cipher.ivSize, ciphertext.salt);
              cfg.iv = derivedParams.iv;
              var plaintext = SerializableCipher.decrypt.call(this, cipher, ciphertext, derivedParams.key, cfg);
              return plaintext;
            }
          });
        }();
      });
    }
  });

  // node_modules/crypto-js/mode-cfb.js
  var require_mode_cfb = __commonJS({
    "node_modules/crypto-js/mode-cfb.js"(exports, module) {
      (function(root, factory, undef) {
        if (typeof exports === "object") {
          module.exports = exports = factory(require_core(), require_cipher_core());
        } else if (typeof define === "function" && define.amd) {
          define(["./core", "./cipher-core"], factory);
        } else {
          factory(root.CryptoJS);
        }
      })(exports, function(CryptoJS) {
        CryptoJS.mode.CFB = function() {
          var CFB = CryptoJS.lib.BlockCipherMode.extend();
          CFB.Encryptor = CFB.extend({
            processBlock: function(words, offset) {
              var cipher = this._cipher;
              var blockSize = cipher.blockSize;
              generateKeystreamAndEncrypt.call(this, words, offset, blockSize, cipher);
              this._prevBlock = words.slice(offset, offset + blockSize);
            }
          });
          CFB.Decryptor = CFB.extend({
            processBlock: function(words, offset) {
              var cipher = this._cipher;
              var blockSize = cipher.blockSize;
              var thisBlock = words.slice(offset, offset + blockSize);
              generateKeystreamAndEncrypt.call(this, words, offset, blockSize, cipher);
              this._prevBlock = thisBlock;
            }
          });
          function generateKeystreamAndEncrypt(words, offset, blockSize, cipher) {
            var keystream;
            var iv = this._iv;
            if (iv) {
              keystream = iv.slice(0);
              this._iv = void 0;
            } else {
              keystream = this._prevBlock;
            }
            cipher.encryptBlock(keystream, 0);
            for (var i = 0; i < blockSize; i++) {
              words[offset + i] ^= keystream[i];
            }
          }
          return CFB;
        }();
        return CryptoJS.mode.CFB;
      });
    }
  });

  // node_modules/crypto-js/mode-ctr.js
  var require_mode_ctr = __commonJS({
    "node_modules/crypto-js/mode-ctr.js"(exports, module) {
      (function(root, factory, undef) {
        if (typeof exports === "object") {
          module.exports = exports = factory(require_core(), require_cipher_core());
        } else if (typeof define === "function" && define.amd) {
          define(["./core", "./cipher-core"], factory);
        } else {
          factory(root.CryptoJS);
        }
      })(exports, function(CryptoJS) {
        CryptoJS.mode.CTR = function() {
          var CTR = CryptoJS.lib.BlockCipherMode.extend();
          var Encryptor = CTR.Encryptor = CTR.extend({
            processBlock: function(words, offset) {
              var cipher = this._cipher;
              var blockSize = cipher.blockSize;
              var iv = this._iv;
              var counter = this._counter;
              if (iv) {
                counter = this._counter = iv.slice(0);
                this._iv = void 0;
              }
              var keystream = counter.slice(0);
              cipher.encryptBlock(keystream, 0);
              counter[blockSize - 1] = counter[blockSize - 1] + 1 | 0;
              for (var i = 0; i < blockSize; i++) {
                words[offset + i] ^= keystream[i];
              }
            }
          });
          CTR.Decryptor = Encryptor;
          return CTR;
        }();
        return CryptoJS.mode.CTR;
      });
    }
  });

  // node_modules/crypto-js/mode-ctr-gladman.js
  var require_mode_ctr_gladman = __commonJS({
    "node_modules/crypto-js/mode-ctr-gladman.js"(exports, module) {
      (function(root, factory, undef) {
        if (typeof exports === "object") {
          module.exports = exports = factory(require_core(), require_cipher_core());
        } else if (typeof define === "function" && define.amd) {
          define(["./core", "./cipher-core"], factory);
        } else {
          factory(root.CryptoJS);
        }
      })(exports, function(CryptoJS) {
        CryptoJS.mode.CTRGladman = function() {
          var CTRGladman = CryptoJS.lib.BlockCipherMode.extend();
          function incWord(word) {
            if ((word >> 24 & 255) === 255) {
              var b1 = word >> 16 & 255;
              var b2 = word >> 8 & 255;
              var b3 = word & 255;
              if (b1 === 255) {
                b1 = 0;
                if (b2 === 255) {
                  b2 = 0;
                  if (b3 === 255) {
                    b3 = 0;
                  } else {
                    ++b3;
                  }
                } else {
                  ++b2;
                }
              } else {
                ++b1;
              }
              word = 0;
              word += b1 << 16;
              word += b2 << 8;
              word += b3;
            } else {
              word += 1 << 24;
            }
            return word;
          }
          function incCounter(counter) {
            if ((counter[0] = incWord(counter[0])) === 0) {
              counter[1] = incWord(counter[1]);
            }
            return counter;
          }
          var Encryptor = CTRGladman.Encryptor = CTRGladman.extend({
            processBlock: function(words, offset) {
              var cipher = this._cipher;
              var blockSize = cipher.blockSize;
              var iv = this._iv;
              var counter = this._counter;
              if (iv) {
                counter = this._counter = iv.slice(0);
                this._iv = void 0;
              }
              incCounter(counter);
              var keystream = counter.slice(0);
              cipher.encryptBlock(keystream, 0);
              for (var i = 0; i < blockSize; i++) {
                words[offset + i] ^= keystream[i];
              }
            }
          });
          CTRGladman.Decryptor = Encryptor;
          return CTRGladman;
        }();
        return CryptoJS.mode.CTRGladman;
      });
    }
  });

  // node_modules/crypto-js/mode-ofb.js
  var require_mode_ofb = __commonJS({
    "node_modules/crypto-js/mode-ofb.js"(exports, module) {
      (function(root, factory, undef) {
        if (typeof exports === "object") {
          module.exports = exports = factory(require_core(), require_cipher_core());
        } else if (typeof define === "function" && define.amd) {
          define(["./core", "./cipher-core"], factory);
        } else {
          factory(root.CryptoJS);
        }
      })(exports, function(CryptoJS) {
        CryptoJS.mode.OFB = function() {
          var OFB = CryptoJS.lib.BlockCipherMode.extend();
          var Encryptor = OFB.Encryptor = OFB.extend({
            processBlock: function(words, offset) {
              var cipher = this._cipher;
              var blockSize = cipher.blockSize;
              var iv = this._iv;
              var keystream = this._keystream;
              if (iv) {
                keystream = this._keystream = iv.slice(0);
                this._iv = void 0;
              }
              cipher.encryptBlock(keystream, 0);
              for (var i = 0; i < blockSize; i++) {
                words[offset + i] ^= keystream[i];
              }
            }
          });
          OFB.Decryptor = Encryptor;
          return OFB;
        }();
        return CryptoJS.mode.OFB;
      });
    }
  });

  // node_modules/crypto-js/mode-ecb.js
  var require_mode_ecb = __commonJS({
    "node_modules/crypto-js/mode-ecb.js"(exports, module) {
      (function(root, factory, undef) {
        if (typeof exports === "object") {
          module.exports = exports = factory(require_core(), require_cipher_core());
        } else if (typeof define === "function" && define.amd) {
          define(["./core", "./cipher-core"], factory);
        } else {
          factory(root.CryptoJS);
        }
      })(exports, function(CryptoJS) {
        CryptoJS.mode.ECB = function() {
          var ECB = CryptoJS.lib.BlockCipherMode.extend();
          ECB.Encryptor = ECB.extend({
            processBlock: function(words, offset) {
              this._cipher.encryptBlock(words, offset);
            }
          });
          ECB.Decryptor = ECB.extend({
            processBlock: function(words, offset) {
              this._cipher.decryptBlock(words, offset);
            }
          });
          return ECB;
        }();
        return CryptoJS.mode.ECB;
      });
    }
  });

  // node_modules/crypto-js/pad-ansix923.js
  var require_pad_ansix923 = __commonJS({
    "node_modules/crypto-js/pad-ansix923.js"(exports, module) {
      (function(root, factory, undef) {
        if (typeof exports === "object") {
          module.exports = exports = factory(require_core(), require_cipher_core());
        } else if (typeof define === "function" && define.amd) {
          define(["./core", "./cipher-core"], factory);
        } else {
          factory(root.CryptoJS);
        }
      })(exports, function(CryptoJS) {
        CryptoJS.pad.AnsiX923 = {
          pad: function(data, blockSize) {
            var dataSigBytes = data.sigBytes;
            var blockSizeBytes = blockSize * 4;
            var nPaddingBytes = blockSizeBytes - dataSigBytes % blockSizeBytes;
            var lastBytePos = dataSigBytes + nPaddingBytes - 1;
            data.clamp();
            data.words[lastBytePos >>> 2] |= nPaddingBytes << 24 - lastBytePos % 4 * 8;
            data.sigBytes += nPaddingBytes;
          },
          unpad: function(data) {
            var nPaddingBytes = data.words[data.sigBytes - 1 >>> 2] & 255;
            data.sigBytes -= nPaddingBytes;
          }
        };
        return CryptoJS.pad.Ansix923;
      });
    }
  });

  // node_modules/crypto-js/pad-iso10126.js
  var require_pad_iso10126 = __commonJS({
    "node_modules/crypto-js/pad-iso10126.js"(exports, module) {
      (function(root, factory, undef) {
        if (typeof exports === "object") {
          module.exports = exports = factory(require_core(), require_cipher_core());
        } else if (typeof define === "function" && define.amd) {
          define(["./core", "./cipher-core"], factory);
        } else {
          factory(root.CryptoJS);
        }
      })(exports, function(CryptoJS) {
        CryptoJS.pad.Iso10126 = {
          pad: function(data, blockSize) {
            var blockSizeBytes = blockSize * 4;
            var nPaddingBytes = blockSizeBytes - data.sigBytes % blockSizeBytes;
            data.concat(CryptoJS.lib.WordArray.random(nPaddingBytes - 1)).concat(CryptoJS.lib.WordArray.create([nPaddingBytes << 24], 1));
          },
          unpad: function(data) {
            var nPaddingBytes = data.words[data.sigBytes - 1 >>> 2] & 255;
            data.sigBytes -= nPaddingBytes;
          }
        };
        return CryptoJS.pad.Iso10126;
      });
    }
  });

  // node_modules/crypto-js/pad-iso97971.js
  var require_pad_iso97971 = __commonJS({
    "node_modules/crypto-js/pad-iso97971.js"(exports, module) {
      (function(root, factory, undef) {
        if (typeof exports === "object") {
          module.exports = exports = factory(require_core(), require_cipher_core());
        } else if (typeof define === "function" && define.amd) {
          define(["./core", "./cipher-core"], factory);
        } else {
          factory(root.CryptoJS);
        }
      })(exports, function(CryptoJS) {
        CryptoJS.pad.Iso97971 = {
          pad: function(data, blockSize) {
            data.concat(CryptoJS.lib.WordArray.create([2147483648], 1));
            CryptoJS.pad.ZeroPadding.pad(data, blockSize);
          },
          unpad: function(data) {
            CryptoJS.pad.ZeroPadding.unpad(data);
            data.sigBytes--;
          }
        };
        return CryptoJS.pad.Iso97971;
      });
    }
  });

  // node_modules/crypto-js/pad-zeropadding.js
  var require_pad_zeropadding = __commonJS({
    "node_modules/crypto-js/pad-zeropadding.js"(exports, module) {
      (function(root, factory, undef) {
        if (typeof exports === "object") {
          module.exports = exports = factory(require_core(), require_cipher_core());
        } else if (typeof define === "function" && define.amd) {
          define(["./core", "./cipher-core"], factory);
        } else {
          factory(root.CryptoJS);
        }
      })(exports, function(CryptoJS) {
        CryptoJS.pad.ZeroPadding = {
          pad: function(data, blockSize) {
            var blockSizeBytes = blockSize * 4;
            data.clamp();
            data.sigBytes += blockSizeBytes - (data.sigBytes % blockSizeBytes || blockSizeBytes);
          },
          unpad: function(data) {
            var dataWords = data.words;
            var i = data.sigBytes - 1;
            for (var i = data.sigBytes - 1; i >= 0; i--) {
              if (dataWords[i >>> 2] >>> 24 - i % 4 * 8 & 255) {
                data.sigBytes = i + 1;
                break;
              }
            }
          }
        };
        return CryptoJS.pad.ZeroPadding;
      });
    }
  });

  // node_modules/crypto-js/pad-nopadding.js
  var require_pad_nopadding = __commonJS({
    "node_modules/crypto-js/pad-nopadding.js"(exports, module) {
      (function(root, factory, undef) {
        if (typeof exports === "object") {
          module.exports = exports = factory(require_core(), require_cipher_core());
        } else if (typeof define === "function" && define.amd) {
          define(["./core", "./cipher-core"], factory);
        } else {
          factory(root.CryptoJS);
        }
      })(exports, function(CryptoJS) {
        CryptoJS.pad.NoPadding = {
          pad: function() {
          },
          unpad: function() {
          }
        };
        return CryptoJS.pad.NoPadding;
      });
    }
  });

  // node_modules/crypto-js/format-hex.js
  var require_format_hex = __commonJS({
    "node_modules/crypto-js/format-hex.js"(exports, module) {
      (function(root, factory, undef) {
        if (typeof exports === "object") {
          module.exports = exports = factory(require_core(), require_cipher_core());
        } else if (typeof define === "function" && define.amd) {
          define(["./core", "./cipher-core"], factory);
        } else {
          factory(root.CryptoJS);
        }
      })(exports, function(CryptoJS) {
        (function(undefined2) {
          var C = CryptoJS;
          var C_lib = C.lib;
          var CipherParams = C_lib.CipherParams;
          var C_enc = C.enc;
          var Hex = C_enc.Hex;
          var C_format = C.format;
          var HexFormatter = C_format.Hex = {
            /**
             * Converts the ciphertext of a cipher params object to a hexadecimally encoded string.
             *
             * @param {CipherParams} cipherParams The cipher params object.
             *
             * @return {string} The hexadecimally encoded string.
             *
             * @static
             *
             * @example
             *
             *     var hexString = CryptoJS.format.Hex.stringify(cipherParams);
             */
            stringify: function(cipherParams) {
              return cipherParams.ciphertext.toString(Hex);
            },
            /**
             * Converts a hexadecimally encoded ciphertext string to a cipher params object.
             *
             * @param {string} input The hexadecimally encoded string.
             *
             * @return {CipherParams} The cipher params object.
             *
             * @static
             *
             * @example
             *
             *     var cipherParams = CryptoJS.format.Hex.parse(hexString);
             */
            parse: function(input) {
              var ciphertext = Hex.parse(input);
              return CipherParams.create({ ciphertext });
            }
          };
        })();
        return CryptoJS.format.Hex;
      });
    }
  });

  // node_modules/crypto-js/aes.js
  var require_aes = __commonJS({
    "node_modules/crypto-js/aes.js"(exports, module) {
      (function(root, factory, undef) {
        if (typeof exports === "object") {
          module.exports = exports = factory(require_core(), require_enc_base64(), require_md5(), require_evpkdf(), require_cipher_core());
        } else if (typeof define === "function" && define.amd) {
          define(["./core", "./enc-base64", "./md5", "./evpkdf", "./cipher-core"], factory);
        } else {
          factory(root.CryptoJS);
        }
      })(exports, function(CryptoJS) {
        (function() {
          var C = CryptoJS;
          var C_lib = C.lib;
          var BlockCipher = C_lib.BlockCipher;
          var C_algo = C.algo;
          var SBOX = [];
          var INV_SBOX = [];
          var SUB_MIX_0 = [];
          var SUB_MIX_1 = [];
          var SUB_MIX_2 = [];
          var SUB_MIX_3 = [];
          var INV_SUB_MIX_0 = [];
          var INV_SUB_MIX_1 = [];
          var INV_SUB_MIX_2 = [];
          var INV_SUB_MIX_3 = [];
          (function() {
            var d = [];
            for (var i = 0; i < 256; i++) {
              if (i < 128) {
                d[i] = i << 1;
              } else {
                d[i] = i << 1 ^ 283;
              }
            }
            var x = 0;
            var xi = 0;
            for (var i = 0; i < 256; i++) {
              var sx = xi ^ xi << 1 ^ xi << 2 ^ xi << 3 ^ xi << 4;
              sx = sx >>> 8 ^ sx & 255 ^ 99;
              SBOX[x] = sx;
              INV_SBOX[sx] = x;
              var x2 = d[x];
              var x4 = d[x2];
              var x8 = d[x4];
              var t = d[sx] * 257 ^ sx * 16843008;
              SUB_MIX_0[x] = t << 24 | t >>> 8;
              SUB_MIX_1[x] = t << 16 | t >>> 16;
              SUB_MIX_2[x] = t << 8 | t >>> 24;
              SUB_MIX_3[x] = t;
              var t = x8 * 16843009 ^ x4 * 65537 ^ x2 * 257 ^ x * 16843008;
              INV_SUB_MIX_0[sx] = t << 24 | t >>> 8;
              INV_SUB_MIX_1[sx] = t << 16 | t >>> 16;
              INV_SUB_MIX_2[sx] = t << 8 | t >>> 24;
              INV_SUB_MIX_3[sx] = t;
              if (!x) {
                x = xi = 1;
              } else {
                x = x2 ^ d[d[d[x8 ^ x2]]];
                xi ^= d[d[xi]];
              }
            }
          })();
          var RCON = [0, 1, 2, 4, 8, 16, 32, 64, 128, 27, 54];
          var AES = C_algo.AES = BlockCipher.extend({
            _doReset: function() {
              var t;
              if (this._nRounds && this._keyPriorReset === this._key) {
                return;
              }
              var key = this._keyPriorReset = this._key;
              var keyWords = key.words;
              var keySize = key.sigBytes / 4;
              var nRounds = this._nRounds = keySize + 6;
              var ksRows = (nRounds + 1) * 4;
              var keySchedule = this._keySchedule = [];
              for (var ksRow = 0; ksRow < ksRows; ksRow++) {
                if (ksRow < keySize) {
                  keySchedule[ksRow] = keyWords[ksRow];
                } else {
                  t = keySchedule[ksRow - 1];
                  if (!(ksRow % keySize)) {
                    t = t << 8 | t >>> 24;
                    t = SBOX[t >>> 24] << 24 | SBOX[t >>> 16 & 255] << 16 | SBOX[t >>> 8 & 255] << 8 | SBOX[t & 255];
                    t ^= RCON[ksRow / keySize | 0] << 24;
                  } else if (keySize > 6 && ksRow % keySize == 4) {
                    t = SBOX[t >>> 24] << 24 | SBOX[t >>> 16 & 255] << 16 | SBOX[t >>> 8 & 255] << 8 | SBOX[t & 255];
                  }
                  keySchedule[ksRow] = keySchedule[ksRow - keySize] ^ t;
                }
              }
              var invKeySchedule = this._invKeySchedule = [];
              for (var invKsRow = 0; invKsRow < ksRows; invKsRow++) {
                var ksRow = ksRows - invKsRow;
                if (invKsRow % 4) {
                  var t = keySchedule[ksRow];
                } else {
                  var t = keySchedule[ksRow - 4];
                }
                if (invKsRow < 4 || ksRow <= 4) {
                  invKeySchedule[invKsRow] = t;
                } else {
                  invKeySchedule[invKsRow] = INV_SUB_MIX_0[SBOX[t >>> 24]] ^ INV_SUB_MIX_1[SBOX[t >>> 16 & 255]] ^ INV_SUB_MIX_2[SBOX[t >>> 8 & 255]] ^ INV_SUB_MIX_3[SBOX[t & 255]];
                }
              }
            },
            encryptBlock: function(M, offset) {
              this._doCryptBlock(M, offset, this._keySchedule, SUB_MIX_0, SUB_MIX_1, SUB_MIX_2, SUB_MIX_3, SBOX);
            },
            decryptBlock: function(M, offset) {
              var t = M[offset + 1];
              M[offset + 1] = M[offset + 3];
              M[offset + 3] = t;
              this._doCryptBlock(M, offset, this._invKeySchedule, INV_SUB_MIX_0, INV_SUB_MIX_1, INV_SUB_MIX_2, INV_SUB_MIX_3, INV_SBOX);
              var t = M[offset + 1];
              M[offset + 1] = M[offset + 3];
              M[offset + 3] = t;
            },
            _doCryptBlock: function(M, offset, keySchedule, SUB_MIX_02, SUB_MIX_12, SUB_MIX_22, SUB_MIX_32, SBOX2) {
              var nRounds = this._nRounds;
              var s0 = M[offset] ^ keySchedule[0];
              var s1 = M[offset + 1] ^ keySchedule[1];
              var s2 = M[offset + 2] ^ keySchedule[2];
              var s3 = M[offset + 3] ^ keySchedule[3];
              var ksRow = 4;
              for (var round = 1; round < nRounds; round++) {
                var t0 = SUB_MIX_02[s0 >>> 24] ^ SUB_MIX_12[s1 >>> 16 & 255] ^ SUB_MIX_22[s2 >>> 8 & 255] ^ SUB_MIX_32[s3 & 255] ^ keySchedule[ksRow++];
                var t1 = SUB_MIX_02[s1 >>> 24] ^ SUB_MIX_12[s2 >>> 16 & 255] ^ SUB_MIX_22[s3 >>> 8 & 255] ^ SUB_MIX_32[s0 & 255] ^ keySchedule[ksRow++];
                var t2 = SUB_MIX_02[s2 >>> 24] ^ SUB_MIX_12[s3 >>> 16 & 255] ^ SUB_MIX_22[s0 >>> 8 & 255] ^ SUB_MIX_32[s1 & 255] ^ keySchedule[ksRow++];
                var t3 = SUB_MIX_02[s3 >>> 24] ^ SUB_MIX_12[s0 >>> 16 & 255] ^ SUB_MIX_22[s1 >>> 8 & 255] ^ SUB_MIX_32[s2 & 255] ^ keySchedule[ksRow++];
                s0 = t0;
                s1 = t1;
                s2 = t2;
                s3 = t3;
              }
              var t0 = (SBOX2[s0 >>> 24] << 24 | SBOX2[s1 >>> 16 & 255] << 16 | SBOX2[s2 >>> 8 & 255] << 8 | SBOX2[s3 & 255]) ^ keySchedule[ksRow++];
              var t1 = (SBOX2[s1 >>> 24] << 24 | SBOX2[s2 >>> 16 & 255] << 16 | SBOX2[s3 >>> 8 & 255] << 8 | SBOX2[s0 & 255]) ^ keySchedule[ksRow++];
              var t2 = (SBOX2[s2 >>> 24] << 24 | SBOX2[s3 >>> 16 & 255] << 16 | SBOX2[s0 >>> 8 & 255] << 8 | SBOX2[s1 & 255]) ^ keySchedule[ksRow++];
              var t3 = (SBOX2[s3 >>> 24] << 24 | SBOX2[s0 >>> 16 & 255] << 16 | SBOX2[s1 >>> 8 & 255] << 8 | SBOX2[s2 & 255]) ^ keySchedule[ksRow++];
              M[offset] = t0;
              M[offset + 1] = t1;
              M[offset + 2] = t2;
              M[offset + 3] = t3;
            },
            keySize: 256 / 32
          });
          C.AES = BlockCipher._createHelper(AES);
        })();
        return CryptoJS.AES;
      });
    }
  });

  // node_modules/crypto-js/tripledes.js
  var require_tripledes = __commonJS({
    "node_modules/crypto-js/tripledes.js"(exports, module) {
      (function(root, factory, undef) {
        if (typeof exports === "object") {
          module.exports = exports = factory(require_core(), require_enc_base64(), require_md5(), require_evpkdf(), require_cipher_core());
        } else if (typeof define === "function" && define.amd) {
          define(["./core", "./enc-base64", "./md5", "./evpkdf", "./cipher-core"], factory);
        } else {
          factory(root.CryptoJS);
        }
      })(exports, function(CryptoJS) {
        (function() {
          var C = CryptoJS;
          var C_lib = C.lib;
          var WordArray = C_lib.WordArray;
          var BlockCipher = C_lib.BlockCipher;
          var C_algo = C.algo;
          var PC1 = [
            57,
            49,
            41,
            33,
            25,
            17,
            9,
            1,
            58,
            50,
            42,
            34,
            26,
            18,
            10,
            2,
            59,
            51,
            43,
            35,
            27,
            19,
            11,
            3,
            60,
            52,
            44,
            36,
            63,
            55,
            47,
            39,
            31,
            23,
            15,
            7,
            62,
            54,
            46,
            38,
            30,
            22,
            14,
            6,
            61,
            53,
            45,
            37,
            29,
            21,
            13,
            5,
            28,
            20,
            12,
            4
          ];
          var PC2 = [
            14,
            17,
            11,
            24,
            1,
            5,
            3,
            28,
            15,
            6,
            21,
            10,
            23,
            19,
            12,
            4,
            26,
            8,
            16,
            7,
            27,
            20,
            13,
            2,
            41,
            52,
            31,
            37,
            47,
            55,
            30,
            40,
            51,
            45,
            33,
            48,
            44,
            49,
            39,
            56,
            34,
            53,
            46,
            42,
            50,
            36,
            29,
            32
          ];
          var BIT_SHIFTS = [1, 2, 4, 6, 8, 10, 12, 14, 15, 17, 19, 21, 23, 25, 27, 28];
          var SBOX_P = [
            {
              0: 8421888,
              268435456: 32768,
              536870912: 8421378,
              805306368: 2,
              1073741824: 512,
              1342177280: 8421890,
              1610612736: 8389122,
              1879048192: 8388608,
              2147483648: 514,
              2415919104: 8389120,
              2684354560: 33280,
              2952790016: 8421376,
              3221225472: 32770,
              3489660928: 8388610,
              3758096384: 0,
              4026531840: 33282,
              134217728: 0,
              402653184: 8421890,
              671088640: 33282,
              939524096: 32768,
              1207959552: 8421888,
              1476395008: 512,
              1744830464: 8421378,
              2013265920: 2,
              2281701376: 8389120,
              2550136832: 33280,
              2818572288: 8421376,
              3087007744: 8389122,
              3355443200: 8388610,
              3623878656: 32770,
              3892314112: 514,
              4160749568: 8388608,
              1: 32768,
              268435457: 2,
              536870913: 8421888,
              805306369: 8388608,
              1073741825: 8421378,
              1342177281: 33280,
              1610612737: 512,
              1879048193: 8389122,
              2147483649: 8421890,
              2415919105: 8421376,
              2684354561: 8388610,
              2952790017: 33282,
              3221225473: 514,
              3489660929: 8389120,
              3758096385: 32770,
              4026531841: 0,
              134217729: 8421890,
              402653185: 8421376,
              671088641: 8388608,
              939524097: 512,
              1207959553: 32768,
              1476395009: 8388610,
              1744830465: 2,
              2013265921: 33282,
              2281701377: 32770,
              2550136833: 8389122,
              2818572289: 514,
              3087007745: 8421888,
              3355443201: 8389120,
              3623878657: 0,
              3892314113: 33280,
              4160749569: 8421378
            },
            {
              0: 1074282512,
              16777216: 16384,
              33554432: 524288,
              50331648: 1074266128,
              67108864: 1073741840,
              83886080: 1074282496,
              100663296: 1073758208,
              117440512: 16,
              134217728: 540672,
              150994944: 1073758224,
              167772160: 1073741824,
              184549376: 540688,
              201326592: 524304,
              218103808: 0,
              234881024: 16400,
              251658240: 1074266112,
              8388608: 1073758208,
              25165824: 540688,
              41943040: 16,
              58720256: 1073758224,
              75497472: 1074282512,
              92274688: 1073741824,
              109051904: 524288,
              125829120: 1074266128,
              142606336: 524304,
              159383552: 0,
              176160768: 16384,
              192937984: 1074266112,
              209715200: 1073741840,
              226492416: 540672,
              243269632: 1074282496,
              260046848: 16400,
              268435456: 0,
              285212672: 1074266128,
              301989888: 1073758224,
              318767104: 1074282496,
              335544320: 1074266112,
              352321536: 16,
              369098752: 540688,
              385875968: 16384,
              402653184: 16400,
              419430400: 524288,
              436207616: 524304,
              452984832: 1073741840,
              469762048: 540672,
              486539264: 1073758208,
              503316480: 1073741824,
              520093696: 1074282512,
              276824064: 540688,
              293601280: 524288,
              310378496: 1074266112,
              327155712: 16384,
              343932928: 1073758208,
              360710144: 1074282512,
              377487360: 16,
              394264576: 1073741824,
              411041792: 1074282496,
              427819008: 1073741840,
              444596224: 1073758224,
              461373440: 524304,
              478150656: 0,
              494927872: 16400,
              511705088: 1074266128,
              528482304: 540672
            },
            {
              0: 260,
              1048576: 0,
              2097152: 67109120,
              3145728: 65796,
              4194304: 65540,
              5242880: 67108868,
              6291456: 67174660,
              7340032: 67174400,
              8388608: 67108864,
              9437184: 67174656,
              10485760: 65792,
              11534336: 67174404,
              12582912: 67109124,
              13631488: 65536,
              14680064: 4,
              15728640: 256,
              524288: 67174656,
              1572864: 67174404,
              2621440: 0,
              3670016: 67109120,
              4718592: 67108868,
              5767168: 65536,
              6815744: 65540,
              7864320: 260,
              8912896: 4,
              9961472: 256,
              11010048: 67174400,
              12058624: 65796,
              13107200: 65792,
              14155776: 67109124,
              15204352: 67174660,
              16252928: 67108864,
              16777216: 67174656,
              17825792: 65540,
              18874368: 65536,
              19922944: 67109120,
              20971520: 256,
              22020096: 67174660,
              23068672: 67108868,
              24117248: 0,
              25165824: 67109124,
              26214400: 67108864,
              27262976: 4,
              28311552: 65792,
              29360128: 67174400,
              30408704: 260,
              31457280: 65796,
              32505856: 67174404,
              17301504: 67108864,
              18350080: 260,
              19398656: 67174656,
              20447232: 0,
              21495808: 65540,
              22544384: 67109120,
              23592960: 256,
              24641536: 67174404,
              25690112: 65536,
              26738688: 67174660,
              27787264: 65796,
              28835840: 67108868,
              29884416: 67109124,
              30932992: 67174400,
              31981568: 4,
              33030144: 65792
            },
            {
              0: 2151682048,
              65536: 2147487808,
              131072: 4198464,
              196608: 2151677952,
              262144: 0,
              327680: 4198400,
              393216: 2147483712,
              458752: 4194368,
              524288: 2147483648,
              589824: 4194304,
              655360: 64,
              720896: 2147487744,
              786432: 2151678016,
              851968: 4160,
              917504: 4096,
              983040: 2151682112,
              32768: 2147487808,
              98304: 64,
              163840: 2151678016,
              229376: 2147487744,
              294912: 4198400,
              360448: 2151682112,
              425984: 0,
              491520: 2151677952,
              557056: 4096,
              622592: 2151682048,
              688128: 4194304,
              753664: 4160,
              819200: 2147483648,
              884736: 4194368,
              950272: 4198464,
              1015808: 2147483712,
              1048576: 4194368,
              1114112: 4198400,
              1179648: 2147483712,
              1245184: 0,
              1310720: 4160,
              1376256: 2151678016,
              1441792: 2151682048,
              1507328: 2147487808,
              1572864: 2151682112,
              1638400: 2147483648,
              1703936: 2151677952,
              1769472: 4198464,
              1835008: 2147487744,
              1900544: 4194304,
              1966080: 64,
              2031616: 4096,
              1081344: 2151677952,
              1146880: 2151682112,
              1212416: 0,
              1277952: 4198400,
              1343488: 4194368,
              1409024: 2147483648,
              1474560: 2147487808,
              1540096: 64,
              1605632: 2147483712,
              1671168: 4096,
              1736704: 2147487744,
              1802240: 2151678016,
              1867776: 4160,
              1933312: 2151682048,
              1998848: 4194304,
              2064384: 4198464
            },
            {
              0: 128,
              4096: 17039360,
              8192: 262144,
              12288: 536870912,
              16384: 537133184,
              20480: 16777344,
              24576: 553648256,
              28672: 262272,
              32768: 16777216,
              36864: 537133056,
              40960: 536871040,
              45056: 553910400,
              49152: 553910272,
              53248: 0,
              57344: 17039488,
              61440: 553648128,
              2048: 17039488,
              6144: 553648256,
              10240: 128,
              14336: 17039360,
              18432: 262144,
              22528: 537133184,
              26624: 553910272,
              30720: 536870912,
              34816: 537133056,
              38912: 0,
              43008: 553910400,
              47104: 16777344,
              51200: 536871040,
              55296: 553648128,
              59392: 16777216,
              63488: 262272,
              65536: 262144,
              69632: 128,
              73728: 536870912,
              77824: 553648256,
              81920: 16777344,
              86016: 553910272,
              90112: 537133184,
              94208: 16777216,
              98304: 553910400,
              102400: 553648128,
              106496: 17039360,
              110592: 537133056,
              114688: 262272,
              118784: 536871040,
              122880: 0,
              126976: 17039488,
              67584: 553648256,
              71680: 16777216,
              75776: 17039360,
              79872: 537133184,
              83968: 536870912,
              88064: 17039488,
              92160: 128,
              96256: 553910272,
              100352: 262272,
              104448: 553910400,
              108544: 0,
              112640: 553648128,
              116736: 16777344,
              120832: 262144,
              124928: 537133056,
              129024: 536871040
            },
            {
              0: 268435464,
              256: 8192,
              512: 270532608,
              768: 270540808,
              1024: 268443648,
              1280: 2097152,
              1536: 2097160,
              1792: 268435456,
              2048: 0,
              2304: 268443656,
              2560: 2105344,
              2816: 8,
              3072: 270532616,
              3328: 2105352,
              3584: 8200,
              3840: 270540800,
              128: 270532608,
              384: 270540808,
              640: 8,
              896: 2097152,
              1152: 2105352,
              1408: 268435464,
              1664: 268443648,
              1920: 8200,
              2176: 2097160,
              2432: 8192,
              2688: 268443656,
              2944: 270532616,
              3200: 0,
              3456: 270540800,
              3712: 2105344,
              3968: 268435456,
              4096: 268443648,
              4352: 270532616,
              4608: 270540808,
              4864: 8200,
              5120: 2097152,
              5376: 268435456,
              5632: 268435464,
              5888: 2105344,
              6144: 2105352,
              6400: 0,
              6656: 8,
              6912: 270532608,
              7168: 8192,
              7424: 268443656,
              7680: 270540800,
              7936: 2097160,
              4224: 8,
              4480: 2105344,
              4736: 2097152,
              4992: 268435464,
              5248: 268443648,
              5504: 8200,
              5760: 270540808,
              6016: 270532608,
              6272: 270540800,
              6528: 270532616,
              6784: 8192,
              7040: 2105352,
              7296: 2097160,
              7552: 0,
              7808: 268435456,
              8064: 268443656
            },
            {
              0: 1048576,
              16: 33555457,
              32: 1024,
              48: 1049601,
              64: 34604033,
              80: 0,
              96: 1,
              112: 34603009,
              128: 33555456,
              144: 1048577,
              160: 33554433,
              176: 34604032,
              192: 34603008,
              208: 1025,
              224: 1049600,
              240: 33554432,
              8: 34603009,
              24: 0,
              40: 33555457,
              56: 34604032,
              72: 1048576,
              88: 33554433,
              104: 33554432,
              120: 1025,
              136: 1049601,
              152: 33555456,
              168: 34603008,
              184: 1048577,
              200: 1024,
              216: 34604033,
              232: 1,
              248: 1049600,
              256: 33554432,
              272: 1048576,
              288: 33555457,
              304: 34603009,
              320: 1048577,
              336: 33555456,
              352: 34604032,
              368: 1049601,
              384: 1025,
              400: 34604033,
              416: 1049600,
              432: 1,
              448: 0,
              464: 34603008,
              480: 33554433,
              496: 1024,
              264: 1049600,
              280: 33555457,
              296: 34603009,
              312: 1,
              328: 33554432,
              344: 1048576,
              360: 1025,
              376: 34604032,
              392: 33554433,
              408: 34603008,
              424: 0,
              440: 34604033,
              456: 1049601,
              472: 1024,
              488: 33555456,
              504: 1048577
            },
            {
              0: 134219808,
              1: 131072,
              2: 134217728,
              3: 32,
              4: 131104,
              5: 134350880,
              6: 134350848,
              7: 2048,
              8: 134348800,
              9: 134219776,
              10: 133120,
              11: 134348832,
              12: 2080,
              13: 0,
              14: 134217760,
              15: 133152,
              2147483648: 2048,
              2147483649: 134350880,
              2147483650: 134219808,
              2147483651: 134217728,
              2147483652: 134348800,
              2147483653: 133120,
              2147483654: 133152,
              2147483655: 32,
              2147483656: 134217760,
              2147483657: 2080,
              2147483658: 131104,
              2147483659: 134350848,
              2147483660: 0,
              2147483661: 134348832,
              2147483662: 134219776,
              2147483663: 131072,
              16: 133152,
              17: 134350848,
              18: 32,
              19: 2048,
              20: 134219776,
              21: 134217760,
              22: 134348832,
              23: 131072,
              24: 0,
              25: 131104,
              26: 134348800,
              27: 134219808,
              28: 134350880,
              29: 133120,
              30: 2080,
              31: 134217728,
              2147483664: 131072,
              2147483665: 2048,
              2147483666: 134348832,
              2147483667: 133152,
              2147483668: 32,
              2147483669: 134348800,
              2147483670: 134217728,
              2147483671: 134219808,
              2147483672: 134350880,
              2147483673: 134217760,
              2147483674: 134219776,
              2147483675: 0,
              2147483676: 133120,
              2147483677: 2080,
              2147483678: 131104,
              2147483679: 134350848
            }
          ];
          var SBOX_MASK = [
            4160749569,
            528482304,
            33030144,
            2064384,
            129024,
            8064,
            504,
            2147483679
          ];
          var DES = C_algo.DES = BlockCipher.extend({
            _doReset: function() {
              var key = this._key;
              var keyWords = key.words;
              var keyBits = [];
              for (var i = 0; i < 56; i++) {
                var keyBitPos = PC1[i] - 1;
                keyBits[i] = keyWords[keyBitPos >>> 5] >>> 31 - keyBitPos % 32 & 1;
              }
              var subKeys = this._subKeys = [];
              for (var nSubKey = 0; nSubKey < 16; nSubKey++) {
                var subKey = subKeys[nSubKey] = [];
                var bitShift = BIT_SHIFTS[nSubKey];
                for (var i = 0; i < 24; i++) {
                  subKey[i / 6 | 0] |= keyBits[(PC2[i] - 1 + bitShift) % 28] << 31 - i % 6;
                  subKey[4 + (i / 6 | 0)] |= keyBits[28 + (PC2[i + 24] - 1 + bitShift) % 28] << 31 - i % 6;
                }
                subKey[0] = subKey[0] << 1 | subKey[0] >>> 31;
                for (var i = 1; i < 7; i++) {
                  subKey[i] = subKey[i] >>> (i - 1) * 4 + 3;
                }
                subKey[7] = subKey[7] << 5 | subKey[7] >>> 27;
              }
              var invSubKeys = this._invSubKeys = [];
              for (var i = 0; i < 16; i++) {
                invSubKeys[i] = subKeys[15 - i];
              }
            },
            encryptBlock: function(M, offset) {
              this._doCryptBlock(M, offset, this._subKeys);
            },
            decryptBlock: function(M, offset) {
              this._doCryptBlock(M, offset, this._invSubKeys);
            },
            _doCryptBlock: function(M, offset, subKeys) {
              this._lBlock = M[offset];
              this._rBlock = M[offset + 1];
              exchangeLR.call(this, 4, 252645135);
              exchangeLR.call(this, 16, 65535);
              exchangeRL.call(this, 2, 858993459);
              exchangeRL.call(this, 8, 16711935);
              exchangeLR.call(this, 1, 1431655765);
              for (var round = 0; round < 16; round++) {
                var subKey = subKeys[round];
                var lBlock = this._lBlock;
                var rBlock = this._rBlock;
                var f = 0;
                for (var i = 0; i < 8; i++) {
                  f |= SBOX_P[i][((rBlock ^ subKey[i]) & SBOX_MASK[i]) >>> 0];
                }
                this._lBlock = rBlock;
                this._rBlock = lBlock ^ f;
              }
              var t = this._lBlock;
              this._lBlock = this._rBlock;
              this._rBlock = t;
              exchangeLR.call(this, 1, 1431655765);
              exchangeRL.call(this, 8, 16711935);
              exchangeRL.call(this, 2, 858993459);
              exchangeLR.call(this, 16, 65535);
              exchangeLR.call(this, 4, 252645135);
              M[offset] = this._lBlock;
              M[offset + 1] = this._rBlock;
            },
            keySize: 64 / 32,
            ivSize: 64 / 32,
            blockSize: 64 / 32
          });
          function exchangeLR(offset, mask) {
            var t = (this._lBlock >>> offset ^ this._rBlock) & mask;
            this._rBlock ^= t;
            this._lBlock ^= t << offset;
          }
          function exchangeRL(offset, mask) {
            var t = (this._rBlock >>> offset ^ this._lBlock) & mask;
            this._lBlock ^= t;
            this._rBlock ^= t << offset;
          }
          C.DES = BlockCipher._createHelper(DES);
          var TripleDES = C_algo.TripleDES = BlockCipher.extend({
            _doReset: function() {
              var key = this._key;
              var keyWords = key.words;
              if (keyWords.length !== 2 && keyWords.length !== 4 && keyWords.length < 6) {
                throw new Error("Invalid key length - 3DES requires the key length to be 64, 128, 192 or >192.");
              }
              var key1 = keyWords.slice(0, 2);
              var key2 = keyWords.length < 4 ? keyWords.slice(0, 2) : keyWords.slice(2, 4);
              var key3 = keyWords.length < 6 ? keyWords.slice(0, 2) : keyWords.slice(4, 6);
              this._des1 = DES.createEncryptor(WordArray.create(key1));
              this._des2 = DES.createEncryptor(WordArray.create(key2));
              this._des3 = DES.createEncryptor(WordArray.create(key3));
            },
            encryptBlock: function(M, offset) {
              this._des1.encryptBlock(M, offset);
              this._des2.decryptBlock(M, offset);
              this._des3.encryptBlock(M, offset);
            },
            decryptBlock: function(M, offset) {
              this._des3.decryptBlock(M, offset);
              this._des2.encryptBlock(M, offset);
              this._des1.decryptBlock(M, offset);
            },
            keySize: 192 / 32,
            ivSize: 64 / 32,
            blockSize: 64 / 32
          });
          C.TripleDES = BlockCipher._createHelper(TripleDES);
        })();
        return CryptoJS.TripleDES;
      });
    }
  });

  // node_modules/crypto-js/rc4.js
  var require_rc4 = __commonJS({
    "node_modules/crypto-js/rc4.js"(exports, module) {
      (function(root, factory, undef) {
        if (typeof exports === "object") {
          module.exports = exports = factory(require_core(), require_enc_base64(), require_md5(), require_evpkdf(), require_cipher_core());
        } else if (typeof define === "function" && define.amd) {
          define(["./core", "./enc-base64", "./md5", "./evpkdf", "./cipher-core"], factory);
        } else {
          factory(root.CryptoJS);
        }
      })(exports, function(CryptoJS) {
        (function() {
          var C = CryptoJS;
          var C_lib = C.lib;
          var StreamCipher = C_lib.StreamCipher;
          var C_algo = C.algo;
          var RC4 = C_algo.RC4 = StreamCipher.extend({
            _doReset: function() {
              var key = this._key;
              var keyWords = key.words;
              var keySigBytes = key.sigBytes;
              var S = this._S = [];
              for (var i = 0; i < 256; i++) {
                S[i] = i;
              }
              for (var i = 0, j = 0; i < 256; i++) {
                var keyByteIndex = i % keySigBytes;
                var keyByte = keyWords[keyByteIndex >>> 2] >>> 24 - keyByteIndex % 4 * 8 & 255;
                j = (j + S[i] + keyByte) % 256;
                var t = S[i];
                S[i] = S[j];
                S[j] = t;
              }
              this._i = this._j = 0;
            },
            _doProcessBlock: function(M, offset) {
              M[offset] ^= generateKeystreamWord.call(this);
            },
            keySize: 256 / 32,
            ivSize: 0
          });
          function generateKeystreamWord() {
            var S = this._S;
            var i = this._i;
            var j = this._j;
            var keystreamWord = 0;
            for (var n = 0; n < 4; n++) {
              i = (i + 1) % 256;
              j = (j + S[i]) % 256;
              var t = S[i];
              S[i] = S[j];
              S[j] = t;
              keystreamWord |= S[(S[i] + S[j]) % 256] << 24 - n * 8;
            }
            this._i = i;
            this._j = j;
            return keystreamWord;
          }
          C.RC4 = StreamCipher._createHelper(RC4);
          var RC4Drop = C_algo.RC4Drop = RC4.extend({
            /**
             * Configuration options.
             *
             * @property {number} drop The number of keystream words to drop. Default 192
             */
            cfg: RC4.cfg.extend({
              drop: 192
            }),
            _doReset: function() {
              RC4._doReset.call(this);
              for (var i = this.cfg.drop; i > 0; i--) {
                generateKeystreamWord.call(this);
              }
            }
          });
          C.RC4Drop = StreamCipher._createHelper(RC4Drop);
        })();
        return CryptoJS.RC4;
      });
    }
  });

  // node_modules/crypto-js/rabbit.js
  var require_rabbit = __commonJS({
    "node_modules/crypto-js/rabbit.js"(exports, module) {
      (function(root, factory, undef) {
        if (typeof exports === "object") {
          module.exports = exports = factory(require_core(), require_enc_base64(), require_md5(), require_evpkdf(), require_cipher_core());
        } else if (typeof define === "function" && define.amd) {
          define(["./core", "./enc-base64", "./md5", "./evpkdf", "./cipher-core"], factory);
        } else {
          factory(root.CryptoJS);
        }
      })(exports, function(CryptoJS) {
        (function() {
          var C = CryptoJS;
          var C_lib = C.lib;
          var StreamCipher = C_lib.StreamCipher;
          var C_algo = C.algo;
          var S = [];
          var C_ = [];
          var G = [];
          var Rabbit = C_algo.Rabbit = StreamCipher.extend({
            _doReset: function() {
              var K = this._key.words;
              var iv = this.cfg.iv;
              for (var i = 0; i < 4; i++) {
                K[i] = (K[i] << 8 | K[i] >>> 24) & 16711935 | (K[i] << 24 | K[i] >>> 8) & 4278255360;
              }
              var X = this._X = [
                K[0],
                K[3] << 16 | K[2] >>> 16,
                K[1],
                K[0] << 16 | K[3] >>> 16,
                K[2],
                K[1] << 16 | K[0] >>> 16,
                K[3],
                K[2] << 16 | K[1] >>> 16
              ];
              var C2 = this._C = [
                K[2] << 16 | K[2] >>> 16,
                K[0] & 4294901760 | K[1] & 65535,
                K[3] << 16 | K[3] >>> 16,
                K[1] & 4294901760 | K[2] & 65535,
                K[0] << 16 | K[0] >>> 16,
                K[2] & 4294901760 | K[3] & 65535,
                K[1] << 16 | K[1] >>> 16,
                K[3] & 4294901760 | K[0] & 65535
              ];
              this._b = 0;
              for (var i = 0; i < 4; i++) {
                nextState.call(this);
              }
              for (var i = 0; i < 8; i++) {
                C2[i] ^= X[i + 4 & 7];
              }
              if (iv) {
                var IV = iv.words;
                var IV_0 = IV[0];
                var IV_1 = IV[1];
                var i0 = (IV_0 << 8 | IV_0 >>> 24) & 16711935 | (IV_0 << 24 | IV_0 >>> 8) & 4278255360;
                var i2 = (IV_1 << 8 | IV_1 >>> 24) & 16711935 | (IV_1 << 24 | IV_1 >>> 8) & 4278255360;
                var i1 = i0 >>> 16 | i2 & 4294901760;
                var i3 = i2 << 16 | i0 & 65535;
                C2[0] ^= i0;
                C2[1] ^= i1;
                C2[2] ^= i2;
                C2[3] ^= i3;
                C2[4] ^= i0;
                C2[5] ^= i1;
                C2[6] ^= i2;
                C2[7] ^= i3;
                for (var i = 0; i < 4; i++) {
                  nextState.call(this);
                }
              }
            },
            _doProcessBlock: function(M, offset) {
              var X = this._X;
              nextState.call(this);
              S[0] = X[0] ^ X[5] >>> 16 ^ X[3] << 16;
              S[1] = X[2] ^ X[7] >>> 16 ^ X[5] << 16;
              S[2] = X[4] ^ X[1] >>> 16 ^ X[7] << 16;
              S[3] = X[6] ^ X[3] >>> 16 ^ X[1] << 16;
              for (var i = 0; i < 4; i++) {
                S[i] = (S[i] << 8 | S[i] >>> 24) & 16711935 | (S[i] << 24 | S[i] >>> 8) & 4278255360;
                M[offset + i] ^= S[i];
              }
            },
            blockSize: 128 / 32,
            ivSize: 64 / 32
          });
          function nextState() {
            var X = this._X;
            var C2 = this._C;
            for (var i = 0; i < 8; i++) {
              C_[i] = C2[i];
            }
            C2[0] = C2[0] + 1295307597 + this._b | 0;
            C2[1] = C2[1] + 3545052371 + (C2[0] >>> 0 < C_[0] >>> 0 ? 1 : 0) | 0;
            C2[2] = C2[2] + 886263092 + (C2[1] >>> 0 < C_[1] >>> 0 ? 1 : 0) | 0;
            C2[3] = C2[3] + 1295307597 + (C2[2] >>> 0 < C_[2] >>> 0 ? 1 : 0) | 0;
            C2[4] = C2[4] + 3545052371 + (C2[3] >>> 0 < C_[3] >>> 0 ? 1 : 0) | 0;
            C2[5] = C2[5] + 886263092 + (C2[4] >>> 0 < C_[4] >>> 0 ? 1 : 0) | 0;
            C2[6] = C2[6] + 1295307597 + (C2[5] >>> 0 < C_[5] >>> 0 ? 1 : 0) | 0;
            C2[7] = C2[7] + 3545052371 + (C2[6] >>> 0 < C_[6] >>> 0 ? 1 : 0) | 0;
            this._b = C2[7] >>> 0 < C_[7] >>> 0 ? 1 : 0;
            for (var i = 0; i < 8; i++) {
              var gx = X[i] + C2[i];
              var ga = gx & 65535;
              var gb = gx >>> 16;
              var gh = ((ga * ga >>> 17) + ga * gb >>> 15) + gb * gb;
              var gl = ((gx & 4294901760) * gx | 0) + ((gx & 65535) * gx | 0);
              G[i] = gh ^ gl;
            }
            X[0] = G[0] + (G[7] << 16 | G[7] >>> 16) + (G[6] << 16 | G[6] >>> 16) | 0;
            X[1] = G[1] + (G[0] << 8 | G[0] >>> 24) + G[7] | 0;
            X[2] = G[2] + (G[1] << 16 | G[1] >>> 16) + (G[0] << 16 | G[0] >>> 16) | 0;
            X[3] = G[3] + (G[2] << 8 | G[2] >>> 24) + G[1] | 0;
            X[4] = G[4] + (G[3] << 16 | G[3] >>> 16) + (G[2] << 16 | G[2] >>> 16) | 0;
            X[5] = G[5] + (G[4] << 8 | G[4] >>> 24) + G[3] | 0;
            X[6] = G[6] + (G[5] << 16 | G[5] >>> 16) + (G[4] << 16 | G[4] >>> 16) | 0;
            X[7] = G[7] + (G[6] << 8 | G[6] >>> 24) + G[5] | 0;
          }
          C.Rabbit = StreamCipher._createHelper(Rabbit);
        })();
        return CryptoJS.Rabbit;
      });
    }
  });

  // node_modules/crypto-js/rabbit-legacy.js
  var require_rabbit_legacy = __commonJS({
    "node_modules/crypto-js/rabbit-legacy.js"(exports, module) {
      (function(root, factory, undef) {
        if (typeof exports === "object") {
          module.exports = exports = factory(require_core(), require_enc_base64(), require_md5(), require_evpkdf(), require_cipher_core());
        } else if (typeof define === "function" && define.amd) {
          define(["./core", "./enc-base64", "./md5", "./evpkdf", "./cipher-core"], factory);
        } else {
          factory(root.CryptoJS);
        }
      })(exports, function(CryptoJS) {
        (function() {
          var C = CryptoJS;
          var C_lib = C.lib;
          var StreamCipher = C_lib.StreamCipher;
          var C_algo = C.algo;
          var S = [];
          var C_ = [];
          var G = [];
          var RabbitLegacy = C_algo.RabbitLegacy = StreamCipher.extend({
            _doReset: function() {
              var K = this._key.words;
              var iv = this.cfg.iv;
              var X = this._X = [
                K[0],
                K[3] << 16 | K[2] >>> 16,
                K[1],
                K[0] << 16 | K[3] >>> 16,
                K[2],
                K[1] << 16 | K[0] >>> 16,
                K[3],
                K[2] << 16 | K[1] >>> 16
              ];
              var C2 = this._C = [
                K[2] << 16 | K[2] >>> 16,
                K[0] & 4294901760 | K[1] & 65535,
                K[3] << 16 | K[3] >>> 16,
                K[1] & 4294901760 | K[2] & 65535,
                K[0] << 16 | K[0] >>> 16,
                K[2] & 4294901760 | K[3] & 65535,
                K[1] << 16 | K[1] >>> 16,
                K[3] & 4294901760 | K[0] & 65535
              ];
              this._b = 0;
              for (var i = 0; i < 4; i++) {
                nextState.call(this);
              }
              for (var i = 0; i < 8; i++) {
                C2[i] ^= X[i + 4 & 7];
              }
              if (iv) {
                var IV = iv.words;
                var IV_0 = IV[0];
                var IV_1 = IV[1];
                var i0 = (IV_0 << 8 | IV_0 >>> 24) & 16711935 | (IV_0 << 24 | IV_0 >>> 8) & 4278255360;
                var i2 = (IV_1 << 8 | IV_1 >>> 24) & 16711935 | (IV_1 << 24 | IV_1 >>> 8) & 4278255360;
                var i1 = i0 >>> 16 | i2 & 4294901760;
                var i3 = i2 << 16 | i0 & 65535;
                C2[0] ^= i0;
                C2[1] ^= i1;
                C2[2] ^= i2;
                C2[3] ^= i3;
                C2[4] ^= i0;
                C2[5] ^= i1;
                C2[6] ^= i2;
                C2[7] ^= i3;
                for (var i = 0; i < 4; i++) {
                  nextState.call(this);
                }
              }
            },
            _doProcessBlock: function(M, offset) {
              var X = this._X;
              nextState.call(this);
              S[0] = X[0] ^ X[5] >>> 16 ^ X[3] << 16;
              S[1] = X[2] ^ X[7] >>> 16 ^ X[5] << 16;
              S[2] = X[4] ^ X[1] >>> 16 ^ X[7] << 16;
              S[3] = X[6] ^ X[3] >>> 16 ^ X[1] << 16;
              for (var i = 0; i < 4; i++) {
                S[i] = (S[i] << 8 | S[i] >>> 24) & 16711935 | (S[i] << 24 | S[i] >>> 8) & 4278255360;
                M[offset + i] ^= S[i];
              }
            },
            blockSize: 128 / 32,
            ivSize: 64 / 32
          });
          function nextState() {
            var X = this._X;
            var C2 = this._C;
            for (var i = 0; i < 8; i++) {
              C_[i] = C2[i];
            }
            C2[0] = C2[0] + 1295307597 + this._b | 0;
            C2[1] = C2[1] + 3545052371 + (C2[0] >>> 0 < C_[0] >>> 0 ? 1 : 0) | 0;
            C2[2] = C2[2] + 886263092 + (C2[1] >>> 0 < C_[1] >>> 0 ? 1 : 0) | 0;
            C2[3] = C2[3] + 1295307597 + (C2[2] >>> 0 < C_[2] >>> 0 ? 1 : 0) | 0;
            C2[4] = C2[4] + 3545052371 + (C2[3] >>> 0 < C_[3] >>> 0 ? 1 : 0) | 0;
            C2[5] = C2[5] + 886263092 + (C2[4] >>> 0 < C_[4] >>> 0 ? 1 : 0) | 0;
            C2[6] = C2[6] + 1295307597 + (C2[5] >>> 0 < C_[5] >>> 0 ? 1 : 0) | 0;
            C2[7] = C2[7] + 3545052371 + (C2[6] >>> 0 < C_[6] >>> 0 ? 1 : 0) | 0;
            this._b = C2[7] >>> 0 < C_[7] >>> 0 ? 1 : 0;
            for (var i = 0; i < 8; i++) {
              var gx = X[i] + C2[i];
              var ga = gx & 65535;
              var gb = gx >>> 16;
              var gh = ((ga * ga >>> 17) + ga * gb >>> 15) + gb * gb;
              var gl = ((gx & 4294901760) * gx | 0) + ((gx & 65535) * gx | 0);
              G[i] = gh ^ gl;
            }
            X[0] = G[0] + (G[7] << 16 | G[7] >>> 16) + (G[6] << 16 | G[6] >>> 16) | 0;
            X[1] = G[1] + (G[0] << 8 | G[0] >>> 24) + G[7] | 0;
            X[2] = G[2] + (G[1] << 16 | G[1] >>> 16) + (G[0] << 16 | G[0] >>> 16) | 0;
            X[3] = G[3] + (G[2] << 8 | G[2] >>> 24) + G[1] | 0;
            X[4] = G[4] + (G[3] << 16 | G[3] >>> 16) + (G[2] << 16 | G[2] >>> 16) | 0;
            X[5] = G[5] + (G[4] << 8 | G[4] >>> 24) + G[3] | 0;
            X[6] = G[6] + (G[5] << 16 | G[5] >>> 16) + (G[4] << 16 | G[4] >>> 16) | 0;
            X[7] = G[7] + (G[6] << 8 | G[6] >>> 24) + G[5] | 0;
          }
          C.RabbitLegacy = StreamCipher._createHelper(RabbitLegacy);
        })();
        return CryptoJS.RabbitLegacy;
      });
    }
  });

  // node_modules/crypto-js/index.js
  var require_crypto_js = __commonJS({
    "node_modules/crypto-js/index.js"(exports, module) {
      (function(root, factory, undef) {
        if (typeof exports === "object") {
          module.exports = exports = factory(require_core(), require_x64_core(), require_lib_typedarrays(), require_enc_utf16(), require_enc_base64(), require_enc_base64url(), require_md5(), require_sha1(), require_sha256(), require_sha224(), require_sha512(), require_sha384(), require_sha3(), require_ripemd160(), require_hmac(), require_pbkdf2(), require_evpkdf(), require_cipher_core(), require_mode_cfb(), require_mode_ctr(), require_mode_ctr_gladman(), require_mode_ofb(), require_mode_ecb(), require_pad_ansix923(), require_pad_iso10126(), require_pad_iso97971(), require_pad_zeropadding(), require_pad_nopadding(), require_format_hex(), require_aes(), require_tripledes(), require_rc4(), require_rabbit(), require_rabbit_legacy());
        } else if (typeof define === "function" && define.amd) {
          define(["./core", "./x64-core", "./lib-typedarrays", "./enc-utf16", "./enc-base64", "./enc-base64url", "./md5", "./sha1", "./sha256", "./sha224", "./sha512", "./sha384", "./sha3", "./ripemd160", "./hmac", "./pbkdf2", "./evpkdf", "./cipher-core", "./mode-cfb", "./mode-ctr", "./mode-ctr-gladman", "./mode-ofb", "./mode-ecb", "./pad-ansix923", "./pad-iso10126", "./pad-iso97971", "./pad-zeropadding", "./pad-nopadding", "./format-hex", "./aes", "./tripledes", "./rc4", "./rabbit", "./rabbit-legacy"], factory);
        } else {
          root.CryptoJS = factory(root.CryptoJS);
        }
      })(exports, function(CryptoJS) {
        return CryptoJS;
      });
    }
  });

  // node_modules/@kameleoon/javascript-sdk-core/dist/hasher/hasher.js
  var require_hasher = __commonJS({
    "node_modules/@kameleoon/javascript-sdk-core/dist/hasher/hasher.js"(exports) {
      "use strict";
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.Hasher = void 0;
      var _cryptoJs = require_crypto_js();
      var Hasher = class {
        static obtainExperimentHashDouble({
          visitorCode,
          campaignId,
          respoolTime
        }) {
          let respoolTimeString = "";
          if (respoolTime.length) {
            respoolTime.forEach((respoolObject) => {
              respoolTimeString += String(respoolObject.value);
            });
          }
          return this.calculateHash(visitorCode + campaignId + respoolTimeString);
        }
        static obtainFeatureFlagHashDouble({
          visitorCode,
          campaignId,
          respoolTime
        }) {
          let suffix = "";
          if (respoolTime) {
            suffix += String(respoolTime);
          }
          return this.calculateHash(visitorCode + campaignId + suffix);
        }
        // --- Note ---
        // `hashDouble` is a seeded pseudo-random number between 0 and 1
        // used for deciding what variation to assign
        // `calculateHash` algorithm is consistent between every SDK
        // and will always provide same pseudo-random value for the same input parameters
        static calculateHash(seed) {
          const hashDigest = (0, _cryptoJs.SHA256)(seed).toString();
          return parseInt(hashDigest, 16) / Math.pow(2, 256);
        }
      };
      exports.Hasher = Hasher;
    }
  });

  // node_modules/@kameleoon/javascript-sdk-core/dist/hasher/index.js
  var require_hasher2 = __commonJS({
    "node_modules/@kameleoon/javascript-sdk-core/dist/hasher/index.js"(exports) {
      "use strict";
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      Object.defineProperty(exports, "Hasher", {
        enumerable: true,
        get: function() {
          return _hasher.Hasher;
        }
      });
      var _hasher = require_hasher();
    }
  });

  // node_modules/@kameleoon/javascript-sdk-core/dist/variationConfiguration/variationConfiguration.js
  var require_variationConfiguration = __commonJS({
    "node_modules/@kameleoon/javascript-sdk-core/dist/variationConfiguration/variationConfiguration.js"(exports) {
      "use strict";
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.VariationConfiguration = void 0;
      var _tsRes = require_build();
      var _hasher = require_hasher2();
      var _kameleoonError = require_kameleoonError2();
      var _utilities = require_utilities2();
      var _types = require_types3();
      var _excluded = ["exposition"];
      function ownKeys(object, enumerableOnly) {
        var keys = Object.keys(object);
        if (Object.getOwnPropertySymbols) {
          var symbols = Object.getOwnPropertySymbols(object);
          enumerableOnly && (symbols = symbols.filter(function(sym) {
            return Object.getOwnPropertyDescriptor(object, sym).enumerable;
          })), keys.push.apply(keys, symbols);
        }
        return keys;
      }
      function _objectSpread(target) {
        for (var i = 1; i < arguments.length; i++) {
          var source = null != arguments[i] ? arguments[i] : {};
          i % 2 ? ownKeys(Object(source), true).forEach(function(key) {
            _defineProperty(target, key, source[key]);
          }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function(key) {
            Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
          });
        }
        return target;
      }
      function _objectWithoutProperties(source, excluded) {
        if (source == null)
          return {};
        var target = _objectWithoutPropertiesLoose(source, excluded);
        var key, i;
        if (Object.getOwnPropertySymbols) {
          var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
          for (i = 0; i < sourceSymbolKeys.length; i++) {
            key = sourceSymbolKeys[i];
            if (excluded.indexOf(key) >= 0)
              continue;
            if (!Object.prototype.propertyIsEnumerable.call(source, key))
              continue;
            target[key] = source[key];
          }
        }
        return target;
      }
      function _objectWithoutPropertiesLoose(source, excluded) {
        if (source == null)
          return {};
        var target = {};
        var sourceKeys = Object.keys(source);
        var key, i;
        for (i = 0; i < sourceKeys.length; i++) {
          key = sourceKeys[i];
          if (excluded.indexOf(key) >= 0)
            continue;
          target[key] = source[key];
        }
        return target;
      }
      function _defineProperty(obj, key, value) {
        key = _toPropertyKey(key);
        if (key in obj) {
          Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
        } else {
          obj[key] = value;
        }
        return obj;
      }
      function _toPropertyKey(arg) {
        var key = _toPrimitive(arg, "string");
        return typeof key === "symbol" ? key : String(key);
      }
      function _toPrimitive(input, hint) {
        if (typeof input !== "object" || input === null)
          return input;
        var prim = input[Symbol.toPrimitive];
        if (prim !== void 0) {
          var res = prim.call(input, hint || "default");
          if (typeof res !== "object")
            return res;
          throw new TypeError("@@toPrimitive must return a primitive value.");
        }
        return (hint === "string" ? String : Number)(input);
      }
      var VariationConfiguration = class {
        constructor(experiments, externalStorage) {
          _defineProperty(this, "experiments", void 0);
          _defineProperty(this, "storage", void 0);
          _defineProperty(this, "getAssociatedVariationId", (visitorCode, experimentId) => {
            const experiment = this.experiments.find((experiment2) => experiment2.id === String(experimentId));
            if (!experiment) {
              return (0, _tsRes.Err)(new _kameleoonError.KameleoonError(_kameleoonError.KameleoonException.ExperimentConfigurationNotFound, experimentId, visitorCode));
            }
            return this.assignVariation(visitorCode, experiment);
          });
          this.experiments = experiments;
          this.storage = externalStorage;
        }
        getAssignedVariations(visitorCode) {
          const result = this.storage.read();
          if (!result.ok) {
            return result;
          }
          const experiments = result.data[visitorCode];
          if (!experiments) {
            return (0, _tsRes.Err)(new _kameleoonError.KameleoonError(_kameleoonError.KameleoonException.StorageRead, visitorCode));
          }
          return (0, _tsRes.Ok)(experiments);
        }
        getFeatureFlagVariation({
          visitorCode,
          featureFlag,
          targetingData,
          withAssignment = false
        }) {
          const validateResult = _utilities.Utilities.validateVisitorCode(visitorCode);
          if (!validateResult.ok) {
            return (0, _tsRes.Err)(validateResult.error);
          }
          const {
            rules,
            featureKey,
            id: featureFlagId,
            defaultVariationKey
          } = featureFlag;
          for (const rule of rules) {
            const {
              segment,
              experimentId,
              id,
              exposition,
              respoolTime,
              variationByExposition
            } = rule;
            const targetingResult = _utilities.Utilities.checkTargeting({
              segment,
              visitorCode,
              experimentId,
              targetingData,
              variationConfiguration: this
            });
            if (!targetingResult.ok) {
              return targetingResult;
            }
            if (!targetingResult.data) {
              continue;
            }
            const ruleHash = _hasher.Hasher.obtainFeatureFlagHashDouble({
              visitorCode,
              respoolTime,
              campaignId: String(id)
            });
            if (ruleHash <= exposition) {
              let totalDeviation = 0;
              const variationHash = _hasher.Hasher.obtainFeatureFlagHashDouble({
                visitorCode,
                respoolTime,
                campaignId: String(experimentId)
              });
              for (const variation of variationByExposition) {
                totalDeviation += variation.exposition;
                if (variationHash <= totalDeviation) {
                  if (rule.type === _types.RuleType.EXPERIMENTATION && withAssignment) {
                    this.updateStorageData({
                      visitorCode,
                      experimentId: String(experimentId),
                      // --- Note ---
                      // For `RuleType.EXPERIMENTATION` `variationId` can not be null
                      variationId: variation.variationId
                    });
                  }
                  const {
                    exposition: exposition2
                  } = variation, restParameters = _objectWithoutProperties(variation, _excluded);
                  return (0, _tsRes.Ok)(_objectSpread(_objectSpread({}, restParameters), {}, {
                    rule,
                    featureFlagId,
                    featureKey,
                    experimentId
                  }));
                }
              }
            }
            if (rule.type === _types.RuleType.TARGETED_DELIVERY) {
              break;
            }
          }
          return (0, _tsRes.Ok)({
            featureKey,
            featureFlagId,
            experimentId: null,
            variationKey: defaultVariationKey,
            variationId: null,
            rule: null
          });
        }
        getExperimentVariation(visitorCode, experiment) {
          const {
            id,
            respoolTime,
            deviations
          } = experiment;
          const hashDouble = _hasher.Hasher.obtainExperimentHashDouble({
            visitorCode,
            campaignId: id,
            respoolTime
          });
          let isUnallocated = true;
          let totalDeviation = 0;
          let resultVariationId = 0;
          for (const deviation of deviations) {
            totalDeviation += deviation.value;
            if (totalDeviation >= hashDouble) {
              isUnallocated = false;
              if (deviation.variationId !== "origin") {
                resultVariationId = Number(deviation.variationId);
              }
              break;
            }
          }
          if (isUnallocated) {
            return (0, _tsRes.Err)(new _kameleoonError.KameleoonError(_kameleoonError.KameleoonException.NotAllocated, visitorCode));
          }
          return (0, _tsRes.Ok)(resultVariationId);
        }
        assignVariation(visitorCode, experiment) {
          const variationResult = this.getExperimentVariation(visitorCode, experiment);
          if (!variationResult.ok) {
            return variationResult;
          }
          const result = this.updateStorageData({
            visitorCode,
            experimentId: experiment.id,
            variationId: variationResult.data
          });
          if (!result.ok) {
            return result;
          }
          return (0, _tsRes.Ok)(variationResult.data);
        }
        updateStorageData({
          visitorCode,
          experimentId,
          variationId
        }) {
          const result = this.storage.read();
          if (!result.ok) {
            if (result.error.type === _kameleoonError.KameleoonException.StorageParse) {
              return result;
            }
          }
          const updatedVariationData = result.ok ? result.data : {};
          const updatedVariation = {
            variationId,
            assignmentDate: (/* @__PURE__ */ new Date()).toString()
          };
          if (updatedVariationData[visitorCode]) {
            updatedVariationData[visitorCode][experimentId] = updatedVariation;
          } else {
            updatedVariationData[visitorCode] = {
              [experimentId]: updatedVariation
            };
          }
          return this.storage.write(updatedVariationData);
        }
        // --- TODO: commented out in case of future logic rework ---
        // --- Mind: `variationId` could cause the `undefined` issue ---
        // --- Reference: https://development.kameleoon.net/sdk/javascript-sdk-packages/-/merge_requests/89 ---
        // private getAssignedRuleVariation(
        //   visitorCode: string,
        //   rule: RuleItemType,
        // ): Result<GetAssignedRuleVariationResultType, KameleoonError> {
        //   const emptyVariation: Omit<VariationByExpositionType, 'exposition'> = {
        //     variationId: null,
        //     variationKey: '',
        //   };
        //   const { experimentId, variationByExposition } = rule;
        //   const variationsResult = this.getAssignedVariations(visitorCode);
        //   // --- Note ---
        //   // If there is an error, we just want to skip seeking
        //   // for variation in the storage, not throw an error
        //   if (!variationsResult.ok) {
        //     return Ok(emptyVariation);
        //   }
        //   const variations = variationsResult.data;
        //   if (
        //     experimentId &&
        //     typeof variations[experimentId].variationId !== undefined
        //   ) {
        //     const id = variations[experimentId].variationId;
        //     const featureFlagVariation = variationByExposition.find(
        //       (item) => item.variationId == id,
        //     );
        //     if (!featureFlagVariation) {
        //       // --- Note ---
        //       // This error is not described for public methods as
        //       // it serves internal purpose of checking whether
        //       // the persistent variation has been updated and should be re-allocated
        //       return Err(new KameleoonError(KameleoonException.DataInconsistency));
        //     }
        //     const { exposition, ...restParameters } = featureFlagVariation;
        //     return Ok({ ...restParameters });
        //   }
        //   return Ok(emptyVariation);
        // }
      };
      exports.VariationConfiguration = VariationConfiguration;
    }
  });

  // node_modules/@kameleoon/javascript-sdk-core/dist/variationConfiguration/types.js
  var require_types12 = __commonJS({
    "node_modules/@kameleoon/javascript-sdk-core/dist/variationConfiguration/types.js"(exports) {
      "use strict";
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
    }
  });

  // node_modules/@kameleoon/javascript-sdk-core/dist/variationConfiguration/index.js
  var require_variationConfiguration2 = __commonJS({
    "node_modules/@kameleoon/javascript-sdk-core/dist/variationConfiguration/index.js"(exports) {
      "use strict";
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      Object.defineProperty(exports, "FeatureFlagVariationType", {
        enumerable: true,
        get: function() {
          return _types.FeatureFlagVariationType;
        }
      });
      Object.defineProperty(exports, "VariationConfiguration", {
        enumerable: true,
        get: function() {
          return _variationConfiguration.VariationConfiguration;
        }
      });
      Object.defineProperty(exports, "VariationType", {
        enumerable: true,
        get: function() {
          return _types.VariationType;
        }
      });
      var _variationConfiguration = require_variationConfiguration();
      var _types = require_types12();
    }
  });

  // node_modules/@kameleoon/javascript-sdk-core/dist/kameleoonClient.js
  var require_kameleoonClient = __commonJS({
    "node_modules/@kameleoon/javascript-sdk-core/dist/kameleoonClient.js"(exports) {
      "use strict";
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.KameleoonClient = void 0;
      var _tsRes = require_build();
      var _cacheManager = require_cacheManager2();
      var _campaignConfiguration = require_campaignConfiguration2();
      var _clientSettings = require_clientSettings2();
      var _constants = require_constants6();
      var _kameleoonData = require_kameleoonData();
      var _kameleoonError = require_kameleoonError2();
      var _requester = require_requester2();
      var _storage = require_storage();
      var _externalStorage = require_externalStorage();
      var _utilities = require_utilities2();
      var _variationConfiguration = require_variationConfiguration2();
      function ownKeys(object, enumerableOnly) {
        var keys = Object.keys(object);
        if (Object.getOwnPropertySymbols) {
          var symbols = Object.getOwnPropertySymbols(object);
          enumerableOnly && (symbols = symbols.filter(function(sym) {
            return Object.getOwnPropertyDescriptor(object, sym).enumerable;
          })), keys.push.apply(keys, symbols);
        }
        return keys;
      }
      function _objectSpread(target) {
        for (var i = 1; i < arguments.length; i++) {
          var source = null != arguments[i] ? arguments[i] : {};
          i % 2 ? ownKeys(Object(source), true).forEach(function(key) {
            _defineProperty(target, key, source[key]);
          }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function(key) {
            Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
          });
        }
        return target;
      }
      function _defineProperty(obj, key, value) {
        key = _toPropertyKey(key);
        if (key in obj) {
          Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
        } else {
          obj[key] = value;
        }
        return obj;
      }
      function _toPropertyKey(arg) {
        var key = _toPrimitive(arg, "string");
        return typeof key === "symbol" ? key : String(key);
      }
      function _toPrimitive(input, hint) {
        if (typeof input !== "object" || input === null)
          return input;
        var prim = input[Symbol.toPrimitive];
        if (prim !== void 0) {
          var res = prim.call(input, hint || "default");
          if (typeof res !== "object")
            return res;
          throw new TypeError("@@toPrimitive must return a primitive value.");
        }
        return (hint === "string" ? String : Number)(input);
      }
      var KameleoonClient = class {
        /**
         * @param {SDKCoreParameters} sdkCoreParameters - parameters for initializing sdk core
         */
        constructor({
          siteCode,
          configuration,
          internalConfiguration
        }) {
          _defineProperty(this, "variationConfiguration", void 0);
          _defineProperty(this, "campaignConfiguration", void 0);
          _defineProperty(this, "variationDataStorage", void 0);
          _defineProperty(this, "trackingCache", void 0);
          _defineProperty(this, "requester", void 0);
          _defineProperty(this, "externalEventSource", void 0);
          const {
            settings: clientSettings
          } = new _clientSettings.ClientSettings(siteCode, configuration);
          const {
            externalStorage,
            externalEventSource,
            externalPackageInfo,
            externalRequestDispatcher,
            externalClientConfiguration
          } = internalConfiguration;
          const requester = new _requester.Requester({
            siteCode,
            environment: clientSettings.environment,
            packageInfo: externalPackageInfo,
            requestDispatcher: externalRequestDispatcher
          });
          const trackingCache = new _cacheManager.CacheManager(_constants.CACHE_CLEANUP_TIMEOUT);
          const clientDataStorage = new _externalStorage.ExternalStorage(externalStorage.initialize(_storage.KameleoonStorageKey.ClientData));
          const variationDataStorage = new _externalStorage.ExternalStorage(externalStorage.initialize(_storage.KameleoonStorageKey.VariationData));
          const campaignConfiguration = new _campaignConfiguration.CampaignConfiguration({
            settings: clientSettings,
            storage: clientDataStorage,
            requester,
            externalClientConfiguration,
            targetingCleanupInterval: configuration?.targetingDataCleanupInterval
          });
          this.requester = requester;
          this.trackingCache = trackingCache;
          this.campaignConfiguration = campaignConfiguration;
          this.variationDataStorage = variationDataStorage;
          this.externalEventSource = externalEventSource;
        }
        async initialize(useCache) {
          const result = await this.campaignConfiguration.initialize(this.externalEventSource, useCache);
          result.throw();
          const variationConfiguration = new _variationConfiguration.VariationConfiguration(this.campaignConfiguration.experiments, this.variationDataStorage);
          this.variationConfiguration = variationConfiguration;
          return result.ok;
        }
        addData(visitorCode, ...data) {
          _utilities.Utilities.validateVisitorCode(visitorCode).throw();
          if (!this.campaignConfiguration) {
            throw new _kameleoonError.KameleoonError(_kameleoonError.KameleoonException.Initialization);
          }
          this.campaignConfiguration.addTargetingData(visitorCode, ...data).throw();
        }
        async getRemoteVisitorData(visitorCode, shouldAddData = true) {
          const result = await this.requester.getVisitorData(visitorCode);
          const data = result.throw();
          const visitorData = _utilities.Utilities.parseVisitorData(data);
          if (shouldAddData) {
            for (const item of visitorData) {
              this.addData(visitorCode, item);
            }
          }
          return visitorData;
        }
        triggerExperiment(visitorCode, experimentId) {
          _utilities.Utilities.validateVisitorCode(visitorCode).throw();
          if (!this.campaignConfiguration || !this.variationConfiguration) {
            throw new _kameleoonError.KameleoonError(_kameleoonError.KameleoonException.Initialization);
          }
          const experiment = this.campaignConfiguration.experiments.find((item) => item.id === String(experimentId));
          if (!experiment) {
            throw new _kameleoonError.KameleoonError(_kameleoonError.KameleoonException.ExperimentConfigurationNotFound, experimentId, visitorCode);
          }
          const userAgent = _utilities.Utilities.getUserAgent(visitorCode, this.campaignConfiguration);
          const dataUrl = _utilities.Utilities.getDataUrl(visitorCode, this.campaignConfiguration);
          const targetingData = this.campaignConfiguration.storedTargetingData[visitorCode];
          const trackingParameters = {
            body: dataUrl,
            visitorCode,
            experimentId
          };
          let variationId = _constants.UNALLOCATED_VARIATION_ID;
          const targetingResult = _utilities.Utilities.checkTargeting({
            visitorCode,
            experimentId,
            targetingData,
            segment: experiment.segment,
            variationConfiguration: this.variationConfiguration
          }).throw();
          variationId = this.variationConfiguration.getAssociatedVariationId(visitorCode, experimentId).else((error) => {
            if (error.type === _kameleoonError.KameleoonException.NotAllocated) {
              this.requester.trackExperiment(_objectSpread({
                isUnallocated: true,
                variationId,
                userAgent
              }, trackingParameters));
              return _constants.UNALLOCATED_VARIATION_ID;
            }
            throw error;
          });
          this.requester.trackExperiment(_objectSpread({
            variationId,
            isUnallocated: false,
            userAgent
          }, trackingParameters));
          if (!targetingResult) {
            throw new _kameleoonError.KameleoonError(_kameleoonError.KameleoonException.NotTargeted, visitorCode);
          }
          _utilities.Utilities.updateCache({
            cacheManager: this.trackingCache,
            visitorCode,
            experimentId,
            variationId
          });
          return variationId;
        }
        trackConversion({
          visitorCode,
          goalId,
          revenue
        }) {
          this.addData(visitorCode, new _kameleoonData.Conversion({
            goalId,
            revenue
          }));
          this.flushData(visitorCode);
        }
        flushData(visitorCode) {
          if (!this.campaignConfiguration) {
            throw new _kameleoonError.KameleoonError(_kameleoonError.KameleoonException.Initialization);
          }
          const dataUrl = _utilities.Utilities.getDataUrl(visitorCode, this.campaignConfiguration);
          const userAgent = _utilities.Utilities.getUserAgent(visitorCode, this.campaignConfiguration);
          this.requester.trackData({
            visitorCode,
            body: dataUrl,
            userAgent
          });
        }
        getExperiments() {
          if (!this.campaignConfiguration) {
            throw new _kameleoonError.KameleoonError(_kameleoonError.KameleoonException.Initialization);
          }
          return this.campaignConfiguration.experiments.map(({
            id,
            name
          }) => ({
            id: Number(id),
            name
          }));
        }
        getVisitorExperiments(visitorCode, isActive = true) {
          if (!this.variationConfiguration || !this.campaignConfiguration) {
            throw new _kameleoonError.KameleoonError(_kameleoonError.KameleoonException.Initialization);
          }
          _utilities.Utilities.validateVisitorCode(visitorCode).throw();
          const experiments = this.campaignConfiguration.experiments;
          const result = [];
          const targetingData = this.campaignConfiguration.storedTargetingData[visitorCode];
          for (const experiment of experiments) {
            const {
              id,
              name,
              segment
            } = experiment;
            const targetingResult = _utilities.Utilities.checkTargeting({
              targetingData,
              visitorCode,
              segment,
              variationConfiguration: this.variationConfiguration,
              experimentId: Number(id)
            }).throw();
            if (!targetingResult) {
              continue;
            }
            if (!isActive) {
              result.push({
                id: Number(id),
                name
              });
              continue;
            }
            const experimentVariations = this.variationConfiguration.getAssignedVariations(visitorCode);
            if (experimentVariations.ok) {
              const experimentVariation = experimentVariations.data[experiment.id];
              if (experimentVariation) {
                result.push({
                  id: Number(id),
                  name
                });
                continue;
              }
            }
            const variationResult = this.variationConfiguration.getExperimentVariation(visitorCode, experiment);
            if (variationResult.ok) {
              result.push({
                id: Number(id),
                name
              });
            }
          }
          return result;
        }
        getExperimentVariationData(variationId) {
          if (!this.campaignConfiguration) {
            throw new _kameleoonError.KameleoonError(_kameleoonError.KameleoonException.Initialization);
          }
          const experiments = this.campaignConfiguration.experiments;
          for (const experiment of experiments) {
            const variation = experiment.variations.find((item) => item.id === String(variationId));
            if (variation) {
              try {
                return JSON.parse(variation.customJson);
              } catch (err) {
                throw new _kameleoonError.KameleoonError(_kameleoonError.KameleoonException.JSONParse, err);
              }
            }
          }
          throw new _kameleoonError.KameleoonError(_kameleoonError.KameleoonException.VariationNotFound);
        }
        getFeatureFlags() {
          if (!this.campaignConfiguration) {
            throw new _kameleoonError.KameleoonError(_kameleoonError.KameleoonException.Initialization);
          }
          return this.campaignConfiguration.featureFlags.map(({
            id,
            featureKey
          }) => ({
            id,
            key: featureKey
          }));
        }
        getVisitorFeatureFlags(visitorCode) {
          if (!this.variationConfiguration || !this.campaignConfiguration) {
            throw new _kameleoonError.KameleoonError(_kameleoonError.KameleoonException.Initialization);
          }
          const featureFlags = this.campaignConfiguration.featureFlags;
          const resultFeatureFlags = [];
          const targetingData = this.campaignConfiguration.storedTargetingData[visitorCode];
          for (const featureFlag of featureFlags) {
            const variationData = this.variationConfiguration.getFeatureFlagVariation({
              visitorCode,
              targetingData,
              featureFlag
            }).throw();
            if (variationData.variationKey !== _constants.OFF_VARIATION_KEY) {
              const {
                featureFlagId,
                featureKey
              } = variationData;
              resultFeatureFlags.push({
                id: featureFlagId,
                key: featureKey
              });
            }
          }
          return resultFeatureFlags;
        }
        getFeatureFlagVariationKey(visitorCode, featureKey) {
          const {
            variationKey
          } = this._getFeatureFlagVariation(visitorCode, featureKey).throw();
          return variationKey;
        }
        getFeatureFlagVariable({
          visitorCode,
          featureKey,
          variableKey
        }) {
          const {
            variationKey
          } = this._getFeatureFlagVariation(visitorCode, featureKey).throw();
          const featureFlags = this.campaignConfiguration.featureFlags;
          const featureFlag = featureFlags.find((item) => item.featureKey === featureKey);
          if (!featureFlag) {
            throw new _kameleoonError.KameleoonError(_kameleoonError.KameleoonException.FeatureFlagConfigurationNotFound, featureKey, visitorCode);
          }
          const variable = featureFlag.variations.find((item) => item.key === variationKey)?.variables.find((item) => item.key === variableKey);
          if (!variable) {
            throw new _kameleoonError.KameleoonError(_kameleoonError.KameleoonException.FeatureFlagVariableNotFound, variableKey, visitorCode);
          }
          const featureVariable = _utilities.Utilities.parseFeatureVariable(variable).throw();
          return featureVariable;
        }
        isFeatureFlagActive(visitorCode, featureKey) {
          const variationKey = this.getFeatureFlagVariationKey(visitorCode, featureKey);
          return variationKey !== _constants.OFF_VARIATION_KEY;
        }
        async getRemoteData(key) {
          const remoteData = await this.requester.getRemoteData(key);
          return remoteData.throw();
        }
        onConfigurationUpdate(callback) {
          if (!this.campaignConfiguration) {
            throw new _kameleoonError.KameleoonError(_kameleoonError.KameleoonException.Initialization);
          }
          this.campaignConfiguration.onConfigurationUpdate(callback);
        }
        getEngineTrackingCode(visitorCode) {
          return _utilities.Utilities.getTrackingCode(this.trackingCache, visitorCode);
        }
        _getFeatureFlagVariation(visitorCode, featureKey) {
          if (!this.variationConfiguration || !this.campaignConfiguration) {
            return (0, _tsRes.Err)(new _kameleoonError.KameleoonError(_kameleoonError.KameleoonException.Initialization));
          }
          const featureFlags = this.campaignConfiguration.featureFlags;
          const featureFlag = featureFlags.find((item) => item.featureKey === featureKey);
          if (!featureFlag) {
            return (0, _tsRes.Err)(new _kameleoonError.KameleoonError(_kameleoonError.KameleoonException.FeatureFlagConfigurationNotFound, featureKey, visitorCode));
          }
          const targetingData = this.campaignConfiguration.storedTargetingData[visitorCode];
          const variationData = this.variationConfiguration.getFeatureFlagVariation({
            visitorCode,
            featureFlag,
            targetingData,
            withAssignment: true
          }).throw();
          const {
            experimentId,
            variationId
          } = variationData;
          if (typeof variationId === "number" && typeof experimentId === "number") {
            _utilities.Utilities.updateCache({
              cacheManager: this.trackingCache,
              visitorCode,
              experimentId,
              variationId
            });
          }
          const userAgent = _utilities.Utilities.getUserAgent(visitorCode, this.campaignConfiguration);
          _utilities.Utilities.trackRule({
            visitorCode,
            requester: this.requester,
            featureFlagVariation: variationData,
            campaignConfiguration: this.campaignConfiguration,
            userAgent
          });
          return (0, _tsRes.Ok)(variationData);
        }
      };
      exports.KameleoonClient = KameleoonClient;
    }
  });

  // node_modules/@kameleoon/javascript-sdk-core/dist/kameleoonUtils.js
  var require_kameleoonUtils = __commonJS({
    "node_modules/@kameleoon/javascript-sdk-core/dist/kameleoonUtils.js"(exports) {
      "use strict";
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.KameleoonUtils = void 0;
      var _tsRes = require_build();
      var _constants = require_constants6();
      var KameleoonUtils = class {
        generateRandomString(length) {
          const characters = "abcdefghijklmnopqrstuvwxyz0123456789";
          let randomString = "";
          if (length < 0) {
            return randomString;
          }
          for (let i = 0; i < length; i++) {
            randomString += characters[Math.floor(Math.random() * characters.length)];
          }
          return randomString;
        }
        getCookieVisitorCode(cookie) {
          const pairs = cookie.split(_constants.Cookie.PairsDelimiter);
          const pair = pairs.find((pair2) => {
            const [key, _] = pair2.split(_constants.Cookie.KeyValueDelimiter);
            return key === _constants.KAMELEOON_COOKIE_KEY;
          });
          if (pair) {
            const [_, value] = pair.split(_constants.Cookie.KeyValueDelimiter);
            return (0, _tsRes.Ok)(value);
          }
          return (0, _tsRes.Err)();
        }
        getResultCookie({
          domain,
          visitorCode
        }) {
          const yearSeconds = 60 * 60 * 24 * 365;
          const cookieArray = [_constants.KAMELEOON_COOKIE_KEY + _constants.Cookie.KeyValueDelimiter + visitorCode, _constants.Cookie.MaxAge + _constants.Cookie.KeyValueDelimiter + yearSeconds, _constants.Cookie.Path + _constants.Cookie.KeyValueDelimiter + "/", _constants.Cookie.Domain + _constants.Cookie.KeyValueDelimiter + domain];
          return cookieArray.join(_constants.Cookie.PairsDelimiter);
        }
      };
      exports.KameleoonUtils = KameleoonUtils;
    }
  });

  // node_modules/@kameleoon/javascript-sdk-core/dist/index.js
  var require_dist = __commonJS({
    "node_modules/@kameleoon/javascript-sdk-core/dist/index.js"(exports) {
      "use strict";
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      Object.defineProperty(exports, "Browser", {
        enumerable: true,
        get: function() {
          return _kameleoonData.Browser;
        }
      });
      Object.defineProperty(exports, "BrowserType", {
        enumerable: true,
        get: function() {
          return _kameleoonData.BrowserType;
        }
      });
      Object.defineProperty(exports, "CLEANUP_TARGETING_DATA_INTERVAL", {
        enumerable: true,
        get: function() {
          return _campaignConfiguration.CLEANUP_TARGETING_DATA_INTERVAL;
        }
      });
      Object.defineProperty(exports, "ClientGetVisitorCodeParametersType", {
        enumerable: true,
        get: function() {
          return _types.ClientGetVisitorCodeParametersType;
        }
      });
      Object.defineProperty(exports, "Conversion", {
        enumerable: true,
        get: function() {
          return _kameleoonData.Conversion;
        }
      });
      Object.defineProperty(exports, "ConversionParametersType", {
        enumerable: true,
        get: function() {
          return _kameleoonData.ConversionParametersType;
        }
      });
      Object.defineProperty(exports, "Cookie", {
        enumerable: true,
        get: function() {
          return _constants.Cookie;
        }
      });
      Object.defineProperty(exports, "CustomData", {
        enumerable: true,
        get: function() {
          return _kameleoonData.CustomData;
        }
      });
      Object.defineProperty(exports, "Device", {
        enumerable: true,
        get: function() {
          return _kameleoonData.Device;
        }
      });
      Object.defineProperty(exports, "DeviceType", {
        enumerable: true,
        get: function() {
          return _kameleoonData.DeviceType;
        }
      });
      Object.defineProperty(exports, "Environment", {
        enumerable: true,
        get: function() {
          return _types.Environment;
        }
      });
      Object.defineProperty(exports, "Err", {
        enumerable: true,
        get: function() {
          return _tsRes.Err;
        }
      });
      Object.defineProperty(exports, "EventSourceOpenParametersType", {
        enumerable: true,
        get: function() {
          return _eventSource.EventSourceOpenParametersType;
        }
      });
      Object.defineProperty(exports, "ExperimentType", {
        enumerable: true,
        get: function() {
          return _types.ExperimentType;
        }
      });
      Object.defineProperty(exports, "ExternalPackageInfoType", {
        enumerable: true,
        get: function() {
          return _types.ExternalPackageInfoType;
        }
      });
      Object.defineProperty(exports, "FeatureFlagType", {
        enumerable: true,
        get: function() {
          return _types.FeatureFlagType;
        }
      });
      Object.defineProperty(exports, "FeatureVariableResultType", {
        enumerable: true,
        get: function() {
          return _types.FeatureVariableResultType;
        }
      });
      Object.defineProperty(exports, "GetClientConfigurationResultType", {
        enumerable: true,
        get: function() {
          return _requester.GetClientConfigurationResultType;
        }
      });
      Object.defineProperty(exports, "GetFeatureFlagVariableParamsType", {
        enumerable: true,
        get: function() {
          return _types.GetFeatureFlagVariableParamsType;
        }
      });
      Object.defineProperty(exports, "Header", {
        enumerable: true,
        get: function() {
          return _requester.Header;
        }
      });
      Object.defineProperty(exports, "HttpMethod", {
        enumerable: true,
        get: function() {
          return _requester.HttpMethod;
        }
      });
      Object.defineProperty(exports, "IExternalEventSource", {
        enumerable: true,
        get: function() {
          return _eventSource.IExternalEventSource;
        }
      });
      Object.defineProperty(exports, "IExternalEventSourceConstructor", {
        enumerable: true,
        get: function() {
          return _eventSource.IExternalEventSourceConstructor;
        }
      });
      Object.defineProperty(exports, "IExternalRequestDispatcher", {
        enumerable: true,
        get: function() {
          return _requester.IExternalRequestDispatcher;
        }
      });
      Object.defineProperty(exports, "IExternalStorage", {
        enumerable: true,
        get: function() {
          return _storage.IExternalStorage;
        }
      });
      Object.defineProperty(exports, "IExternalStorageConstructor", {
        enumerable: true,
        get: function() {
          return _storage.IExternalStorageConstructor;
        }
      });
      Object.defineProperty(exports, "IKameleoonCore", {
        enumerable: true,
        get: function() {
          return _kameleoonClient.IKameleoonClient;
        }
      });
      Object.defineProperty(exports, "InternalSDKConfigurationType", {
        enumerable: true,
        get: function() {
          return _types.InternalSDKConfigurationType;
        }
      });
      Object.defineProperty(exports, "JSONType", {
        enumerable: true,
        get: function() {
          return _campaignConfiguration.JSONType;
        }
      });
      Object.defineProperty(exports, "KameleoonCore", {
        enumerable: true,
        get: function() {
          return _kameleoonClient.KameleoonClient;
        }
      });
      Object.defineProperty(exports, "KameleoonCoreUtils", {
        enumerable: true,
        get: function() {
          return _kameleoonUtils.KameleoonUtils;
        }
      });
      Object.defineProperty(exports, "KameleoonDataType", {
        enumerable: true,
        get: function() {
          return _kameleoonData.KameleoonDataType;
        }
      });
      Object.defineProperty(exports, "KameleoonError", {
        enumerable: true,
        get: function() {
          return _kameleoonError.KameleoonError;
        }
      });
      Object.defineProperty(exports, "KameleoonException", {
        enumerable: true,
        get: function() {
          return _kameleoonError.KameleoonException;
        }
      });
      Object.defineProperty(exports, "KameleoonStorageKey", {
        enumerable: true,
        get: function() {
          return _storage.KameleoonStorageKey;
        }
      });
      Object.defineProperty(exports, "MobileGetVisitorCodeParametersType", {
        enumerable: true,
        get: function() {
          return _types.MobileGetVisitorCodeParametersType;
        }
      });
      Object.defineProperty(exports, "Ok", {
        enumerable: true,
        get: function() {
          return _tsRes.Ok;
        }
      });
      Object.defineProperty(exports, "PageView", {
        enumerable: true,
        get: function() {
          return _kameleoonData.PageView;
        }
      });
      Object.defineProperty(exports, "PageViewParametersType", {
        enumerable: true,
        get: function() {
          return _kameleoonData.PageViewParametersType;
        }
      });
      Object.defineProperty(exports, "RealTimeEventType", {
        enumerable: true,
        get: function() {
          return _eventSource.RealTimeEventType;
        }
      });
      Object.defineProperty(exports, "Result", {
        enumerable: true,
        get: function() {
          return _tsRes.Result;
        }
      });
      Object.defineProperty(exports, "SDKConfigurationType", {
        enumerable: true,
        get: function() {
          return _types.SDKConfigurationType;
        }
      });
      Object.defineProperty(exports, "SDKCoreParameters", {
        enumerable: true,
        get: function() {
          return _types.SDKCoreParameters;
        }
      });
      Object.defineProperty(exports, "SDKType", {
        enumerable: true,
        get: function() {
          return _constants.SDKType;
        }
      });
      Object.defineProperty(exports, "ServerGetVisitorCodeParametersType", {
        enumerable: true,
        get: function() {
          return _types.ServerGetVisitorCodeParametersType;
        }
      });
      Object.defineProperty(exports, "TrackConversionParamsType", {
        enumerable: true,
        get: function() {
          return _types.TrackConversionParamsType;
        }
      });
      Object.defineProperty(exports, "TrackParametersType", {
        enumerable: true,
        get: function() {
          return _requester.TrackParametersType;
        }
      });
      Object.defineProperty(exports, "VISITOR_CODE_LENGTH", {
        enumerable: true,
        get: function() {
          return _constants.VISITOR_CODE_LENGTH;
        }
      });
      Object.defineProperty(exports, "VariableType", {
        enumerable: true,
        get: function() {
          return _types.VariableType;
        }
      });
      var _kameleoonClient = require_kameleoonClient();
      var _kameleoonUtils = require_kameleoonUtils();
      var _kameleoonError = require_kameleoonError2();
      var _storage = require_storage();
      var _constants = require_constants6();
      var _campaignConfiguration = require_campaignConfiguration2();
      var _tsRes = require_build();
      var _types = require_types();
      var _kameleoonData = require_kameleoonData();
      var _eventSource = require_eventSource();
      var _requester = require_requester2();
    }
  });

  // node_modules/@kameleoon/javascript-sdk/dist/constants.js
  var require_constants9 = __commonJS({
    "node_modules/@kameleoon/javascript-sdk/dist/constants.js"(exports) {
      "use strict";
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.NUMBER_OF_RETRIES = exports.DELAY_MILLISECONDS = void 0;
      var NUMBER_OF_RETRIES = 3;
      exports.NUMBER_OF_RETRIES = NUMBER_OF_RETRIES;
      var DELAY_MILLISECONDS = 2e3;
      exports.DELAY_MILLISECONDS = DELAY_MILLISECONDS;
    }
  });

  // node_modules/@kameleoon/javascript-sdk/dist/requester.js
  var require_requester3 = __commonJS({
    "node_modules/@kameleoon/javascript-sdk/dist/requester.js"(exports) {
      "use strict";
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.RequestDispatcher = void 0;
      var _javascriptSdkCore = require_dist();
      var _constants = require_constants9();
      var RequestDispatcher = class {
        async track({
          url,
          headers,
          body
        }) {
          const response = await fetch(url, {
            method: _javascriptSdkCore.HttpMethod.Post,
            headers,
            body
          });
          return response.ok;
        }
        async getClientConfiguration(url) {
          for (let i = 1; i <= _constants.NUMBER_OF_RETRIES; i++) {
            try {
              const response = await fetch(url, {
                method: _javascriptSdkCore.HttpMethod.Get
              });
              if (response.status !== 504) {
                return response.json();
              }
            } catch (err) {
              throw new _javascriptSdkCore.KameleoonError(_javascriptSdkCore.KameleoonException.ClientConfiguration);
            }
            if (i < _constants.NUMBER_OF_RETRIES) {
              await new Promise((resolve) => setTimeout(resolve, _constants.DELAY_MILLISECONDS));
            }
          }
          throw new _javascriptSdkCore.KameleoonError(_javascriptSdkCore.KameleoonException.MaximumRetriesReached);
        }
        async getRemoteData(url) {
          const response = await fetch(url, {
            method: _javascriptSdkCore.HttpMethod.Get
          });
          return response.json();
        }
      };
      exports.RequestDispatcher = RequestDispatcher;
    }
  });

  // node_modules/@kameleoon/javascript-sdk/dist/storage.js
  var require_storage2 = __commonJS({
    "node_modules/@kameleoon/javascript-sdk/dist/storage.js"(exports) {
      "use strict";
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.StorageConstructor = void 0;
      var _javascriptSdkCore = require_dist();
      function _defineProperty(obj, key, value) {
        key = _toPropertyKey(key);
        if (key in obj) {
          Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
        } else {
          obj[key] = value;
        }
        return obj;
      }
      function _toPropertyKey(arg) {
        var key = _toPrimitive(arg, "string");
        return typeof key === "symbol" ? key : String(key);
      }
      function _toPrimitive(input, hint) {
        if (typeof input !== "object" || input === null)
          return input;
        var prim = input[Symbol.toPrimitive];
        if (prim !== void 0) {
          var res = prim.call(input, hint || "default");
          if (typeof res !== "object")
            return res;
          throw new TypeError("@@toPrimitive must return a primitive value.");
        }
        return (hint === "string" ? String : Number)(input);
      }
      var StorageConstructor = class {
        initialize(key) {
          const storage = new Storage(key);
          return storage;
        }
      };
      exports.StorageConstructor = StorageConstructor;
      var Storage = class {
        constructor(key) {
          _defineProperty(this, "storageKey", void 0);
          this.storageKey = key;
        }
        get key() {
          return this.storageKey;
        }
        read() {
          const data = localStorage.getItem(this.storageKey);
          if (!data) {
            return (0, _javascriptSdkCore.Err)(new _javascriptSdkCore.KameleoonError(_javascriptSdkCore.KameleoonException.StorageRead, this.storageKey));
          }
          return (0, _javascriptSdkCore.Ok)(data);
        }
        write(data) {
          try {
            localStorage.setItem(this.storageKey, data);
            return (0, _javascriptSdkCore.Ok)();
          } catch (err) {
            return (0, _javascriptSdkCore.Err)(new _javascriptSdkCore.KameleoonError(_javascriptSdkCore.KameleoonException.StorageWrite, err));
          }
        }
      };
    }
  });

  // node_modules/@kameleoon/javascript-sdk/dist/eventSource.js
  var require_eventSource2 = __commonJS({
    "node_modules/@kameleoon/javascript-sdk/dist/eventSource.js"(exports) {
      "use strict";
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.EventSourceConstructor = void 0;
      function _defineProperty(obj, key, value) {
        key = _toPropertyKey(key);
        if (key in obj) {
          Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
        } else {
          obj[key] = value;
        }
        return obj;
      }
      function _toPropertyKey(arg) {
        var key = _toPrimitive(arg, "string");
        return typeof key === "symbol" ? key : String(key);
      }
      function _toPrimitive(input, hint) {
        if (typeof input !== "object" || input === null)
          return input;
        var prim = input[Symbol.toPrimitive];
        if (prim !== void 0) {
          var res = prim.call(input, hint || "default");
          if (typeof res !== "object")
            return res;
          throw new TypeError("@@toPrimitive must return a primitive value.");
        }
        return (hint === "string" ? String : Number)(input);
      }
      var EventSourceConstructor = class {
        initialize(url) {
          return new ExternalEventSource(url);
        }
      };
      exports.EventSourceConstructor = EventSourceConstructor;
      var ExternalEventSource = class {
        constructor(url) {
          _defineProperty(this, "eventSource", void 0);
          const eventSource = new EventSource(url);
          this.eventSource = eventSource;
        }
        open({
          siteCode,
          eventType,
          onEvent
        }) {
          this.eventSource.addEventListener(eventType, (message) => {
            const event = JSON.parse(message.data);
            const {
              siteCode: eventSiteCode,
              ts
            } = event;
            if (siteCode === eventSiteCode) {
              onEvent(ts);
            }
          });
        }
        close() {
          this.eventSource.close();
        }
      };
    }
  });

  // node_modules/@kameleoon/javascript-sdk/dist/kameleoonClient.js
  var require_kameleoonClient2 = __commonJS({
    "node_modules/@kameleoon/javascript-sdk/dist/kameleoonClient.js"(exports) {
      "use strict";
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.KameleoonClient = void 0;
      var _javascriptSdkCore = require_dist();
      var _requester = require_requester3();
      var _storage = require_storage2();
      var _eventSource = require_eventSource2();
      var KameleoonClient = class extends _javascriptSdkCore.KameleoonCore {
        constructor(siteCode, configuration) {
          const storage = new _storage.StorageConstructor();
          const eventSource = new _eventSource.EventSourceConstructor();
          const requestDispatcher = new _requester.RequestDispatcher();
          super({
            siteCode,
            configuration,
            internalConfiguration: {
              externalStorage: storage,
              externalEventSource: eventSource,
              externalRequestDispatcher: requestDispatcher,
              externalPackageInfo: {
                type: _javascriptSdkCore.SDKType.JavaScript,
                version: "1.4.4"
              }
            }
          });
        }
        /**
         * @method initialize - an asynchronous method for KameleoonClient initialization by fetching Kameleoon SDK related data from server or by retrieving data from local source if data is up-to-date or update interval has not been reached
         * @param {boolean | undefined} useCache - optional parameter for activating SDK offline mode, if `true` is passed failed polls will not return error and will use cached data if such data is available, default value is `false`. Note: if offline mode is on, SDK will still try to retrieve the latest data.
         * @returns {Promise<boolean>} Promise resolved into boolean field indicating success or fail
         * @throws `KameleoonError` with one of the following `type` s:
         *
         * - `KameleoonException.StorageWrite` Couldn't update storage data
         * - `KameleoonException.ClientConfiguration` Couldn't retrieve client configuration from Kameleoon Api
         * - `KameleoonException.MaximumRetriesReached` Maximum retries reached, request failed
         */
        async initialize(useCache) {
          return super.initialize(useCache);
        }
      };
      exports.KameleoonClient = KameleoonClient;
    }
  });

  // node_modules/@kameleoon/javascript-sdk/dist/kameleoonUtils.js
  var require_kameleoonUtils2 = __commonJS({
    "node_modules/@kameleoon/javascript-sdk/dist/kameleoonUtils.js"(exports) {
      "use strict";
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      exports.KameleoonUtils = void 0;
      var _javascriptSdkCore = require_dist();
      var KameleoonUtilsConstructor = class extends _javascriptSdkCore.KameleoonCoreUtils {
        getVisitorCode({
          domain,
          defaultVisitorCode
        }) {
          const cookie = document.cookie;
          const visitorCodeResult = this.getCookieVisitorCode(cookie);
          if (visitorCodeResult.ok && visitorCodeResult.data) {
            return visitorCodeResult.data;
          }
          const visitorCode = defaultVisitorCode || this.generateRandomString(_javascriptSdkCore.VISITOR_CODE_LENGTH);
          const resultCookie = this.getResultCookie({
            domain,
            visitorCode
          });
          resultCookie.split(_javascriptSdkCore.Cookie.PairsDelimiter).forEach((item) => {
            document.cookie = item;
          });
          return visitorCode;
        }
      };
      var KameleoonUtils = class {
        /**
         * @method getVisitorCode obtains visitor code from the browser cookie, if the visitor code doesn't yet exist generates a random visitor code (or uses a provided default) and sets a new visitor code to cookie
         * @param {string} domain domain which cookie belongs to
         * @param {string | undefined} defaultVisitorCode visitor code to be used in case there is no visitor code in cookies Note: if not passed visitor code will be randomly generated
         * @returns {string} result visitor code
         * */
        static getVisitorCode(domain, defaultVisitorCode) {
          const kameleoonUtilsConstructor = new KameleoonUtilsConstructor();
          return kameleoonUtilsConstructor.getVisitorCode({
            domain,
            defaultVisitorCode
          });
        }
      };
      exports.KameleoonUtils = KameleoonUtils;
    }
  });

  // node_modules/@kameleoon/javascript-sdk/dist/index.js
  var require_dist2 = __commonJS({
    "node_modules/@kameleoon/javascript-sdk/dist/index.js"(exports) {
      Object.defineProperty(exports, "__esModule", {
        value: true
      });
      var _exportNames = {
        KameleoonClient: true,
        KameleoonUtils: true
      };
      Object.defineProperty(exports, "KameleoonClient", {
        enumerable: true,
        get: function() {
          return _kameleoonClient.KameleoonClient;
        }
      });
      Object.defineProperty(exports, "KameleoonUtils", {
        enumerable: true,
        get: function() {
          return _kameleoonUtils.KameleoonUtils;
        }
      });
      var _javascriptSdkCore = require_dist();
      Object.keys(_javascriptSdkCore).forEach(function(key) {
        if (key === "default" || key === "__esModule")
          return;
        if (Object.prototype.hasOwnProperty.call(_exportNames, key))
          return;
        if (key in exports && exports[key] === _javascriptSdkCore[key])
          return;
        Object.defineProperty(exports, key, {
          enumerable: true,
          get: function() {
            return _javascriptSdkCore[key];
          }
        });
      });
      var _kameleoonClient = require_kameleoonClient2();
      var _kameleoonUtils = require_kameleoonUtils2();
    }
  });
  return require_dist2();
})();
/*! Bundled license information:

crypto-js/ripemd160.js:
  (** @preserve
  	(c) 2012 by Cédric Mesnil. All rights reserved.
  
  	Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
  
  	    - Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
  	    - Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
  
  	THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  	*)

crypto-js/mode-ctr-gladman.js:
  (** @preserve
   * Counter block mode compatible with  Dr Brian Gladman fileenc.c
   * derived from CryptoJS.mode.CTR
   * Jan Hruby jhruby.web@gmail.com
   *)
*/
